2020-07-26  Bruno Haible  <bruno@clisp.org>

	Update translations (from the TP).
	* gettext-runtime/po/*.po: Update.
	* gettext-tools/po/*.po: Update.
	* gettext-tools/examples/po/*.po: Update.
	* gettext-tools/examples/po/LINGUAS: Add 'nn'.
	* gettext-tools/examples/hello-*/po/LINGUAS: Likewise.
	* gettext-tools/examples/Makefile.am (EXAMPLESPOFILES): Add nn.po.

	Prepare for 0.21 release.
	* gettext-runtime/doc/matrix.texi: Update from TP.
	* gettext-runtime/doc/nls.texi (STATUS): Update.
	* gettext-runtime/intl/libgnuintl.in.h (LIBINTL_VERSION): Bump.
	* gettext-tools/libgettextpo/gettext-po.in.h (LIBGETTEXTPO_VERSION): Bump.
	* libtextstyle/version.sh: Update VERSION_NUMBER, RELEASE_DATE.
	* gettext-runtime/po/Makefile.in.in: Bump Origin version.
	* NEWS, libtextstyle/NEWS, gettext-runtime/NEWS: Update.
	* libtextstyle/lib/Makefile.am (LTV_*): Bump to 1:1:1.
	* gettext-runtime/intl/Makefile.am (LTV_*): Bump to 10:0:2.
	* gettext-tools/libgettextpo/Makefile.am (LTV_*): Bump to 5:7:5.
	* gettext-tools/configure.ac (ARCHIVE_VERSION): Bump to 0.21.
	* gettext-tools/misc/autopoint.in: Allow version 0.21.

	doc: Tweak libgettextpo chapter.
	* gettext-tools/doc/gettext.texi (libgettextpo): Very small tweaks.

	doc: Make function declarations easier to read.
	* gettext-tools/doc/gettext.texi: Inside the argument list of function
	declarations, use no-break spaces instead of spaces, except directly after
	a comma.

	doc: Canonicalize source.
	* gettext-tools/doc/gettext.texi: Prefer long lines to @<newline> breaks.

2020-07-26  Miguel Ángel Arruga Vivas  <rosen644835@gmail.com>

	doc: Add Checking API
	* gettext-tools/doc/gettext.texi (Checking API): New subsection.  Add
	po_file_check_all, po_message_check_all, and po_message_check_format
	documentation
	(libgettextpo): Add entry to the menu.

	doc: Update po_message_t API (VI)
	* gettext-tools/doc/gettext.texi (po_message_t API): Add previous
	message contents accessors po_message_prev_msgctxt,
	po_message_set_prev_msgctxt, po_message_prev_msgid,
	po_message_set_prev_msgid, po_message_prev_msgid_plural, and
	po_message_set_prev_msgid_plural documentation.

	doc: Add format type API
	* gettext-tools/doc/gettext.texi (Format Type API): New subsection.
	Add po_format_list and po_format_pretty_name documentation.

	doc: Update po_message_t API (V)
	* gettext-tools/doc/gettext.texi (po_message_t API): Update references
	to the variable from the function declaration.

	doc: Update po_message_t API (IV)
	* gettext-tools/doc/gettext.texi (po_message_t API): Add
	po_message_is_obsolete, po_message_set_obsolete, po_message_is_fuzzy,
	po_message_set_fuzzy, po_message_is_format, po_message_set_format,
	po_message_is_range, and po_message_set_range documentation.

	doc: Add po_filepos_t API
	* gettext-tools/doc/gettext.texi (po_filepos_t API): New
	subsection. Add po_message_filepos, po_message_remove_filepos, and
	po_message_add_filepos documentation.
	(libgettextpo): Add new subsection to the menu.

	doc: Add Header Entry API
	* gettext-tools/doc/gettext.texi (PO Header Entry API): New
	subsection.  Add po_file_domain_header, po_header_field and
	po_header_set_field documentation.
	(libgettextpo): Add subsection to the menu.

	doc: Update po_message_t API (III)
	* gettext-tools/doc/gettext.texi (po_message_t API): Add
	po_message_set_msgctxt, po_message_set_msgid,
	po_message_set_msgid_plural, po_message_set_msgstr,
	po_message_set_msgstr_plural, po_message_set_comments, and
	po_message_set_extracted_comments documentation.

	doc: Update po_message_t API (II)
	* gettext-tools/doc/gettext.texi (po_message_t API): Add
	po_message_msgctxt, po_message_comments, and
	po_message_extracted_comments documentation.

	doc: Update po_message_t API (I)
	* gettext-tools/doc/gettext.texi (po_message_t API): Add
	po_message_create documentation.

	doc: Update libgettextpo example
	* gettext-tools/doc/gettext.texi (libgettextpo): Update example to the
	latest API.

	doc: Move libgettextpo example to the front subsection.
	* gettext-tools/doc/gettext.texi (po_message_t API): Move example from
	here...
	(libgettextpo): ... back to here.

	doc: Split libgettextpo documentation into subsections
	* gettext-tools/doc/gettext.texi (libgettextpo): Add a menu and split
	the functions an types into separate subsections.
	(Error Handling): New subsection.
	(po_file_t API): New subsection
	(po_message_iterator_t API). New subsection.
	(po_message_t API): New subsection.

	doc: Add po_file_write documentation
	* gettext-tools/doc/gettext.texi (libgettextpo): Add po_file_write
	documentation.
	* gettext-tools/doc/gettext-po.in.h (po_file_write): Update comment.

	doc: Update po_file_read documentation
	* gettext-tools/doc/gettext.texi (libgettextpo): Update documentation
	from po_file_read to the version 3 of the implementation.
	* gettext-tools/libgettextpo/gettext-po.in.h (po_file_read): Update
	comment.

	doc: Add po_xerror_handler_t documentation
	* gettext-tools/doc/gettext.texi (libgettextpo): Add struct
	po_xerror_handler and its callbacks to the manual.

	doc: Add po_file_create documentation
	* gettext-tools/doc/gettext.texi (libgettextpo): Add po_file_create
	documentation.

2020-07-26  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* gettext-runtime/m4/intl.m4 (gt_INTL_SUBDIR_CORE): Don't require gt_INTTYPES_PRI.
	* gettext-runtime/m4/inttypes-pri.m4: Remove file.
	* gettext-runtime/m4/Makefile.am (EXTRA_DIST): Remove it.
	* Makefile.am (distcheck-hook): Don't compare inttypes-pri.m4.
	* gettext-runtime/m4/size_max.m4: Update from gnulib.

	Update to newest gnulib.

	Drop portability to AIX 4.
	* gettext-runtime/intl/loadmsgcat.c: Assume PRI_MACROS_BROKEN is not set.
	* gettext-tools/tests/format-c-3-prg.c: Likewise.
	* gettext-tools/tests/format-c-4-prg.c: Likewise.

2020-07-18  Bruno Haible  <bruno@clisp.org>

	msgmerge: Make --sort-by-file sort messages without file reference correctly.
	Reported by <wangqr@wangqr.tk> in <https://savannah.gnu.org/bugs/?58778>.

	* gettext-tools/src/write-catalog.c (cmp_by_filepos): When a->filepos_count and
	b->filepos_count are both 0, compare the msgid strings.
	* gettext-tools/tests/msgmerge-29: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2020-07-15  Bruno Haible  <bruno@clisp.org>

	build: Fix a "make install" failure in a VPATH build with OpenBSD 'make'.
	* gettext-tools/misc/Makefile.am: Assume that archive.dir.tar is in $(srcdir).

2020-07-08  Bruno Haible  <bruno@clisp.org>

	Fix a test failure on MSVC.
	* gettext-tools/tests/recode-sr-latin-1: Allow CRLF newlines in the output.

	Fix build error on mingw (regression from 2020-07-05).
	* autogen.sh (GNULIB_MODULES_LIBGETTEXTPO_OTHER): Add fdopen.

	Update to newest gnulib.

2020-07-06  Bruno Haible  <bruno@clisp.org>

	alloca-opt: Fix build error on AIX (regression from 2020-07-05).
	* gnulib-local/lib/alloca.in.h: Don't include <alloca.h>, since it would be a
	recursive include of the same file.

	Fix compilation error on AIX (regression from 2019-01-06).
	* gettext-runtime/intl/Makefile.am (localename-table.h): Fix insertion of
	export.h.

2020-07-06  Bruno Haible  <bruno@clisp.org>

	doc: Fix typo.
	Reported by Arun Isaac <arunisaac@systemreboot.net> in
	<https://lists.gnu.org/archive/html/bug-gettext/2020-07/msg00001.html>.

	* gettext-tools/doc/gettext.texi (Prioritizing messages): Fix a typo.

2020-07-06  Bruno Haible  <bruno@clisp.org>

	msgfmt: Supersede, not overwrite, the output file of type '.mo'.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC): Add 'supersede'.
	* gettext-tools/src/write-mo.c: Include supersede.h.
	(msgdomain_write_mo): When writing to a file, use fopen_supersede and
	fwriteerror_supersede.
	* NEWS: Mention the change.

2020-07-05  Bruno Haible  <bruno@clisp.org>

	Avoid possible future conflict with gnulib module 'dirname'.
	* gnulib-local/lib/basename.c: Remove file.
	* gnulib-local/lib/basename.h: Remove file.
	* gnulib-local/modules/basename: Remove file.
	* gnulib-local/Makefile.am (EXTRA_DIST): Remove them.
	* gnulib-local/lib/addext.c: Include basename-lgpl.h instead of basename.h.
	(addext): Invoke last_component instead of basename.
	* gnulib-local/lib/backupfile.c: Include basename-lgpl.h instead of basename.h.
	(find_backup_file_name): Invoke last_component instead of basename.
	* gnulib-local/modules/backupfile (Depends-on): Remove basename. Add
	basename-lgpl.
	* autogen.sh (GNULIB_MODULES_RUNTIME_FOR_SRC, GNULIB_MODULES_TOOLS_FOR_SRC,
	GNULIB_MODULES_LIBGETTEXTPO): Remove basename. Add basename-lgpl.
	* gettext-runtime/src/envsubst.c: Include basename-lgpl.h instead of basename.h.
	(main): Invoke last_component instead of basename.
	* gettext-runtime/src/gettext.c: Likewise.
	* gettext-runtime/src/ngettext.c: Likewise.
	* gettext-tools/src/cldr-plurals.c: Likewise.
	* gettext-tools/src/hostname.c: Likewise.
	* gettext-tools/src/msgattrib.c: Likewise.
	* gettext-tools/src/msgcat.c: Likewise.
	* gettext-tools/src/msgcmp.c: Likewise.
	* gettext-tools/src/msgcomm.c: Likewise.
	* gettext-tools/src/msgconv.c: Likewise.
	* gettext-tools/src/msgen.c: Likewise.
	* gettext-tools/src/msgexec.c: Likewise.
	* gettext-tools/src/msgfilter.c: Likewise.
	* gettext-tools/src/msgfmt.c: Likewise.
	* gettext-tools/src/msggrep.c: Likewise.
	* gettext-tools/src/msginit.c: Likewise.
	* gettext-tools/src/msgmerge.c: Likewise.
	* gettext-tools/src/msgunfmt.c: Likewise.
	* gettext-tools/src/msguniq.c: Likewise.
	* gettext-tools/src/urlget.c: Likewise.
	* gettext-tools/src/xgettext.c: Likewise.
	* gettext-tools/tests/tstgettext.c: Likewise.
	* gettext-tools/tests/tstngettext.c: Likewise. Include <string.h>.
	* gettext-tools/src/recode-sr-latin.c: Include basename-lgpl.h instead of
	basename.h.
	(main, process): Invoke last_component instead of basename.
	* gettext-tools/src/locating-rule.c: Include basename-lgpl.h instead of
	basename.h.
	(locating_rule_match): Invoke last_component instead of basename.
	* gettext-tools/src/msgl-cat.c: Include basename-lgpl.h instead of basename.h.
	(catenate_msgdomain_list): Invoke last_component instead of basename.
	* gettext-tools/src/msgl-charset.c: Include basename-lgpl.h instead of
	basename.h.
	(compare_po_locale_charsets): Invoke last_component instead of basename.
	* gettext-tools/src/msgl-iconv.c: Include basename-lgpl.h instead of basename.h.
	(iconv_message_list_internal): Invoke last_component instead of basename.
	* gettext-tools/src/po-charset.c: Include basename-lgpl.h instead of basename.h.
	(po_lex_charset_set): Invoke last_component instead of basename.
	* gettext-tools/src/x-python.c: Include basename-lgpl.h instead of basename.h.
	(set_current_file_source_encoding): Invoke last_component instead of basename.
	* gettext-tools/src/x-javascript.c: Don't include basename.h.

	Update after gnulib changed.
	* gnulib-local/lib/clean-temp.c.diff: Remove file.
	* gnulib-local/Makefile.am (EXTRA_DIST): Remove it.
	* gettext-tools/src/write-csharp.c (msgdomain_write_csharp): Update fopen_temp
	invocation.
	* gettext-tools/src/write-java.c (msgdomain_write_java): Likewise.

	Update to newest gnulib.

	gettext.h: Update from gnulib.
	* gnulib-local/lib/gettext.h: Disable use of VLAs if GNULIB_NO_VLA is defined.

	alloca-opt: Update from gnulib.
	* gnulib-local/lib/alloca.in.h: Update from gnulib.
	* gnulib-local/m4/alloca.m4: Remove file.
	* gnulib-local/Makefile.am (EXTRA_DIST): Remove it.

	Avoid possible future conflict with gnulib module 'hash'.
	* gnulib-local/lib/hash.c.diff: New file.
	* gnulib-local/lib/hash.h.diff: New file.
	* gnulib-local/Makefile.am (EXTRA_DIST): Add them.

	Remove some now unneeded gnulib-tool --avoid options.
	* autogen.sh: Remove some --avoid=*-tests options.
	* libtextstyle/autogen.sh: Likewise.

2020-07-04  Bruno Haible  <bruno@clisp.org>

	Avoid a module name and include file name collision with gnulib.
	* gnulib-local/lib/mem-hash-map.h: Renamed from gnulib-local/lib/hash.h.
	* gnulib-local/lib/mem-hash-map.c: Renamed from gnulib-local/lib/hash.c.
	Include mem-hash-map.h instead of hash.h.
	* gnulib-local/modules/mem-hash-map: Renamed from gnulib-local/modules/hash.
	Update.
	* gnulib-local/Makefile.am (EXTRA_DIST): Update.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC, GNULIB_MODULES_LIBGETTEXTPO):
	Update.
	* libtextstyle/gnulib-local/modules/term-styled-ostream (Depends-on): Likewise.
	* gettext-tools/src/its.c: Include mem-hash-map.h instead of hash.h.
	* gettext-tools/src/locating-rule.c: Likewise.
	* gettext-tools/src/message.c: Likewise.
	* gettext-tools/src/message.h: Likewise.
	* gettext-tools/src/read-desktop.h: Likewise.
	* gettext-tools/src/write-mo.c: Likewise.
	* gettext-tools/src/write-qt.c: Likewise.
	* gettext-tools/src/x-c.c: Likewise.
	* gettext-tools/src/x-csharp.c: Likewise.
	* gettext-tools/src/x-desktop.c: Likewise.
	* gettext-tools/src/x-elisp.c: Likewise.
	* gettext-tools/src/x-java.c: Likewise.
	* gettext-tools/src/x-librep.c: Likewise.
	* gettext-tools/src/x-lisp.c: Likewise.
	* gettext-tools/src/x-scheme.c: Likewise.
	* gettext-tools/src/x-sh.c: Likewise.
	* gettext-tools/src/x-tcl.c: Likewise.
	* gettext-tools/src/x-vala.c: Likewise.
	* gettext-tools/src/xg-arglist-callshape.h: Likewise.
	* gettext-tools/src/xg-arglist-context.h: Likewise.
	* libtextstyle/gnulib-local/lib/term-styled-ostream.oo.c: Likewise.

	Remove redundant code (redundant since 2008-10-19).
	* gnulib-local/modules/wait-process.diff: Remove file.
	* gnulib-local/m4/unionwait.m4: Remove file.
	* gnulib-local/Makefile.am (EXTRA_DIST): Remove them.

2020-07-03  Bruno Haible  <bruno@clisp.org>

	Remove redundant code.
	* gettext-tools/src/write-mo.c (msgdomain_write_mo): Remove a redundant test.
	* gettext-tools/src/write-qt.c (msgdomain_write_qt): Likewise.

2020-06-27  Bruno Haible  <bruno@clisp.org>

	Add comment.
	* gettext-tools/src/plural-eval.c (sigfpe_handler): Add comment.

	Update after gnulib changed.
	* gnulib-local/modules/fnmatch.diff: Remove file.
	* gnulib-local/lib/fnmatch.c.diff: Remove file.
	* gnulib-local/lib/fnmatch_loop.c.diff: Remove file.
	* gnulib-local/Makefile.am (EXTRA_DIST): Remove them.
	* gettext-tools/src/read-properties.c (properties_parse): Update the fread_file
	invocation.
	* gettext-tools/po/POTFILES.in: Remove gnulib-lib/copy-acl.c,
	gnulib-lib/set-acl.c.
	* gettext-runtime/intl/localename.c: Update from gnulib.
	* gettext-runtime/intl/relocatable.c: Likewise.
	* gettext-runtime/intl/verify.h: Likewise.
	* gettext-runtime/intl/windows-rwlock.c: Likewise.

2020-06-26  Bruno Haible  <bruno@clisp.org>

	Update to newest gnulib.

2020-06-06  Bruno Haible  <bruno@clisp.org>

	FAQ: Update information about mailing lists.
	Reported by Vincent Lefèvre <vincent@vinc17.net> in
	<https://lists.gnu.org/archive/html/bug-gettext/2020-06/msg00003.html>.

	* gettext-tools/doc/FAQ.html: Don't mention bug-gnu-utils. Clarify what
	bug-gnu-gettext is.

2020-06-06  Bruno Haible  <bruno@clisp.org>

	msgunfmt: Detect more cases of invalid .mo files.
	* gettext-tools/src/read-mo.c: Include hash-string.h.
	(read_mo_file): Verify the array of messages and the hash table.
	* gettext-tools/src/write-mo.c (write_table): Fix typo in comment.
	* gettext-tools/src/Makefile.am (msgunfmt_SOURCES): Add hash-string.c.
	* gettext-tools/tests/overflow-7.mo: Renamed from
	gettext-tools/tests/sysdep-without-nul.mo.
	* gettext-tools/tests/sysdep-without-nul.mo: New file.
	* gettext-tools/tests/msgunfmt-3: Test also overflow-7.mo.
	* gettext-tools/tests/Makefile.am (EXTRA_DIST): Add overflow-7.mo.

2020-06-06  Bruno Haible  <bruno@clisp.org>

	po-mode: Fix syntax highlighting of comment lines with double-quotes.
	Reported by Vincent Lefèvre <vincent@vinc17.net> in
	<https://lists.gnu.org/archive/html/bug-gettext/2020-06/msg00000.html>.

	* gettext-tools/emacs/po-mode.el (po-mode-version-string): Bump.
	(po-font-lock-keywords): Move the rules that recognize comments to the
	beginning.

2020-05-10  Bruno Haible  <bruno@clisp.org>

	Reorder list of programming languages.
	* gettext-tools/src/format.h: Reorder declarations.
	* gettext-tools/src/format.c (formatstring_parsers): Reorder entries.
	* gettext-tools/src/message.h (enum format_type): Reorder items.
	* gettext-tools/src/message.c (format_language, format_language_pretty): Reorder
	entries.
	* gettext-tools/src/xgettext.c: Reorder includes.
	(flag_table_*): Reorder declarations.
	(main): Reorder init_flag_table_* invocations.
	(xgettext_record_flag): Reorder switch statement.
	(language_to_extractor, extension_to_language): Reorder table entries.
	* gettext-tools/src/format-smalltalk.c: Renamed from
	gettext-tools/src/format-ycp.c.
	* gettext-tools/src/FILES: Update.
	* gettext-tools/src/Makefile.am (noinst_HEADERS, FORMAT_SOURCE,
	xgettext_SOURCES): Update.
	* gettext-tools/po/POTFILES.in: Update.
	* gettext-tools/libgettextpo/Makefile.am (libgettextpo_la_AUXSOURCES): Update.
	* gettext-tools/tests/Makefile.am (TESTS): Reorder.

	i18n: Update list of files.
	* gettext-tools/po/POTFILES.in: Add missing files.

	doc: Reorder list of programming languages.
	* gettext-tools/doc/lang-c.texi: New file, extracted from
	gettext-tools/doc/gettext.texi.
	* gettext-tools/doc/lang-python.texi: Likewise.
	* gettext-tools/doc/lang-java.texi: Likewise.
	* gettext-tools/doc/lang-csharp.texi: Likewise.
	* gettext-tools/doc/lang-javascript.texi: Likewise.
	* gettext-tools/doc/lang-scheme.texi: Likewise.
	* gettext-tools/doc/lang-lisp.texi: Likewise.
	* gettext-tools/doc/lang-clisp-c.texi: Likewise.
	* gettext-tools/doc/lang-elisp.texi: Likewise.
	* gettext-tools/doc/lang-librep.texi: Likewise.
	* gettext-tools/doc/lang-ruby.texi: Likewise.
	* gettext-tools/doc/lang-sh.texi: Likewise.
	* gettext-tools/doc/lang-bash.texi: Likewise.
	* gettext-tools/doc/lang-gawk.texi: Likewise.
	* gettext-tools/doc/lang-lua.texi: Likewise.
	* gettext-tools/doc/lang-pascal.texi: Likewise.
	* gettext-tools/doc/lang-smalltalk.texi: Likewise.
	* gettext-tools/doc/lang-vala.texi: Likewise.
	* gettext-tools/doc/lang-wxwidgets.texi: Likewise.
	* gettext-tools/doc/lang-tcl.texi: Likewise.
	* gettext-tools/doc/lang-perl.texi: Likewise.
	* gettext-tools/doc/lang-php.texi: Likewise.
	* gettext-tools/doc/lang-pike.texi: Likewise.
	* gettext-tools/doc/lang-gcc-source.texi: Likewise.
	* gettext-tools/doc/lang-ycp.texi: Likewise.
	* gettext-tools/doc/Makefile.am (gettext_TEXINFOS): Add them.
	* gettext-tools/doc/gettext.texi (List of Programming Languages): Reorder list
	of programming languages, approximately according to decreasing importance.
	(PO Files): Reorder list for format string markers accordingly.
	(Translators for other Languages): Likewise.

2020-05-10  Daiki Ueno  <ueno@gnu.org>

	xgettext: Warn if a fallback ITS file is used
	* src/xgettext.c (main): Warn if a fallback ITS file is used.
	Suggested by Will Thompson in:
	<https://savannah.gnu.org/bugs/?56455>.

2020-05-09  Bruno Haible  <bruno@clisp.org>

	Reduce explicit use of __attribute__.
	* gnulib-local/lib/xalloc.h: Include noreturn.h.
	(xalloc_die): Use _GL_NORETURN_FUNC.
	* gnulib-local/modules/xalloc (Depends-on): Add noreturn.

	Reduce explicit use of __attribute__.
	* autogen.sh (GNULIB_MODULES_RUNTIME_FOR_SRC, GNULIB_MODULES_TOOLS_FOR_SRC): Add noreturn.
	* gettext-runtime/src/envsubst.c: Include noreturn.h.
	(usage): Use _GL_NORETURN_FUNC.
	* gettext-runtime/src/gettext.c: Likewise.
	* gettext-runtime/src/ngettext.c: Likewise.
	* gettext-tools/src/hostname.c: Likewise.
	* gettext-tools/src/msgattrib.c: Likewise.
	* gettext-tools/src/msgcat.c: Likewise.
	* gettext-tools/src/msgcmp.c: Likewise.
	* gettext-tools/src/msgcomm.c: Likewise.
	* gettext-tools/src/msgconv.c: Likewise.
	* gettext-tools/src/msgen.c: Likewise.
	* gettext-tools/src/msgexec.c: Likewise.
	* gettext-tools/src/msgfilter.c: Likewise.
	* gettext-tools/src/msgfmt.c: Likewise.
	* gettext-tools/src/msginit.c: Likewise.
	* gettext-tools/src/msgmerge.c: Likewise.
	* gettext-tools/src/msgunfmt.c: Likewise.
	* gettext-tools/src/msguniq.c: Likewise.
	* gettext-tools/src/recode-sr-latin.c: Likewise.
	* gettext-tools/src/urlget.c: Likewise.
	* gettext-tools/src/xgettext.c: Likewise.
	* gettext-tools/src/msggrep.c: Include noreturn.h.
	(no_pass, usage): Use _GL_NORETURN_FUNC.
	* gettext-tools/src/msgl-iconv.c: Include noreturn.h.
	(conversion_error): Use _GL_NORETURN_FUNC.
	* gettext-tools/tests/tstgettext.c: Include noreturn.h.
	(usage): Use _GL_NORETURN_FUNC.
	* gettext-tools/tests/tstngettext.c: Likewise.

	build: Fix "make distcheck" failure.
	* gettext-tools/src/Makefile.am (po-gram-gen.c, cldr-plural.c): Don't use
	ylwrap.
	(MOSTLYCLEANFILES): Augment accordingly.
	* gettext-tools/configure.ac (YACC): Remove assignment.

2020-05-08  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* autogen.sh: Create gettext-runtime/intl/attribute.h.
	(GNULIB_MODULES_LIBASPRINTF): Add 'attribute'.
	* gettext-runtime/intl/Makefile.am (EXTRA_DIST): Add attribute.h.
	* Makefile.am (distcheck-hook): Test also gettext-runtime/intl/attribute.h.
	* gettext-runtime/intl/vasnprintf.c: Update from gnulib.
	* gettext-runtime/intl/xsize.h: Likewise.
	* gettext-runtime/libasprintf/vasnprintf.c: Likewise.

	Update to newest gnulib.

	Update after gnulib changed.
	* gnulib-local/modules/fnmatch.diff: Update.

	Update to newest gnulib.

2020-05-03  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* gettext-runtime/m4/intl.m4 (gt_INTL_SUBDIR_CORE): Remove redundant argument to
	gl_PROG_BISON.
	* gettext-tools/configure.ac: Likewise.

	Update to newest gnulib.

2020-05-01  Bruno Haible  <bruno@clisp.org>

	Clarify minimum needed bison version.
	* gettext-tools/src/cldr-plural.y: Add %require declaration.

	Tweak last commit.
	* gettext-tools/src/po-gram-gen.y: Move %define declaration after the first code
	block. Add %require declaration.

2020-05-01  Akim Demaille  <akim.demaille@gmail.com>

	Solidify remapping of function names of bison-generated parsers.
	* gettext-tools/src/po-gram-gen.y: Use Bison's api.prefix (introduced in Bison
	2.6) instead of handling renaming by hand.  New symbols would have been not
	renamed.

2020-05-01  Bruno Haible  <bruno@clisp.org>

	Update copyright year.
	* gettext-runtime/intl/plural.y: Update copyright year.

	intl: Require bison 3.0 or newer.
	* gettext-runtime/m4/intl.m4 (gt_INTL_SUBDIR_CORE): Require bison >= 3.0, not
	bison >= 2.7.

2020-05-01  Akim Demaille  <akim.demaille@gmail.com>

	intl: Fix grammar conflicts instead of accepting them.
	The seven conflicts are related to "a ? b : c <op> d".  In all the
	cases we left the S/R conflict be resolved as a shift, i.e., "a ? b
	: (c <op> d)".  To make this explicit, give the rule of the ternary
	operator a very low precedence.  In fact give it the same precedence
	as "?".  Now, to resolve the conflict in "a ? b : c ? d : e" be parsed
	as "a ? b : (c ? d : e)", make them right-associative.

	* gettext-runtime/intl/plural.y: Require Bison 3.0, to use %precedence
	instead of useless associativities such as %right.
	Make '?' and ':' of the same precedence, right associative.

2020-05-01  Bruno Haible  <bruno@clisp.org>

	build: Fix VPATH build failures with old bison when the *.y files are modified.
	* gettext-runtime/intl/Makefile.am (BISON): New variable.
	(YACC): Use it.
	(plural.c): Don't do the post-processing if a suitable version of bison was not
	found.
	* gettext-tools/src/Makefile.am (BISON): New variable.
	(po-gram-gen.c, cldr-plural.c): Don't do the post-processing if a suitable
	version of bison was not found.

	build: Simplify bison detection.
	* autogen.sh (GNULIB_MODULES_RUNTIME_OTHER): Add bison.
	* gettext-runtime/configure.ac: Don't invoke AC_PROG_YACC.
	* gettext-runtime/m4/intl.m4 (gt_INTL_SUBDIR_CORE): Invoke gl_PROG_BISON.

	build: Fix a build failure with bison < 3.0 when cldr-plural.y is modified.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC): Add bison.
	* gettext-tools/configure.ac: Don't invoke AC_PROG_YACC. Instead, invoke
	gl_PROG_BISON, set YACC, and invoke gl_BISON.

	Update to newest gnulib.

2020-05-01  Bruno Haible  <bruno@clisp.org>

	build: Fix link error in tests (regression from 2020-04-26).
	Reported and fix by Akim Demaille <akim.demaille@gmail.com>.

	* gettext-tools/libgettextpo/Makefile.am (libgettextpo_la_AUXSOURCES): Add
	format-ruby.c.

2020-04-27  Bruno Haible  <bruno@clisp.org>

	xgettext: Add Ruby support.
	* gettext-tools/src/x-ruby.h: New file.
	* gettext-tools/src/x-ruby.c: New file.
	* gettext-tools/src/xgettext.h (verbose): New declaration.
	* gettext-tools/src/xgettext.c: Include x-ruby.h.
	(verbose): New declaration.
	(flag_table_ruby): New variable.
	(long_options): Add '--verbose'.
	(main): Update for Ruby. Handle '-v'/'--verbose' option.
	(usage): Document the '-L Ruby' and '-v' options.
	(xgettext_record_flag, language_to_extractor, extension_to_language): Update for
	Ruby.
	* gettext-tools/src/Makefile.am (noinst_HEADERS): Add x-ruby.h.
	(xgettext_SOURCES): Add x-ruby.c.
	* gettext-tools/src/FILES: Mention x-ruby.h, x-ruby.c.
	* gettext-tools/tests/xgettext-ruby-1: New file.
	* gettext-tools/tests/format-ruby-1: New file.
	* gettext-tools/tests/format-ruby-2: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add them.
	* gettext-tools/doc/gettext.texi (Ruby): New section.
	* gettext-tools/doc/xgettext.texi: Document the '-L Ruby' and '-v' options.
	* HACKING: Document the recommended Ruby packages.
	* NEWS: Mention the Ruby support.

	xgettext: Define alternate parser signature for the Ruby support.
	* gettext-tools/src/xgettext.c (extract_from_stream_func): Renamed from
	extractor_func.
	(extract_from_file_func): New type.
	(struct extractor_ty): Rename field func to extract_from_stream. New field
	extract_from_file.
	(main): Consider both fields.
	(xgettext_find_file): New function.
	(extract_from_file): Add alternative code for when the other extraction function
	is defined.
	(language_to_extractor): In the table, rename field func to extract_from_stream,
	and add new field extract_from_file.
	* gettext-tools/src/x-*.h (SCANNERS_*): Update.

	xgettext: Define functions for the Ruby support.
	* gettext-tools/src/xg-message.h (decide_is_format, intersect_range,
	decide_do_wrap, decide_syntax_check): New declarations.
	* gettext-tools/src/xg-message.c (decide_is_format, intersect_range,
	decide_do_wrap, decide_syntax_check): New functions. extracted from
	remember_a_message.
	(remember_a_message): Invoke these functions.

	str-list: Add a remove function.
	* gettext-tools/src/str-list.h (string_list_remove): New declaration.
	* gettext-tools/src/str-list.c (string_list_remove): New function.

	Add support for Ruby format strings.
	* gettext-tools/src/message.h (enum format_type): Add format_ruby.
	* gettext-tools/src/message.c (format_language, format_language_pretty): Add an
	entry for format_ruby.
	(NFORMATS): Increment.
	* gettext-tools/src/format.h (formatstring_ruby): New declaration.
	* gettext-tools/src/format.c (formatstring_parsers): Add an entry for
	format_ruby.
	* gettext-tools/src/format-ruby.c: New file, based on
	gettext-tools/src/format-python.c.
	* gettext-tools/src/FILES: Mention it.
	* gettext-tools/src/Makefile.am (FORMAT_SOURCE): Add format-ruby.c.
	* gettext-tools/doc/gettext.texi (PO Files): Mention ruby-format.
	(ruby-format): New section.

	xgettext: Fix a comment.
	* gettext-tools/src/x-po.c: Fix a comment.

	Reduce heap allocation in format string parsers.
	* gettext-tools/src/format-awk.c (struct spec): Remove 'allocated' field.
	(format_parse): Use a local variable instead.
	* gettext-tools/src/format-boost.c: Likewise.
	* gettext-tools/src/format-elisp.c: Likewise.
	* gettext-tools/src/format-gcc-internal.c: Likewise.
	* gettext-tools/src/format-java-printf.c: Likewise.
	* gettext-tools/src/format-javascript.c: Likewise.
	* gettext-tools/src/format-kde.c: Likewise.
	* gettext-tools/src/format-librep.c: Likewise.
	* gettext-tools/src/format-lua.c: Likewise.
	* gettext-tools/src/format-perl-brace.c: Likewise.
	* gettext-tools/src/format-python.c: Likewise.
	* gettext-tools/src/format-sh.c: Likewise.
	* gettext-tools/src/format-tcl.c: Likewise.
	* gettext-tools/src/format-c-parse.h (struct spec): Remove 'allocated' field.
	(format_parse_entrails): Use a local variable instead.
	* gettext-tools/src/format-pascal.c (struct spec): Remove 'allocated' field.
	(format_parse): Rename a local variable.
	* gettext-tools/src/format-perl.c: Likewise.
	* gettext-tools/src/format-php.c: Likewise.
	* gettext-tools/src/format-gfc-internal.c (format_parse): Rename a local
	variable.

	examples: Improve code style.
	* gettext-tools/examples/hello-*/configure.ac: Improve quoting.

	Update .gitignore after 2020-04-19 change.

2020-04-25  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* gettext-runtime/libasprintf/vasnprintf.c: Update from gnulib.

2020-04-20  Bruno Haible  <bruno@clisp.org>

	build: Fix a warning (regression from 2020-01-05).
	* gettext-tools/tests/tstgettext.c (setlocale): Declare after defining as
	fake_setlocale.
	* gettext-tools/tests/tstngettext.c (setlocale): Likewise.
	* gettext-tools/tests/plural-1-prg.c (setlocale): Likewise.
	* gettext-tools/tests/format-c-3-prg.c (setlocale): Likewise.
	* gettext-tools/tests/format-c-4-prg.c (setlocale): Likewise.

2020-04-20  Bruno Haible  <bruno@clisp.org>

	intl: Support any Unicode characters in the locale dir on native Windows.
	Reported at <https://savannah.gnu.org/bugs/?57714>.

	* gettext-runtime/intl/libgnuintl.in.h (libintl_wbindtextdomain): New
	declaration.
	(wbindtextdomain): New redirect.
	* gettext-runtime/intl/bindtextdom.c (set_binding_values): Accept a wdirnamep
	argument. Set not only binding->dirname but also binding->wdirname.
	(BINDTEXTDOMAIN, BIND_TEXTDOMAIN_CODESET): Pass NULL as wdirnamep.
	(libintl_wbindtextdomain): New function.
	* gettext-runtime/intl/loadinfo.h (struct loaded_l10nfile): Add a wfilename
	field.
	(_nl_make_l10nflist): On native Windows, accept wdirlist, wdirlist_len
	parameters.
	* gettext-runtime/intl/loadmsgcat.c (_nl_load_domain): On native Windows, use
	_wopen() instead of open() to open a file with a name given as wchar_t[].
	* gettext-runtime/intl/l10nflist.c: Include <wchar.h>.
	(_nl_make_l10nflist): On native Windows, accept wdirlist, wdirlist_len
	parameters. Construct abs_wfilename and use in the search for existing
	'struct loaded_l10nfile' and when allocating a fresh 'struct loaded_l10nfile'.
	* gettext-runtime/intl/gettextP.h (struct binding): Add a wdirname field.
	(_nl_find_domain): On native Windows, accept a wdirname parameter.
	* gettext-runtime/intl/finddomain.c (_nl_find_domain): On native Windows, accept
	a wdirname parameter. Pass it to _nl_make_l10nflist.
	* gettext-runtime/intl/dcigettext.c (DCIGETTEXT): Consider not only
	binding->dirname but also binding->wdirname. On native Windows, use _wgetcwd
	instead of getcwd. Pass also wdirname to _nl_find_domain.
	* gettext-tools/tests/intl-6: New file, based on gettext-tools/tests/intl-1.
	* gettext-tools/tests/intl-6-prg.c: New file, based on
	gettext-tools/tests/intl-1-prg.c.
	* gettext-tools/tests/Makefile.am (TESTS): Add intl-6.
	(check_PROGRAMS): Add intl-6-prg.
	(intl_6_prg_SOURCES, intl_6_prg_LDADD): New variables.
	* gettext-tools/doc/gettext.texi (Ambiguities, src/Makefile,
	Language Implementors, C): Document wbindtextdomain.
	* gettext-runtime/NEWS: Mention the change.
	* NEWS: Likewise.

2020-04-20  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* gettext-runtime/intl/vasnprintf.c: Update from gnulib.

	Update to newest gnulib.

2020-04-19  Bruno Haible  <bruno@clisp.org>

	intl: Add comment regarding debugging printf.
	* gettext-runtime/intl/printf.c (ENABLE_WCHAR_FALLBACK): New commented
	definition.

2020-04-14  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Fix a memory leak.
	Reported by José E. Marchesi <jemarch@gnu.org>.

	* libtextstyle/gnulib-local/lib/term-ostream.oo.c (term_ostream::free): Free
	also the stream's attrbuffer.

2020-04-14  Bruno Haible  <bruno@clisp.org>

	Update NEWS files after version 0.20.2 was released.

	Fix typo in release steps.

	Merge from 0.20.x branch: Update translations (from the TP).
	* gettext-runtime/po/*.po: Update.
	* gettext-tools/po/*.po: Update.
	* gettext-tools/examples/po/*.po: Update.
	* gettext-tools/examples/po/LINGUAS: Add 'sq'.
	* gettext-tools/examples/hello-*/po/LINGUAS: Likewise.
	* gettext-tools/examples/Makefile.am (EXAMPLESPOFILES): Add sq.po.

	Merge from 0.20.x branch: examples: Use infrastructure from gettext version 0.20.2.
	* gettext-tools/examples/hello-*/configure.ac: Use AM_GNU_GETTEXT_VERSION with
	version 0.20.2.
	* gettext-tools/examples/hello-c++-kde/configure.in.in: Likewise.

	Merge from 0.20.x branch: Prepare for 0.20.2 release.
	* gettext-runtime/doc/matrix.texi: Update from TP.
	* gettext-runtime/doc/nls.texi (STATUS): Update.
	* gettext-runtime/intl/Makefile.am (LTV_*): Bump to 9:7:1.
	* gettext-runtime/intl/libgnuintl.in.h (LIBINTL_VERSION): Bump.
	* gettext-tools/configure.ac (ARCHIVE_VERSION): Bump to 0.20.2.
	* gettext-tools/libgettextpo/Makefile.am (LTV_*): Bump to 5:6:5.
	* gettext-tools/libgettextpo/gettext-po.in.h (LIBGETTEXTPO_VERSION): Bump.
	* gettext-runtime/src/envsubst.c: Update copyright years in --version output.
	* gettext-runtime/src/gettext.c: Likewise.
	* gettext-runtime/src/gettext.sh.in: Likewise.
	* gettext-runtime/src/ngettext.c: Likewise.
	* gettext-tools/src/cldr-plurals.c: Likewise.
	* gettext-tools/src/hostname.c: Likewise.
	* gettext-tools/src/msgattrib.c: Likewise.
	* gettext-tools/src/msgcat.c: Likewise.
	* gettext-tools/src/msgcmp.c: Likewise.
	* gettext-tools/src/msgcomm.c: Likewise.
	* gettext-tools/src/msgconv.c: Likewise.
	* gettext-tools/src/msgen.c: Likewise.
	* gettext-tools/src/msgexec.c: Likewise.
	* gettext-tools/src/msgfilter.c: Likewise.
	* gettext-tools/src/msgfmt.c: Likewise.
	* gettext-tools/src/msggrep.c: Likewise.
	* gettext-tools/src/msginit.c: Likewise.
	* gettext-tools/src/msgmerge.c: Likewise.
	* gettext-tools/src/msgunfmt.c: Likewise.
	* gettext-tools/src/msguniq.c: Likewise.
	* gettext-tools/src/recode-sr-latin.c: Likewise.
	* gettext-tools/src/urlget.c: Likewise.
	* gettext-tools/src/xgettext.c: Likewise.
	* gettext-tools/misc/convert-archive.in: Likewise.
	* gettext-tools/misc/gettextize.in: Likewise.
	* gettext-tools/misc/autopoint.in: Likewise. Handle version 0.20.2.

	maint: Update download location of jdom-1.0.jar.

	build: Fix the generation of hello-c-gnome3.pot (regression from 2019-10-04).
	* gettext-tools/examples/po/Makefile.am (USE_BUILT_PROGS): Set also
	GETTEXTDATADIR.

2020-04-13  Bruno Haible  <bruno@clisp.org>

	Fix a compilation error (regression from 2019-12-24).
	* gettext-tools/src/write-desktop.c: Include <stdint.h>.

2020-04-12  Bruno Haible  <bruno@clisp.org>

	intl: Drop argz processing outside of glibc.
	* gettext-runtime/intl/l10nflist.c: Don't test HAVE_ARGZ_H.
	(__argz_count, __argz_stringify, __argz_next): Remove definitions.
	(_nl_make_l10nflist): Simplify !_LIBC case.
	* gettext-runtime/m4/intl.m4 (gt_INTL_SUBDIR_CORE): Don't test for <argz.h>,
	argz_count, argz_stringify, argz_next.

	intl: Improve comments.
	* gettext-runtime/intl/Makefile.am: Add an overview of the code.
	* gettext-runtime/intl/loadinfo.h (_nl_make_l10nflist): Improve comment.
	* gettext-runtime/intl/dcigettext.c (guess_category_value): Likewise.
	* gettext-runtime/intl/finddomain.c (_nl_find_domain): Likewise.

2020-04-11  Bruno Haible  <bruno@clisp.org>

	po: Emit a warning when creating a tarball without POT file.
	* gettext-runtime/po/Makefile.in.in (dist2): Emit a warning when the POT file
	does not exist.
	* gettext-tools/examples/hello-*/po/Makefile.am (distdir1): Likewise.

	libtextstyle: Update .gitignore after 2019-12-24 change.

	Update to newest gnulib.

2020-04-10  Bruno Haible  <bruno@clisp.org>

	xgettext: Fix a report by an undefined-behaviour sanitizer.
	Reported by Jeffrey Walton <noloader@gmail.com> in
	<https://lists.gnu.org/archive/html/bug-gettext/2020-01/msg00029.html>.

	* gettext-tools/src/read-properties.c (read_escaped_string): Don't call memcpy
	with a NULL argument.

2020-04-06  Bruno Haible  <bruno@clisp.org>

	xgettext: Improve JSX support in JavaScript.
	Reported by Vaclav Slavik <vaclav@slavik.io> in
	<https://savannah.gnu.org/bugs/?57927>.

	* gettext-tools/src/x-javascript.c (enum token_type_ty): Add some more types.
	(is_after_expression): New function.
	(phase5_get): Distinguish the "other" tokens in more detail. Use
	'is_after_expression ()' when interpreting a '<' or '/' character.
	(extract_balanced): Don't let commas in braced expressions and in XML elements
	disturb the argument processing outside.
	(extract_javascript): Update.
	* gettext-tools/tests/xgettext-javascript-6: Enhance the test.
	* NEWS: Mention the change.

2020-04-06  Bruno Haible  <bruno@clisp.org>

	xgettext: Freshly initialize all static variables for each input file.
	* gettext-tools/src/x-c.c (extract_whole_file): Initialize
	phase1_pushback_length, phase2_pushback_length, phase3_pushback_length,
	phase5_pushback_length, phase6_pushback_length.
	* gettext-tools/src/x-csharp.c (extract_csharp): Initialize
	phase1_pushback_length, phase2_pushback_length, phase3_pushback_length,
	phase5_pushback_length, phase6_pushback_length, phase7_pushback_length.
	* gettext-tools/src/x-java.c (extract_java): Initialize phase1_pushback_length,
	phase2_pushback_length, phase3_pushback_length, phase5_pushback_length,
	phase6_pushback_length.
	* gettext-tools/src/x-javascript.c (continuation_or_nonblank_line,
	last_token_type): Remove static initialization.
	(extract_javascript): Initialize phase1_pushback_length, phase2_pushback_length,
	phase5_pushback_length, last_token_type.
	* gettext-tools/src/x-lua.c (first_character): Change type to 'bool'. Remove
	static initialization.
	(extract_lua): Initialize phase1_pushback_length, first_character,
	phase3_pushback_length, phase4_last, phase4_pushback_length.
	* gettext-tools/src/x-perl.c (extract_perl): Reorder initializations.
	* gettext-tools/src/x-php.c (extract_php): Initialize phase1_pushback_length,
	phase3_pushback_length, phase4_pushback_length.
	* gettext-tools/src/x-python.c (continuation_or_nonblank_line): Remove static
	initialization.
	(extract_python): Initialize phase1_pushback_length, phase2_pushback_length,
	phase5_pushback_length.
	* gettext-tools/src/x-sh.c (extract_sh): Initialize phase1_pushback_length,
	phase2_pushback_length.
	* gettext-tools/src/x-smalltalk.c (extract_smalltalk): Initialize
	phase2_pushback_length, phase3_pushback_length.
	* gettext-tools/src/x-tcl.c (extract_tcl): Initialize phase1_pushback_length,
	phase2_pushback_length.
	* gettext-tools/src/x-vala.c (last_token_type): Remove static initialization.
	(extract_vala): Initialize phase1_pushback_length, phase3_pushback_length,
	last_token_type.
	* gettext-tools/src/x-ycp.c (extract_ycp): Initialize phase2_pushback_length,
	phase5_pushback_length, phase8_pushback_length.

2020-04-05  Bruno Haible  <bruno@clisp.org>

	po, examples: In the .po -> .gmo rules, really consider the newest changes to the POT file.
	Reported by Petr Ovtchenkov <ptr@void-ptr.info> in
	<https://lists.gnu.org/archive/html/bug-gnulib/2020-04/msg00000.html>.
	Helped by Paul Smith.

	* gettext-runtime/po/Makefile.in.in (.po.gmo): Write dependency on the POT file
	as a target rule, since inference rules don't support prerequisites.
	* gettext-tools/examples/hello-*/po/Makefile.am: Likewise, also for the .po.qm
	rule.
	* NEWS: Mention the fix.

2020-04-04  Bruno Haible  <bruno@clisp.org>

	The gettext library is under LGPL 2.1, not 2.0.
	* gettext-runtime/m4/intl.m4: Fix comments regarding the gettext library.
	* gettext-runtime/m4/intlmacosx.m4: Likewise.
	* gettext-runtime/m4/nls.m4: Likewise.
	* gettext-runtime/m4/po.m4: Likewise.
	* gettext-runtime/m4/progtest.m4: Likewise.

	The next release will be 0.20.2, not 0.21.
	* gettext-runtime/m4/gettext.m4: Update header comment.
	* gettext-runtime/m4/intdiv0.m4: Likewise.
	* gettext-tools/m4/exported.m4: Likewise.

2020-03-29  Bruno Haible  <bruno@clisp.org>

	doc: Don't recommend to use the reserved identifier '_' in Java.
	Reported by Akim Demaille <akim.demaille@gmail.com>.

	* gettext-tools/doc/gettext.texi (Java): Use i18n instead _ as magic identifier.

2020-03-28  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* gnulib-local/lib/regex_internal.h.diff: Update.
	* gnulib-local/lib/unistd.in.h.diff: Update.
	* gettext-runtime/intl/filename.h: New file, from gnulib.
	* gettext-runtime/intl/dcigettext.c (ISSLASH, HAS_DEVICE, IS_ABSOLUTE_PATH,
	IS_PATH_WITH_DIR): Remove macros. Instead, include filename.h.
	(IS_ABSOLUTE_FILE_NAME, IS_RELATIVE_FILE_NAME, IS_FILE_NAME_WITH_DIR): New
	macros.
	(DCIGETTEXT): Use IS_RELATIVE_FILE_NAME, IS_FILE_NAME_WITH_DIR.
	* gettext-runtime/intl/l10nflist.c (ISSLASH, HAS_DEVICE, IS_ABSOLUTE_PATH):
	Remove macros. Instead, include filename.h.
	(IS_ABSOLUTE_FILE_NAME, IS_RELATIVE_FILE_NAME): New macros.
	(_nl_make_l10nflist): Use IS_RELATIVE_FILE_NAME.
	* gettext-runtime/intl/Makefile.am (EXTRA_DIST): Add filename.h.
	(l10nflist.lo, dcigettext.lo): Depend on it.
	* Makefile.am (distcheck-hook): Check also gettext-runtime/intl/filename.h.
	* gettext-runtime/intl/lock.c: Update from gnulib.
	* gettext-runtime/intl/lock.h: Likewise.
	* gettext-runtime/intl/relocatable.c: Likewise.
	* gettext-tools/src/locating-rule.c (locating_rule_list_locate): Use
	IS_RELATIVE_FILE_NAME instead of IS_ABSOLUTE_PATH.
	* gettext-tools/src/open-catalog.c (try_open_catalog_file): Likewise.
	* gettext-tools/src/xgettext.c (main, xgettext_open): Likewise.
	* libtextstyle/lib/color.c (style_file_lookup): Use IS_FILE_NAME_WITH_DIR
	instead of IS_PATH_WITH_DIR.

	Update to newest gnulib.

2020-02-24  Bruno Haible  <bruno@clisp.org>

	urlget: Follow the "privacy by design" principle.
	* gettext-tools/src/urlget.c (fetch): Override the User-Agent string, so as not
	to reveal the program version to the server. For wget, use long options.

2020-02-23  Bruno Haible  <bruno@clisp.org>

	urlget: Follow the "privacy by design" principle.
	* gettext-tools/src/gnu/gettext/GetURL.java (fetch): Override the User-Agent
	string, so as not to reveal the Java version to the server.

2020-01-21  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Prepare intermediate release 0.20.5.
	* libtextstyle/version.sh: Update version number.
	* libtextstyle/lib/Makefile.am (LTV_*): Bump to 1:0:1.
	* libtextstyle/NEWS: Update.
	* NEWS: Likewise.

2020-01-05  Bruno Haible  <bruno@clisp.org>

	build: Tweak configure.ac.
	* gettext-runtime/configure.ac: Move AH_BOTTOM invocation, for consistency with
	gettext-tools/configure.ac.

	build: Fix link error on MSVC with --disable-shared.
	* gettext-tools/tests/setlocale.c (setlocale): Define to fake_setlocale on
	native Windows.
	* gettext-tools/tests/format-c-3-prg.c (setlocale): Likewise.
	* gettext-tools/tests/format-c-4-prg.c (setlocale): Likewise.
	* gettext-tools/tests/plural-1-prg.c (setlocale): Likewise.
	* gettext-tools/tests/tstgettext.c (setlocale): Likewise.
	* gettext-tools/tests/tstngettext.c (setlocale): Likewise.

	build: Fix build error on MSVC with --disable-shared.
	* gettext-tools/configure.ac (AH_BOTTOM): On MSVC with --disable-shared, even
	when compiling with option -MD, define DLL_VARIABLE to empty.

2020-01-05  Dmitry V. Levin  <ldv@altlinux.org>

	libtextstyle: Enable large files and, on Linux, 64-bit inodes support.
	* libtextstyle/autogen.sh (GNULIB_MODULES): Add 'largefile' to enable
	large files support on systems where this is not the default and 64-bit
	inodes in 32-bit applications on Linux.

2020-01-05  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.

2020-01-02  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* gettext-runtime/intl/localcharset.c: Update from gnulib.
	* gettext-runtime/intl/setlocale-lock.c: Likewise.

	Update to newest gnulib.

2019-12-24  Bruno Haible  <bruno@clisp.org>

	Fix a test failure of msgfmt-desktop-2 on HP-UX with cc.
	* gettext-tools/src/write-desktop.c (msgfmt_desktop_handle_pair): Don't cast
	directly from 'void *' to 'bool'.

	Update after gnulib changed: Support building with --enable-threads=isoc.
	* gettext-runtime/intl/dcigettext.c (lock): Move outside _nl_find_msg.
	* gettext-runtime/intl/finddomain.c (lock): Move outside _nl_find_domain.
	* gettext-runtime/intl/loadmsgcat.c (lock): Move outside _nl_load_domain.

	Update after gnulib changed: Fix test failures on FreeBSD, NetBSD, macOS.
	* gettext-tools/tests/setlocale.c (setlocale): Undefine.

	Update after gnulib changed.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC_COMMON_DEPENDENCIES): Add
	setlocale-null.
	* gettext-runtime/intl/localcharset.h: Update from gnulib.
	* gettext-runtime/intl/localcharset.c: Likewise.
	* gettext-runtime/intl/localename.c: Likewise.
	* gettext-runtime/intl/setlocale_null.h: New file, from gnulib.
	* gettext-runtime/intl/arg-nonnull.h: New file, from gnulib.
	* gettext-runtime/intl/setlocale_null.c: New file, from gnulib.
	* gettext-runtime/intl/setlocale-lock.c: New file, from gnulib.
	* gettext-runtime/intl/lock.h: Update from gnulib.
	* gettext-runtime/intl/lock.c: Likewise.
	* gettext-runtime/intl/threadlib.c: Likewise.
	* gettext-runtime/intl/vasnprintf.c: Likewise.
	* gettext-runtime/intl/verify.h: Likewise.
	* gettext-runtime/intl/Makefile.am (EXTRA_DIST): Add arg-nonnull.h,
	setlocale_null.h.
	(LIBINTLSOURCES): Add setlocale-lock.c, setlocale_null.c.
	(setlocale-lock.lo, setlocale_null.lo): New rules.
	(localename.lo, setlocale-lock.lo, setlocale_null.lo): Update dependencies.
	* Makefile.am (distcheck-hook): Check the new files in gettext-runtime/intl/.
	* gettext-runtime/libasprintf/vasnprintf.c: Update from gnulib.
	* gettext-tools/libgettextpo/Makefile.am (DEFS): Define OMIT_SETLOCALE_LOCK.
	* gettext-runtime/NEWS: Mention the multithread-safety fix in localcharset.c.
	* NEWS: Likewise.

	Update to newest gnulib.

	Fix test failures on Haiku.
	* gettext-tools/tests/init.cfg (func_filter_POT_Creation_Date): New function.
	* gettext-tools/tests/xgettext-*: Use it.

	build: Fix build failures on HP-UX 11.31/hppa with cc.
	* gnulib-local/lib/libxml/parser.c (struct _xmlDefAttrs): Don't use ISO C 99
	syntax with this compiler.
	* gettext-runtime/intl/plural-exp.h (HAVE_STRUCT_INITIALIZER): Set to 0 with
	this compiler.

	libtextstyle: Don't erase the .sym.in file if 'sed' is not GNU sed.
	* libtextstyle/lib/Makefile.am (libtextstyle.sym.in): Test the exit status of
	the declared.sh command. Preserve the existing libunistring.sym if it failed.

2019-11-25  Bruno Haible  <bruno@clisp.org>

	libcroco: Improve copyright headers.
	The copyright headers should be unambiguous even if a single file is copied from
	the GNU gettext package and used elsewhere. Reported by John Darrington.

	* libtextstyle/gnulib-local/lib/libcroco/*: Inline the COPYRIGHT file where
	applicable. Add copyright header.
	* libtextstyle/gnulib-local/lib/libcroco/libcroco-config.h: Add copyright header.

2019-11-24  Bruno Haible  <bruno@clisp.org>

	libxml: Improve copyright headers.
	The copyright headers should be unambiguous even if a single file is copied from
	the GNU gettext package and used elsewhere. Reported by John Darrington.

	* gnulib-local/lib/libxml/*: Inline this directory's COPYING file where
	applicable. Add FSF copyright header.
	* gnulib-local/lib/libxml/trionan.c: Add copyright header.

2019-11-24  Bruno Haible  <bruno@clisp.org>

	glib: Improve copyright headers.
	The copyright headers should be unambiguous even if a single file is copied from
	the GNU gettext package and used elsewhere. Reported by John Darrington.

	* libtextstyle/gnulib-local/lib/glib*: Add FSF copyright header.

2019-10-28  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Add test for ostream_printf.
	* libtextstyle/gnulib-local/tests/test-memory-ostream.c: New file.
	* libtextstyle/gnulib-local/modules/memory-ostream-tests: New file.
	* libtextstyle/Makefile.am (EXTRA_DIST): Add them.
	* libtextstyle/autogen.sh (GNULIB_MODULES): Add 'memory-ostream-tests'.

2019-10-28  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Add ostream_printf, ostream_vprintf functions.
	Suggested by José Marchesi.

	* libtextstyle/autogen.sh (GNULIB_MODULES): Add 'vasprintf-posix'.
	* libtextstyle/gnulib-local/lib/ostream.oo.h: Include <stdarg.h>.
	(ostream_printf, ostream_vprintf): New declarations.
	* libtextstyle/gnulib-local/lib/ostream.oo.c: Include <stdio.h>.
	(ostream_printf, ostream_vprintf): New functions.
	* libtextstyle/gnulib-local/lib/styled-ostream.oo.h: Update comments.
	* libtextstyle/gnulib-local/lib/term-ostream.oo.h: Likewise.
	* libtextstyle/gnulib-local/lib/html-ostream.oo.h: Likewise.
	* libtextstyle/lib/textstyle.h: Include <stdio.h>.
	(ostream_printf, ostream_vprintf): New functions.
	(styled_ostream_flush_to_current_style, term_ostream_flush_to_current_style,
	html_ostream_flush_to_current_style): Update comments.
	* libtextstyle/doc/libtextstyle.texi (The ostream class): Document
	ostream_printf, ostream_vprintf.
	(The styled_ostream class, The term_ostream class, The html_ostream class):
	Update comments.
	* libtextstyle/NEWS: Mention it.
	* NEWS: Likewise.

2019-10-28  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Clarify memory_stream_contents function.
	* libtextstyle/gnulib-local/lib/memory-ostream.oo.h (memory_stream::contents):
	Clarify extent of return values.
	* libtextstyle/doc/libtextstyle.texi (The memory_ostream class): Likewise.

	build: Fix typo in comment.
	* gettext-tools/gnulib-tests/Makefile.am: Fix typo.
	* libtextstyle/adhoc-tests/Makefile.am: Likewise.
	* libtextstyle/tests/Makefile.am: Likewise.

2019-10-20  Bruno Haible  <bruno@clisp.org>

	doc: Add more info for language implementors.
	* gettext-tools/doc/gettext.texi (Language Implementors): Add more details.

2019-10-13  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* gettext-runtime/intl/localcharset.c: Update from gnulib.
	* gettext-runtime/intl/verify.h: Likewise.

	Update to the newest gnulib.

2019-10-07  Bruno Haible  <bruno@clisp.org>

	doc: Mention continuous integration.
	* HACKING: Mention continuous integration.

2019-10-06  Bruno Haible  <bruno@clisp.org>

	build: Fix failure to build the doc in a VPATH build.
	* gettext-tools/doc/Makefile.am ($(srcdir)/stamp-vti): Create version.texi in
	the source directory.

	xgettext: Fix bug in shell script parser (regression from 2019-09-15).
	* gettext-tools/src/x-sh.c (read_command): Set matters_for_argparser = false
	when context_iter is not being initialized.

	Correct indentation.
	* gettext-tools/src/x-scheme.c (read_object): Correct indentation.

2019-10-05  Bruno Haible  <bruno@clisp.org>

	doc: Mention packages needed for Javascript support.
	* HACKING: Mention the gir1.2-gtk-3.0 package alongside with gjs.

2019-10-04  Bruno Haible  <bruno@clisp.org>

	doc: Don't need an ar_SA locale.
	* HACKING: Remove command that creates an ar_SA locale.

	doc: Update list of external dependencies.
	* DEPENDENCIES: Don't list glib2 and libcroco (not needed any more since
	2019-02-15).

2019-10-04  Bruno Haible  <bruno@clisp.org>

	build: Fix the build error in gettext-tools/examples/po.
	Reported by Nick Alcock <nix@esperi.org.uk>
	at <https://savannah.gnu.org/bugs/?56529>.

	* gettext-tools/examples/po/Makefile.am (USE_BUILT_PROGS): New variable.
	(hello-*.pot): Use it.
	($(srcdir)/../hello-*/po/$(LL).po): Likewise.
	* HACKING: Remove the workaround.

2019-10-04  Bruno Haible  <bruno@clisp.org>

	Make it easier to build the code when the documentation tools don't work.
	* libtextstyle/Makefile.am (SUBDIRS): Move 'doc' to the end.

	libxml: Simplify autoconf macro.
	* gnulib-local/m4/libxml.m4 (gl_LIBXML): Don't test for dlopen and shlload.
	The test for dlopen failed, because it would require linking with '-ldl'.
	The test for shlload failed, because the function on HP-UX is called 'shl_load'
	and it would require linking with '-ldld'.

	build: Don't fetch gnulib a second time in libtextstyle.
	* autogen.sh: Set GNULIB_SRCDIR when invoking libtextstyle/autogen.sh.
	* libtextstyle/autogen.sh: Remove all git operations. Look at the GNULIB_SRCDIR
	environment variable. Ignore the GNULIB_TOOL environment variable.

	libtextstyle: Fix failure to download texinfo.tex.
	* libtextstyle/autogen.sh: Create build-aux directory.

2019-09-30  Bruno Haible  <bruno@clisp.org>

	Update NEWS file.
	* NEWS: Include the news about libtextstyle.

2019-09-29  Bruno Haible  <bruno@clisp.org>

	xgettext: Signal a warning when the same msgid is used with and without plural.
	* gettext-tools/src/xg-message.h (remember_a_message): Add pluralp argument.
	* gettext-tools/src/xg-message.c (remember_a_message): Likewise. Signal a
	warning when the same msgid is used with and without plural.
	* gettext-tools/src/xg-arglist-parser.c (arglist_parser_done): Update
	remember_a_message invocation.
	* gettext-tools/src/xgettext.c (xgettext_its_extract_callback): Update
	remember_a_message invocations.
	* gettext-tools/src/x-awk.c (extract_parenthesized): Likewise.
	* gettext-tools/src/x-c.c (extract_parenthesized): Likewise.
	* gettext-tools/src/x-csharp.c (extract_parenthesized): Likewise.
	* gettext-tools/src/x-desktop.c (extract_desktop_handle_pair): Likewise.
	* gettext-tools/src/x-elisp.c (read_object): Likewise.
	* gettext-tools/src/x-java.c (extract_parenthesized): Likewise.
	* gettext-tools/src/x-javascript.c (extract_balanced): Likewise.
	* gettext-tools/src/x-librep.c (read_object): Likewise.
	* gettext-tools/src/x-lisp.c (read_object): Likewise.
	* gettext-tools/src/x-lua.c (extract_balanced): Likewise.
	* gettext-tools/src/x-perl.c (extract_variable, interpolate_keywords,
	extract_balanced): Likewise.
	* gettext-tools/src/x-php.c (extract_balanced): Likewise.
	* gettext-tools/src/x-python.c (extract_balanced): Likewise.
	* gettext-tools/src/x-rst.c (extract_rst, extract_rsj): Likewise.
	* gettext-tools/src/x-scheme.c (read_object): Likewise.
	* gettext-tools/src/x-sh.c (read_word, read_command): Likewise.
	* gettext-tools/src/x-tcl.c (read_command): Likewise.
	* gettext-tools/src/x-vala.c (extract_balanced): Likewise.
	* gettext-tools/src/x-smalltalk.c (phase3_pushback, phase3_pushback_length): New
	variables.
	(phase3_get): Renamed from x_smalltalk_lex. Handle pushback.
	(phase3_unget): New function.
	(extract_smalltalk): Update remember_a_message invocations through a lookahead
	of one token.
	* gettext-tools/src/x-ycp.c (phase8_pushback, phase8_pushback_length): New
	variables.
	(phase8_get): Handle pushback.
	(phase8_unget): New function.
	(extract_parenthesized): Update remember_a_message invocations through a
	lookahead of one token.
	* gettext-tools/tests/xgettext-15: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2019-09-29  Bruno Haible  <bruno@clisp.org>

	msgcat: Signal error when the same msgid is used with and without msgid_plural.
	Suggested by Mikko Rantalainen <mikko.rantalainen@peda.net>
	in <https://lists.gnu.org/archive/html/bug-gettext/2019-09/msg00020.html>.

	* gettext-tools/src/msgl-cat.c (catenate_msgdomain_list): Signal an error when
	the same msgid is used with and without msgid_plural.
	* gettext-tools/src/msgcat.c (main): Exit with failure code if there was an
	error.
	* gettext-tools/src/msgcomm.c (main): Likewise.
	* gettext-tools/src/msguniq.c (main): Likewise.
	* gettext-tools/tests/msgcat-21: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2019-09-29  Bruno Haible  <bruno@clisp.org>

	libxml: Fix buffer overrun.
	Reported by GCC 8 -Wformat-truncation warning.

	* gnulib-local/lib/libxml/parser.c (xmlParseReference): Increase size of buffer
	'out' to 12 bytes.

2019-09-29  Bruno Haible  <bruno@clisp.org>

	xgettext: Fix parsing of XML tags.
	* gettext-tools/src/x-javascript.c (phase5_get): Fix lexical_context after
	decrementing xml_element_depth.

2019-09-29  Bruno Haible  <bruno@clisp.org>

	xgettext: Fix parsing of XML tags that end in /> and have attributes.
	Reported by Matej Marusak <marusak.matej@gmail.com>
	in <https://savannah.gnu.org/bugs/?56848>.

	* gettext-tools/src/x-javascript.c (phase5_get): After reading a string, reset
	the lexical_context to the previous one, not to lc_outside. When reading /> at
	the end of an XML element, decrement xml_element_depth.
	* gettext-tools/tests/xgettext-javascript-6: Add a test.

2019-09-29  Bruno Haible  <bruno@clisp.org>

	xgettext: Recognize text blocks in Java parser.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC): Add
	unictype/syntax-java-whitespace.
	* gettext-tools/src/x-java.c: Include unictype.h.
	(strip_indent): New function.
	(phase5_get): Parse text blocks (Java 13 syntax).
	* gettext-tools/tests/xgettext-java-2: Add tests of text blocks.
	* gettext-tools/doc/gettext.texi (Java): Mention the text block syntax.
	* NEWS: Mention the change.

2019-09-29  Bruno Haible  <bruno@clisp.org>

	xgettext: Verify parsing of JavaScript template literals inside objects.
	Reported by Andy Holmes <andrew.g.r.holmes@gmail.com>
	in <https://savannah.gnu.org/bugs/?50920>.

	* gettext-tools/tests/xgettext-javascript-7: Test template literals inside an
	object.

2019-09-16  Bruno Haible  <bruno@clisp.org>

	xgettext: Recognize 'env' and assignments in Shell scripts.
	Reported by Jason Vas Dias <jason.vas.dias@gmail.com>
	in <https://lists.gnu.org/archive/html/bug-gettext/2019-08/msg00032.html>.

	* gettext-tools/src/x-sh.c (enum word_type): Add t_assignment.
	(read_word): Recognize assignments.
	(read_command): In a function position, ignore assignments and 'env' tokens.
	* gettext-tools/tests/xgettext-sh-7: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.
	* NEWS: Mention the change.

2019-09-16  Bruno Haible  <bruno@clisp.org>

	Document improvement done on 2019-05-20.
	* gettext-runtime/NEWS: Document improvement.
	* NEWS: Likewise.

2019-09-14  Bruno Haible  <bruno@clisp.org>

	build: Install gettext.h with the LGPL license header, not with the GPL header.
	Reported by Joachim Metz <joachim.metz@gmail.com>
	in <https://lists.gnu.org/archive/html/bug-gettext/2012-09/msg00000.html>.

	* gettext-tools/gnulib-lib/Makefile.am (gettextsrcdir, gettextsrc_DATA): Remove
	variables.
	* gnulib-local/Makefile.am (gettextsrcdir, gettextsrc_DATA): Define them here.

2019-09-14  Bruno Haible  <bruno@clisp.org>

	Clarify license of gettext.m4.
	* gettext-runtime/m4/gettext.m4: Update comments: libintl is under LGPLv2.1+.

2019-09-14  Bruno Haible  <bruno@clisp.org>

	build: Avoid failing a configure test due to CFLAGS="-Werror".
	Reported by Florian Weimer <fweimer@redhat.com>.

	* gettext-runtime/m4/intdiv0.m4 (gt_INTDIV0): In the test program, include
	<unistd.h>, for the declaration of _exit().

2019-09-01  Bruno Haible  <bruno@clisp.org>

	build: Add support for shallow-cloning of subdirectories.
	* gitsub.sh (func_usage): Document allowed git options with 'git pull'.
	(func_pull): Accept GIT_OPTIONS argument.
	(pull): Parse git options before complaining about too many arguments.
	Pass the git options to func_pull.

2019-08-25  Bruno Haible  <bruno@clisp.org>

	xgettext: Assume that Python source files are in UTF-8 by default.
	Reported by ilias iliadis <apiuano-bugs@yahoo.gr>
	at <https://savannah.gnu.org/bugs/?55231>.

	* gettext-tools/src/xg-encoding.h (xgettext_global_source_encoding): Allow a
	NULL value.
	* gettext-tools/src/xg-encoding.c (xgettext_global_source_encoding): Likewise.
	* gettext-tools/src/xgettext.c (main): Initialize
	xgettext_global_source_encoding with NULL, not "ASCII". Handle a NULL
	xgettext_global_source_encoding.
	(extract_from_file): Use ASCII as default for xgettext_global_source_encoding.
	* gettext-tools/src/x-javascript.c (extract_javascript): Likewise.
	* gettext-tools/src/x-python.c (phase2_getc): Signal an error when encountering
	an invalid or incomplete UTF-8 character.
	(set_current_file_source_encoding): In the error message, use
	xgettext_current_file_source_encoding instead of
	xgettext_global_source_encoding.
	(extract_python): Use UTF-8 as default for xgettext_global_source_encoding.
	* gettext-tools/tests/xgettext-python-3: Verify that if the source file has no
	magic coding comment but is UTF-8 encoded, xgettext succeeds.
	* NEWS: Mention the change.

2019-08-25  Bruno Haible  <bruno@clisp.org>

	Add support for Java format strings in the Formatter syntax.
	* gettext-tools/src/message.h (format_type): Add format_java_printf.
	(NFORMATS): Increment.
	* gettext-tools/src/message.c (format_language, format_language_pretty): Add
	entry for format_java_printf.
	* gettext-tools/src/format.h (formatstring_java_printf): New declaration.
	* gettext-tools/src/format-java.c: Update comments.
	* gettext-tools/src/format-java-printf.c: New file.
	* gettext-tools/src/format.c (formatstring_parsers): Add entry for
	format_java_printf.
	* gettext-tools/src/x-java.h (SCANNERS_JAVA): Use formatstring_java_printf.
	* gettext-tools/src/x-java.c (init_flag_table_java): Add entries relevant to
	format strings in Formatter syntax.
	* gettext-tools/src/xgettext.c (xgettext_record_flag): Add support for
	format_java_printf.
	* gettext-tools/src/FILES: Add format-java-printf.c.
	* gettext-tools/src/Makefile.am (FORMAT_SOURCE): Add format-java-printf.c.
	* gettext-tools/woe32dll/gettextsrc-exports.c: Export formatstring_java_printf.
	* gettext-tools/libgettextpo/Makefile.am (libgettextpo_la_AUXSOURCES): Likewise.
	* gettext-tools/tests/xgettext-6 (xg-test6.java): Add test for recognition of
	format strings in Formatter syntax.
	* gettext-tools/tests/format-java-printf-1: New file.
	* gettext-tools/tests/format-java-printf-2: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add them.
	* gettext-tools/tests/lang-java: Add two uses of String.format to the program.
	* gettext-tools/doc/gettext.texi (PO Files): Document java-printf-format and
	no-java-printf-format.
	(java-format): Describe both kinds of format strings. Update URLs.
	(Java): Mention the second kind of format string as well.
	* NEWS: Mention the improvement.

2019-08-25  Bruno Haible  <bruno@clisp.org>

	tests: Remove comments about GCJ.
	We don't support GCJ any more since 2017-05-04.

	* gettext-tools/tests/lang-java: Remove comment about failure with GCJ.
	* gettext-tools/tests/msgunfmt-java-1: Likewise.

2019-08-25  Bruno Haible  <bruno@clisp.org>

	Update compile-command in comments.
	* gettext-tools/src/format-*.c: Fix -I options in compile-command.

	desktop: Small parser fix.
	* gettext-tools/src/read-desktop.c (desktop_lex): Fix handling of control
	characters in group names.

	code style: Avoid gratuitous 'continue;' statements.
	* gettext-tools/src/file-list.c (read_names_from_file): Use 'if' instead of
	'continue'.
	* gettext-tools/src/its.c (its_rule_list_add_from_doc): Likewise.
	* gettext-tools/src/locating-rule.c (locating_rule_list_add_from_file):
	Likewise.
	* gettext-tools/src/msgfmt.c (get_languages): Likewise.
	* gettext-tools/src/x-javascript.c (phase5_scan_xml_markup): Likewise.
	* gettext-tools/src/x-lua.c (phase2_getc): Likewise.
	* gettext-tools/src/read-desktop.c (desktop_lex): Use 'if' instead of 'switch'
	with few alternatives. Test for EOF first.

2019-08-24  Bruno Haible  <bruno@clisp.org>

	autogen.sh: Make more reliable.
	* autogen.sh: Really bail out if gnulib-tool fails to copy config.{guess,sub}.

2019-08-22  Bruno Haible  <bruno@clisp.org>

	xgettext: Handle newlines in Lua long bracket literal strings correctly.
	Reported by Frans de Jonge <fransdejonge@gmail.com>
	at <https://savannah.gnu.org/bugs/?56794>.

	* gettext-tools/src/x-lua.c (phase3_get): Test for EOF first. After an opening
	long bracket, swallow one newline.
	* gettext-tools/tests/xgettext-lua-1: Add tests for newlines in long brackets.
	* gettext-tools/tests/xgettext-lua-2: Update comment.

2019-08-19  Bruno Haible  <bruno@clisp.org>

	xgettext: Recognize gettext -e invocations in shell parser.
	Reported by Eugene V. Lyubimkin <jackyf.devel@gmail.com>
	in <https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=507091>.

	* gettext-runtime/src/escapes.h: New file, extracted from
	gettext-runtime/src/gettext.c.
	* gettext-runtime/src/gettext.c: Include escapes.h.
	(expand_escape): Remove function.
	(inhibit_added_newline): New variable.
	(add_newline): Remove variable.
	(main): Initialize inhibit_added_newline. Invoke expand_escapes instead of
	expand_escape.
	* gettext-runtime/src/ngettext.c: Include escapes.h.
	(expand_escape): Remove function.
	(main): Invoke expand_escapes instead of expand_escape.
	* gettext-runtime/src/Makefile.am (gettext_SOURCES, ngettext_SOURCES): Add
	escapes.h.
	* gettext-tools/tests/tstgettext.c: Include escapes.h.
	(expand_escape): Remove function.
	(inhibit_added_newline): New variable.
	(add_newline): Remove variable.
	(main): Initialize inhibit_added_newline. Invoke expand_escapes instead of
	expand_escape.
	* gettext-tools/tests/Makefile.am (tstgettext_SOURCES): Add escapes.h.
	* gettext-tools/src/x-sh.c: Include escapes.h.
	(read_command): Recognize a '-e' option in the argument list of gettext and
	ngettext.
	* gettext-tools/src/Makefile.am (xgettext_SOURCES): Add escapes.h.
	* gettext-tools/tests/xgettext-sh-1: Test the recognition of gettext -e
	arguments.
	* NEWS: Mention the change.

2019-08-19  Bruno Haible  <bruno@clisp.org>

	doc: Fix documentation of gettext, ngettext programs.
	* gettext-runtime/doc/rt-gettext.texi: Clarify when the additional newline is
	emitted.
	* gettext-runtime/doc/rt-ngettext.texi: Remove '\c' from the list of recognized
	escape sequences.

	Update after gnulib changed.
	* gettext-runtime/intl/localcharset.c: Update from gnulib.
	* gettext-runtime/intl/verify.h: Likewise.

	gettext, ngettext: Fix the expansion of '\\' and octal escape sequences.
	* gettext-runtime/src/gettext.c (expand_escape): Don't swallow the expansion
	of '\\' and octal escape sequences.
	* gettext-runtime/src/ngettext.c (expand_escape): Likewise.
	* gettext-tools/tests/tstgettext.c (expand_escape): Likewise.
	* NEWS: Mention the change.

2019-08-19  Bruno Haible  <bruno@clisp.org>

	xgettext: Fix parsing of escaped single-quote characters in shell parser.
	Reported by Markus Gothe <nietzsche@lysator.liu.se>
	at <https://savannah.gnu.org/bugs/?49809>.

	* gettext-tools/src/x-sh.c (phase2_getc): Handle the case c == '\''
	&& !open_singlequote && !open_doublequote differently.
	* gettext-tools/tests/xgettext-sh-1: Add test with an escape single-quote.

2019-08-19  Bruno Haible  <bruno@clisp.org>

	xgettext: Fix endless loop in shell parser.
	Reported by Hanno Boeck at <https://savannah.gnu.org/bugs/?45408>.
	Based on patch by Daiki Ueno.

	* gettext-tools/src/x-sh.c (read_word): React on CLOSING_BACKQUOTE even when we
	are currently not looking for a closing backquote.

2019-08-18  Bruno Haible  <bruno@clisp.org>

	build: Don't use an obsolete libtool macro.
	* gettext-tools/m4/exported.m4 (gt_GLOBAL_SYMBOL_PIPE): Require
	_LT_CMD_GLOBAL_SYMBOLS, not AC_LIBTOOL_SYS_GLOBAL_SYMBOL_PIPE.

	Update to the newest gnulib.

	libtextstyle: Fix VPATH build (regression from yesterday).
	* libtextstyle/lib/Makefile.am (AM_CPPFLAGS): Search also the glib subdirectory
	of the build dir.

2019-08-18  Bruno Haible  <bruno@clisp.org>

	Don't extract Icon values from .desktop files into POT files.
	Reported by Piotr Drąg <piotrdrag@gmail.com>
	at <https://savannah.gnu.org/support/?108887>
	and by Will Thompson <wjt@endlessm.com>
	at <https://savannah.gnu.org/bugs/?56543>.

	There was a discussion starting at
	<https://lists.freedesktop.org/archives/xdg/2019-June/014158.html>.
	The most interesting posts in this thread were
	<https://lists.freedesktop.org/archives/xdg/2019-June/014164.html>
	<https://lists.freedesktop.org/archives/xdg/2019-June/014167.html>.

	* gettext-tools/doc/gettext.texi (Icons): New subsubsection.
	* gettext-tools/src/read-desktop.c (desktop_add_default_keywords): Don't add
	"Icon".
	* gettext-tools/src/x-desktop.c: Update comments.
	* gettext-tools/doc/xgettext.texi (Desktop): Remove 'Icon' from the list of
	extracted keys.
	* gettext-tools/tests/xgettext-desktop-2: New file.
	* gettext-tools/tests/msgfmt-desktop-3: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add them.
	* NEWS: Mention the change.

2019-08-18  Bruno Haible  <bruno@clisp.org>

	maint: Document how to deal with the build error in gettext-tools/examples/po.
	Reported by Nick Alcock <nix@esperi.org.uk>
	at <https://savannah.gnu.org/bugs/?56529>.

	* HACKING (Building off the Git repository): Explain the common build error and
	how to fix it.

2019-08-17  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Upgrade to libcroco-0.6.13.
	This fixes a couple of warnings.

	Reported by Frank Hunleth <fhunleth@troodon-software.com>
	at <https://savannah.gnu.org/bugs/?55356>.

	* libtextstyle/gnulib-local/lib/libcroco/*: Upgrade to version 0.6.13.
	* libtextstyle/gnulib-local/modules/libcroco: Update.
	* libtextstyle/gnulib-local/lib/glib/gmacros.in.h: New file, based on
	glib-2.12.4/glib/gmacros.h.
	* libtextstyle/gnulib-local/lib/glib/gprintfint.in.h: New file, based on
	glib-2.12.4/glib/gprintfint.h.
	* libtextstyle/Makefile.am (EXTRA_DIST): Add them.
	* libtextstyle/gnulib-local/m4/libglib.m4 (gl_LIBGLIB): Add glib/gmacros.h and
	glib/gprintfint.h to LIBGLIB_H.
	* libtextstyle/gnulib-local/modules/libglib (Files): Add lib/glib/gmacros.in.h,
	lib/glib/gprintfint.in.h.
	(Depends-on): Add snprintf-posix.
	(glib/gmacros.h, glib/gprintfint.h): New rules.
	(MOSTLYCLEANFILES): Add glib/gmacros.h, glib/gprintfint.h.
	* libtextstyle/gnulib-local/lib/glib.in.h: Include glib/gmacros.h.
	* libtextstyle/gnulib-local/lib/glib/gstrfuncs.in.h (g_ascii_dtostr,
	g_ascii_formatd, g_ascii_strcasecmp): Enable declarations.
	* libtextstyle/gnulib-local/lib/glib/gstrfuncs.c: Include gprintfint.h.
	(g_ascii_dtostr, g_ascii_formatd): Enable.
	(ISSPACE, ISUPPER, ISLOWER, ISALPHA, TOUPPER, TOLOWER): Move out of function
	g_parse_long_long.
	(g_ascii_strcasecmp): Enable.

2019-08-14  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Document the hyperlink support.
	* libtextstyle/doc/libtextstyle.texi (The NO_TERM_HYPERLINKS variable): New
	section.
	(Hyperlinks): New subsection.
	(The abstract styled_ostream class): Document styled_ostream_get_hyperlink_ref,
	styled_ostream_get_hyperlink_id, styled_ostream_set_hyperlink.
	(The term_ostream class): Document term_ostream_get_hyperlink_ref,
	term_ostream_get_hyperlink_id, term_ostream_set_hyperlink.
	(The html_ostream class): Document html_ostream_get_hyperlink_ref,
	html_ostream_set_hyperlink_ref.
	* libtextstyle/NEWS: Mention it.

	libtextstyle: styled-ostream: Add hyperlink support.
	* libtextstyle/gnulib-local/lib/styled-ostream.oo.h (struct styled_ostream): Add
	methods get_hyperlink_ref, get_hyperlink_id, set_hyperlink.
	* libtextstyle/gnulib-local/lib/term-styled-ostream.oo.c
	(term_styled_ostream::get_hyperlink_ref, term_styled_ostream::get_hyperlink_id,
	term_styled_ostream::set_hyperlink): New functions.
	* libtextstyle/gnulib-local/lib/html-styled-ostream.oo.c
	(struct html_styled_ostream): Add field hyperlink_id.
	(html_styled_ostream::free): Free the hyperlink_id field.
	(html_styled_ostream::get_hyperlink_ref, html_styled_ostream::get_hyperlink_id,
	html_styled_ostream::set_hyperlink): New functions.
	(html_styled_ostream_create): Initialize the hyperlink_id field.
	* libtextstyle/gnulib-local/lib/noop-styled-ostream.oo.c
	(struct noop_styled_ostream): Add fields hyperlink_ref, hyperlink_id.
	(noop_styled_ostream::free): Free the hyperlink_ref and hyperlink_id fields.
	(noop_styled_ostream::get_hyperlink_ref, noop_styled_ostream::get_hyperlink_id,
	noop_styled_ostream::set_hyperlink): New functions.
	(noop_styled_ostream_create): Initialize the hyperlink_ref and hyperlink_id
	fields.
	* libtextstyle/lib/textstyle.h (styled_ostream_get_hyperlink_ref,
	styled_ostream_get_hyperlink_id, styled_ostream_set_hyperlink,
	term_styled_ostream_get_hyperlink_ref, term_styled_ostream_get_hyperlink_id,
	term_styled_ostream_set_hyperlink, html_styled_ostream_get_hyperlink_ref,
	html_styled_ostream_get_hyperlink_id, html_styled_ostream_set_hyperlink,
	noop_styled_ostream_get_hyperlink_ref, noop_styled_ostream_get_hyperlink_id,
	noop_styled_ostream_set_hyperlink): New declarations.
	* libtextstyle/adhoc-tests/hello.c (main): Invoke styled_ostream_set_hyperlink.

	libtextstyle: html-ostream: Add hyperlink support.
	* libtextstyle/gnulib-local/lib/html-ostream.oo.h (struct html_ostream): Add
	methods get_hyperlink_ref, set_hyperlink_ref.
	* libtextstyle/gnulib-local/lib/html-ostream.oo.c (struct html_ostream): Add
	field hyperlink_ref;
	(write_attribute_value): New function.
	(html_ostream::free): Emit an anchor end if needed.
	(html_ostream::get_hyperlink_ref, html_ostream::set_hyperlink_ref): New
	functions.
	(html_ostream_create): Initialize the hyperlink_ref field.
	* libtextstyle/lib/textstyle.h (html_ostream_get_hyperlink_ref,
	html_ostream_set_hyperlink_ref): New declarations.

	libtextstyle: term-ostream: Add hyperlink support.
	* libtextstyle/gnulib-local/lib/term-ostream.oo.h (struct term_ostream): Add
	methods get_hyperlink_ref, get_hyperlink_id, set_hyperlink.
	* libtextstyle/gnulib-local/lib/term-ostream.oo.c: Include <stdint.h>,
	<sys/time.h>, get_ppid_of.h, get_progname_of.h, xgethostname.h.
	(hyperlink_t): New type.
	(free_hyperlink): New function.
	(attributes_t): Add 'hyperlink' field.
	(equal_attributes): Compare also the 'hyperlink' field.
	(struct term_ostream): Add fields supports_hyperlink, restore_hyperlink,
	hostname_hash, start_time, id_serial, hyperlinks_array, hyperlinks_count,
	hyperlinks_allocated, active_attr_hyperlink.
	(simplify_attributes): Deal with 'hyperlink' field.
	(generate_hyperlink_id): New function.
	(out_hyperlink_change): New function.
	(out_attr_change): Set active_attr_hyperlink. Invoke out_hyperlink_change.
	(restore, async_restore): Use stream->restore_hyperlink.
	(async_set_attributes_from_default): Invoke out_hyperlink_change.
	(output_buffer): At the end, free the unused hyperlink_t objects.
	(term_ostream::free): Free the hyperlinks_array and its contents.
	(term_ostream::get_hyperlink_ref, term_ostream::get_hyperlink_id,
	term_ostream::set_hyperlink): New functions.
	(get_terminal_emulator_progname, should_enable_hyperlinks): New functions.
	(term_ostream_create): Set the fields supports_hyperlink, restore_hyperlink,
	hostname_hash, start_time, id_serial, hyperlinks_array, hyperlinks_count,
	hyperlinks_allocated.
	* libtextstyle/gnulib-local/m4/term-ostream.m4 (gl_TERM_OSTREAM): Test for
	getsid function.
	* libtextstyle/gnulib-local/modules/term-ostream (Depends-on): Add gettimeofday,
	get_ppid_of, get_progname_of, stdint, xgethostname.
	* libtextstyle/lib/textstyle.h (term_ostream_get_hyperlink_ref,
	term_ostream_get_hyperlink_id, term_ostream_set_hyperlink): New declarations.

	Update to the newest gnulib.

2019-08-14  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Support the NO_COLOR environment variable.
	It follows the specification at https://no-color.org/.

	The support is in the example programs, not in the function
	styled_ostream_create, so that it can be overridden through the command-line
	option --color=always.

	We only test whether the environment variable is set, not whether its value
	is non-empty. POSIX-specified environment variables are treated like unset
	when their value is empty; this is because in the old days it was not possible
	to unset an environment variable. But nowadays:
	  - all shells support the 'unset' built-in,
	  - all platforms that have the setenv() function also have the unsetenv()
	    function, and
	  - the 'env' program from GNU coreutils supports --unset=VARIABLE to unset a
	    variable.
	This makes it possible to unset an environment variable that is set by the
	parent process.

	* libtextstyle/adhoc-tests/hello.c (main): Do not emit styling when the
	environment variable NO_COLOR is set.
	* libtextstyle/examples/color-filter/filter.c (main): Likewise.
	* libtextstyle/examples/color-hello/hello.c (main): Likewise.
	* gettext-tools/src/write-catalog.c (msgdomain_list_print): Likewise.
	* libtextstyle/doc/libtextstyle.texi (The NO_COLOR variable): New section.
	* libtextstyle/NEWS: Mention it.

2019-08-12  Bruno Haible  <bruno@clisp.org>

	xalloc: Add x2realloc function, from gnulib.
	* gnulib-local/lib/xalloc.h (x2realloc): New declaration, from
	gnulib/lib/xalloc.h.
	* gnulib-local/lib/xmalloc.c (x2nrealloc): New function, from
	gnulib/lib/xalloc.h.
	(x2realloc): New function, from gnulib/lib/xmalloc.c.
	* gnulib-local/modules/xalloc (configure.ac): Require AC_C_INLINE.

	Drop our xalloc_oversized macro in favour of gnulib's xalloc_oversized macro.
	* gnulib-local/lib/xalloc.h: Include xalloc-oversized.h.
	(xalloc_oversized): Remove macro.
	* gnulib-local/modules/xalloc (Depends-on): Add 'xalloc-oversized'.

2019-07-28  Bruno Haible  <bruno@clisp.org>

	xgettext: Fix parsing of JavaScript template literals inside functions.
	Reported by Dmitry Vinnik <vinnik.dmitry07@gmail.com>
	in <https://savannah.gnu.org/bugs/?56678>.

	* gettext-tools/src/x-javascript.c (brace_depths, brace_depths_alloc): New
	variables.
	(brace_depth): Remove variable.
	(new_brace_depth_level): New function.
	(phase5_get): Invoke it. Access the top of the brace_depths stack.
	(extract_javascript): Don't set brace_depth. Invoke new_brace_depth_level
	instead.
	* gettext-tools/tests/xgettext-javascript-7: Test template literals inside a
	function.

2019-07-28  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2019-07-21  Bruno Haible  <bruno@clisp.org>

	Fix test failure on MSVC.
	* gettext-tools/tests/lang-c++: On MSVC, use <iostream>, not <iostream.h>.

	Update after gnulib changed.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC_COMMON_DEPENDENCIES): Add
	windows-rwlock.
	* gettext-runtime/intl/windows-rwlock.h: New file, from gnulib.
	* gettext-runtime/intl/windows-rwlock.c: New file, from gnulib.
	* gettext-runtime/intl/windows-initguard.h: New file, from gnulib.
	* gettext-runtime/intl/windows-spinlock.h: Remove file.
	* gettext-runtime/intl/lock.h: Update from gnulib.
	* gettext-runtime/intl/lock.c: Likewise.
	* gettext-runtime/intl/verify.h: Likewise.
	* gettext-runtime/intl/windows-mutex.h: Likewise.
	* gettext-runtime/intl/windows-recmutex.h: Likewise.
	* gettext-runtime/intl/Makefile.am (EXTRA_DIST): Add windows-rwlock.h,
	windows-initguard.h. Remove windows-spinlock.h.
	(LIBINTLSOURCES): Conditionally add windows-rwlock.c.
	(windows-rwlock.lo): New rule.
	(*.lo): Update dependencies.
	* Makefile.am (distcheck-hook): Check that gettext-runtime/intl/windows-*.[hc]
	are up-to-date.
	* gnulib-local/lib/libxml/threads.c: Test HAVE_PTHREAD_H, HAVE_WIN32_THREADS,
	HAVE_BEOS_THREADS only if LIBXML_THREAD_ENABLED is defined; otherwise use a
	fallback suitable for single-threaded applications.

2019-07-20  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2019-07-19  Bruno Haible  <bruno@clisp.org>

	build: Avoid warnings from bison versions >= 3.3.
	Reported by Bernhard Voelker <mail@bernhard-voelker.de>.

	* gettext-runtime/intl/Makefile.am (YACC): Remove option '-y'.

2019-07-19  Bruno Haible  <bruno@clisp.org>

	intl: Make autoconf macro more robust.
	Reported by Bernhard Voelker <mail@bernhard-voelker.de>.

	* gettext-runtime/m4/intl.m4 (gt_INTL_SUBDIR_CORE): Don't make assumptions about
	the version numbers of future Bison versions.

2019-07-17  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Fix link error when compiled with GCC 3.3.x.
	Reported by Jeffrey Walton <noloader@gmail.com>.

	* gnulib-local/lib/libxml/timsort.h (CLZ): Don't define based on __builtin_clzll
	in GCC versions < 3.4.

2019-07-07  Bruno Haible  <bruno@clisp.org>

	intl: Don't export the glwthread* symbols from libintl on native Windows.
	* gettext-runtime/intl/Makefile.am (OTHER_LDFLAGS): Add an -export-symbols-regex
	option.

2019-07-04  Bruno Haible  <bruno@clisp.org>

	build: Fix build errors with MSVC.
	* gettext-tools/src/lang-table.h (language_table, language_variant_table):
	Declare with C linkage.
	* gettext-tools/src/read-po.h (input_format_po): Likewise.
	* gettext-tools/src/read-properties.h (input_format_properties): Likewise.
	* gettext-tools/src/read-stringtable.h (input_format_stringtable): Likewise.
	* gettext-tools/src/write-properties.h (output_format_properties): Likewise.
	* gettext-tools/src/write-stringtable.h (output_format_stringtable): Likewise.

	build: Fix build error with MSVC.
	* gettext-runtime/intl/Makefile.am (INTL_WINDOWS_LIBS): New variable.
	(OTHER_LDFLAGS): Add it.

	build: Fix build error with MSVC.
	* gettext-runtime/intl/export.h (LIBINTL_DLL_EXPORTED): Define differently for
	MSVC.

	build: Fix build errors with MSVC.
	* gettext-tools/libgettextpo/exported.sh.in: Remove one level of eval.
	* gettext-tools/libgettextpo/Makefile.am (config.h): Redirect compiler output to
	stderr. Remove symbols that contain an '@'.
	* libtextstyle/lib/Makefile.am (config.h): Likewise.

	Update after gnulib changed.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC_COMMON_DEPENDENCIES): Add
	windows-mutex, windows-once, windows-recmutex.
	* gettext-runtime/m4/flexmember.m4: Update from gnulib.
	* gettext-runtime/intl/flexmember.h: Likewise.
	* gettext-runtime/intl/localcharset.c: Likewise.
	* gettext-runtime/intl/windows-mutex.h: New file, from gnulib.
	* gettext-runtime/intl/windows-mutex.c: New file, from gnulib.
	* gettext-runtime/intl/windows-once.h: New file, from gnulib.
	* gettext-runtime/intl/windows-once.c: New file, from gnulib.
	* gettext-runtime/intl/windows-recmutex.h: New file, from gnulib.
	* gettext-runtime/intl/windows-recmutex.c: New file, from gnulib.
	* gettext-runtime/intl/windows-spinlock.h: New file, from gnulib.
	* gettext-runtime/intl/lock.h: Update from gnulib.
	* gettext-runtime/intl/lock.c: Likewise.
	* gettext-runtime/intl/Makefile.am (EXTRA_DIST): Add windows-*.h.
	(LIBINTLSOURCES): Conditionally add windows-*.c.
	(windows-mutex.lo, windows-recmutex.lo, windows-once.lo): New rules.
	(*.lo): Update dependencies.
	* gettext-runtime/configure.ac: New condition WINDOWS_NATIVE.
	* gettext-tools/configure.ac: Likewise.
	* Makefile.am (distcheck-hook): Check that gettext-runtime/intl/windows-*.[hc]
	are up-to-date.

	Update to the newest gnulib.

2019-05-20  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* gettext-runtime/intl/setlocale.c (search): Optimize away a redundant strcmp()
	invocation.
	(locales_with_principal_territory): New array.
	(langcmp, get_main_locale_with_same_language): New functions.
	(locales_with_principal_language): New array.
	(terrcmp, get_main_locale_with_same_territory): New functions.
	(rpl_setlocale): When setlocale_single failed, try again with a locale that is
	more likely to exist. Don't warn if the environment variable SETLOCALE_VERBOSE
	is not set.

	Update after gnulib changed.
	* gettext-runtime/m4/intlmacosx.m4 (gt_INTL_MACOSX): Don't test for
	CFLocaleCopyCurrent.
	* gettext-runtime/intl/localename.c: Remove includes for
	HAVE_CFLOCALECOPYCURRENT.
	(gl_locale_name_environ, gl_locale_name_default): Remove code for
	HAVE_CFLOCALECOPYCURRENT.

	Update to the newest gnulib.

	msginit: Define default territory for some more languages.
	* gettext-tools/src/msginit.c (catalogname_for_locale): Add information about
	Bislama, Kyrgyz, Mauritian Creole, Chichewa, Kinyarwanda, Tok Pisin.

	Update a country name.
	* gettext-tools/doc/ISO_3166: Write "North Macedonia", not "Macedonia".
	* gettext-tools/doc/iso-3166.texi: Likewise.
	* gettext-tools/src/msginit.c (catalogname_for_locale): Likewise.

	build: Avoid endless "config.status --recheck" loop (regression from yesterday).
	* gettext-tools/configure.ac: Use AC_MSG_WARN instead of AC_MSG_ERROR.

	intl: Work around setlocale bug on Android 4.3.
	* gettext-runtime/intl/setlocale.c (setlocale_unixlike): New wrapper for
	Android.

2019-05-19  Bruno Haible  <bruno@clisp.org>

	msgmerge: Fix behaviour of --for-msgfmt on PO files with no translations.
	Reported by Don Lawrence <dlawrence@iecok.com>
	in <https://lists.freedesktop.org/archives/p11-glue/2019-May/000700.html>
	via Daiki Ueno
	in <https://lists.gnu.org/archive/html/bug-gettext/2019-05/msg00124.html>.

	* gettext-tools/src/msgmerge.c (main): Treat force_po like true if for_msgfmt
	is true.
	* gettext-tools/tests/msgmerge-26: Add test of PO file with no translations.

2019-05-19  Bruno Haible  <bruno@clisp.org>

	build: Restore the ability to build gettext-tools separately, part 2.
	* gettext-tools/configure.ac: New option --with-installed-csharp-dll.
	(USE_INSTALLED_CSHARP_DLL): New conditional.
	* gettext-tools/src/Makefile.am (CSHARP_DLL_DIR): New variable.
	(msgunfmt.net.exe): Use it.
	* configure.ac: Filter out --with-installed-csharp-dll from inherited --help
	output.
	* PACKAGING: Document that gettext-tools's configure needs to be invoked with
	--with-installed-csharp-dll.

2019-05-19  Bruno Haible  <bruno@clisp.org>

	build: Restore the ability to build gettext-tools separately, part 1.
	Reported by Hanspeter Niederstrasser <nieder@users.sourceforge.net>
	in <https://savannah.gnu.org/bugs/?56333>.

	Code based on patch by Miguel Ángel Arruga Vivas <rosen644835@gmail.com>.

	* autogen.sh: Copy libtextstyle.m4 for use by gettext-tools.
	* gettext-tools/configure.ac: New option --with-installed-libtextstyle.
	(USE_INSTALLED_LIBTEXTSTYLE): New conditional.
	* gettext-tools/src/Makefile.am (textstyle.h): Disable rule if
	USE_INSTALLED_LIBTEXTSTYLE is true.
	(LT_LIBTEXTSTYLE): New variable.
	(libgettextsrc_la_LDFLAGS): Use it instead of hardcoding a relative filename of
	libtextstyle.la.
	* configure.ac: Filter out --with-installed-libtextstyle from inherited --help
	output.
	* Makefile.am (distcheck-hook): Compare different copies of libtextstyle.m4.
	* PACKAGING: Document that gettext-tools's configure needs to be invoked with
	--with-installed-libtextstyle.

2019-05-19  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Complete commit from 2019-04-28.
	* libtextstyle/Makefile.am (EXTRA_DIST): Add
	test-term-ostream-xterm-freebsd-italic.out.

	build: Avoid the use of mingw winpthreads for multithreading.
	* gettext-runtime/configure.ac: Invoke gl_AVOID_WINPTHREAD.
	* gettext-tools/configure.ac: Likewise.

	Update to the newest gnulib.

2019-05-18  Bruno Haible  <bruno@clisp.org>

	build: Avoid trouble on mingw caused by mingw's *printf functions.
	Reported by Michele Locati <michele@locati.it>
	in <https://lists.gnu.org/archive/html/bug-gettext/2019-05/msg00103.html>.

	* gettext-runtime/intl/Makefile.am (AM_CPPFLAGS): Define __USE_MINGW_ANSI_STDIO
	to 0.
	* gettext-runtime/libasprintf/Makefile.am (DEFS): Likewise.
	* libtextstyle/lib/Makefile.am (AM_CPPFLAGS): Likewise.

2019-05-18  Bruno Haible  <bruno@clisp.org>

	libasprintf: Avoid compilation error on mingw with -D__USE_MINGW_ANSI_STDIO=1.
	* gettext-runtime/libasprintf/lib-asprintf.c (asprintf, vasprintf): Don't define
	on mingw when __USE_MINGW_ANSI_STDIO is non-zero.

2019-05-18  Bruno Haible  <bruno@clisp.org>

	doc: Don't mention trademarks.
	Reported by John Darrington <john@darrington.wattle.id.au>
	in <https://savannah.gnu.org/bugs/?56340>.

	* gettext-tools/doc/gettext.texi (catgets): Drop trademark annotation.

2019-05-18  Bruno Haible  <bruno@clisp.org>

	build: Fix typo in comment.
	* check-copyright-headers: Fix typo in comment.

2019-05-12  Bruno Haible  <bruno@clisp.org>

	build: Fix "make install" failure with --disable-shared on glibc systems.
	Reported by Gabor Z. Papp <gzp@papp.hu>.

	This is a regression from 2018-11-25.

	* gettext-tools/configure.ac (PRELOADABLE_LIBINTL): Set to false if
	--disable-shared was specified.

2019-05-12  Bruno Haible  <bruno@clisp.org>

	Update translations (from the TP).

	Update release steps.

2019-05-12  Bruno Haible  <bruno@clisp.org>

	intl: Fix wrong libtool versioning information.
	Reported by Ken Takata <ktakata65536@gmail.com>
	in <https://savannah.gnu.org/bugs/?56305>.

	* gettext-runtime/intl/Makefile.am (LTV_*): Bump to 9:6:1, not 9:6:2.
	* NEWS: Mention the change.

2019-05-12  Bruno Haible  <bruno@clisp.org>

	Update bug reporting instructions.
	* README: Tell users to report bugs in the bug tracker or by email. Use the
	mailing list address, not the alias.
	* gettext-runtime/libasprintf/README: Likewise.
	* gettext-tools/doc/gettext.texi (Introduction): Likewise.
	(Plural forms): Use the mailing list address, not the alias.
	* configure.ac (AC_INIT): Use the mailing list address, not the alias.
	* gettext-runtime/configure.ac (AC_INIT): Likewise.
	* gettext-tools/configure.ac (AC_INIT): Likewise.
	* gettext-tools/examples/configure.ac (AC_INIT): Likewise.
	* gettext-runtime/po/Makevars (MSGID_BUGS_ADDRESS): Use the mailing list
	address, not the alias.
	* gettext-tools/po/Makevars (MSGID_BUGS_ADDRESS): Likewise.
	* gettext-tools/examples/po/Makefile.am (MSGID_BUGS_ADDRESS): Likewise.
	* gettext-tools/examples/hello-*/po/Makevars (MSGID_BUGS_ADDRESS): Likewise.
	* gettext-tools/examples/hello-*/po/Makefile.am (MSGID_BUGS_ADDRESS): Likewise.
	* gettext-tools/examples/hello-objc-gnustep/po/GNUmakefile (MSGID_BUGS_ADDRESS):
	Likewise.
	* gettext-tools/examples/hello-c++-kde/hello.cc (main): Likewise.
	* gettext-runtime/src/envsubst.c (main): Move URL out of translatable string.
	(usage): Tell users to report bugs in the bug tracker or by email. Use the
	mailing list address, not the alias.
	* gettext-runtime/src/gettext.c: Likewise.
	* gettext-runtime/src/ngettext.c: Likewise.
	* gettext-tools/src/cldr-plurals.c: Likewise.
	* gettext-tools/src/hostname.c: Likewise.
	* gettext-tools/src/msgattrib.c: Likewise.
	* gettext-tools/src/msgcat.c: Likewise.
	* gettext-tools/src/msgcmp.c: Likewise.
	* gettext-tools/src/msgcomm.c: Likewise.
	* gettext-tools/src/msgconv.c: Likewise.
	* gettext-tools/src/msgen.c: Likewise.
	* gettext-tools/src/msgexec.c: Likewise.
	* gettext-tools/src/msgfilter.c: Likewise.
	* gettext-tools/src/msgfmt.c: Likewise.
	* gettext-tools/src/msggrep.c: Likewise.
	* gettext-tools/src/msginit.c: Likewise.
	* gettext-tools/src/msgmerge.c: Likewise.
	* gettext-tools/src/msgunfmt.c: Likewise.
	* gettext-tools/src/msguniq.c: Likewise.
	* gettext-tools/src/recode-sr-latin.c: Likewise.
	* gettext-tools/src/urlget.c: Likewise.
	* gettext-tools/src/xgettext.c: Likewise.
	* gettext-tools/tests/tstgettext.c: Likewise.
	* gettext-tools/tests/tstngettext.c: Likewise.
	* gettext-tools/misc/autopoint.in (func_usage): Tell users to report bugs in the
	bug tracker or by email. Use the mailing list address, not the alias.
	* gettext-tools/misc/convert-archive.in (func_usage): Likewise.
	* gettext-tools/misc/gettextize.in (func_usage): Likewise.

2019-05-11  Bruno Haible  <bruno@clisp.org>

	doc: Recommend to avoid literal URLs in translatable strings.
	Suggested by John Darrington <john@darrington.wattle.id.au>
	in <https://lists.gnu.org/archive/html/bug-gnulib/2019-05/msg00033.html>.

	* gettext-tools/doc/gettext.texi (Preparing Strings): Add recommendation against
	embedded URLs. Add sub-headers.

2019-05-11  Bruno Haible  <bruno@clisp.org>

	build: Fix build failure with parallel make.
	Reported by Lars Wendler <polynomial-c@gentoo.org>.

	* gettext-tools/src/Makefile.am (.NOTPARALLEL): Add this special target.

2019-05-11  Bruno Haible  <bruno@clisp.org>

	intl: Remove obsolete code.
	* gettext-runtime/intl/plural.y: Assume bison >= 2.0.

	Update after gnulib changed.
	* autogen.sh: Don't copy intl.m4.
	* Makefile.am (distcheck-hook): Don't check glibc2.m4, glibc21.m4, intdiv0.m4,
	intl.m4, intmax.m4, printf-posix.m4, uintmax_t.m4, visibility.m4.
	* gettext-runtime/intl/verify.h: Update from gnulib.

	Update to newest gnulib.

2019-05-09  Bruno Haible  <bruno@clisp.org>

	Update release steps.

2019-05-08  Bruno Haible  <bruno@clisp.org>

	examples: Use infrastructure from gettext version 0.20.
	* gettext-tools/examples/hello-*/configure.ac: Use AM_GNU_GETTEXT_VERSION with
	version 0.20.
	* gettext-tools/examples/hello-c++-kde/configure.in.in: Likewise.
	* gettext-tools/examples/hello-*/m4/Makefile.am: Update .m4 file list.
	* gettext-tools/examples/hello-*/autoclean.sh: Likewise.

	Update translations (from the TP).

	Prepare for 0.20 release.
	* gettext-runtime/doc/matrix.texi: Update from TP.
	* gettext-runtime/doc/nls.texi (STATUS): Update.
	* libtextstyle/version.sh: Update RELEASE_DATE.

2019-05-07  Bruno Haible  <bruno@clisp.org>

	libtextstyle: examples: Enable --color=html, for debuggability.
	Reported by Akim Demaille.

	* libtextstyle/examples/color-hello/hello.c (main): Handle color_html case.
	* libtextstyle/examples/color-filter/filter.c (main): Likewise.

2019-05-05  Bruno Haible  <bruno@clisp.org>

	examples: hello-c++-widgets: Update build infrastructure.
	Gnulib changed on 2018-11-11: asm-underscore.m4 is no longer needed for havelib.

	* gettext-tools/examples/hello-c++-widgets/autogen.sh: Don't pull in
	asm-underscore.m4.
	* gettext-tools/examples/hello-c++-widgets/autoclean.sh: Don't remove
	asm-underscore.m4.

2019-05-05  Bruno Haible  <bruno@clisp.org>

	Add unit test for libintl_version.
	* gettext-tools/tests/intl-version-prg.c: New file.
	* gettext-tools/tests/intl-version: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.
	(check_PROGRAMS): Add intl-version-prg.
	(intl_version_prg_SOURCES, intl_version_prg_LDADD): New variables.

2019-05-05  Bruno Haible  <bruno@clisp.org>

	msginit: Avoid error messages when run on mingw.
	Reported by Michele Locati <michele@locati.it>.

	* gettext-tools/src/msginit.c (project_id, project_id_version, get_user_email,
	language_team_address): Don't even attempt to run the shell script.

2019-05-05  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Document debugging tricks.
	Reported by Akim Demaille <akim@lrde.epita.fr>.

	* libtextstyle/doc/libtextstyle.texi (Debugging style files): New subsection.
	(Debugging the styling code): New section.

2019-05-01  Bruno Haible  <bruno@clisp.org>

	msginit: Fix invocation of helper programs on Windows.
	Reported by Michele Locati <michele@locati.it>
	in <https://lists.gnu.org/archive/html/bug-gettext/2019-04/msg00058.html>.

	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC): Add configmake.
	* gettext-tools/src/msginit.c: Include configmake.h.
	(main): Add BINDIR to the PATH.

2019-05-01  Bruno Haible  <bruno@clisp.org>

	msginit: Improvements for Cygwin and Android.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC): Add sh-filename.
	* gettext-tools/src/msginit.c (project_id, project_id_version, get_user_email,
	language_team_address): Use BOURNE_SHELL instead of hardcoding /bin/sh.

2019-04-29  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Document one more terminal emulator.
	* libtextstyle/doc/libtextstyle.texi (Terminal emulators): Mention QTerminal.

2019-04-28  Bruno Haible  <bruno@clisp.org>

	Fix msginit-4 test failure on mingw.
	* gettext-tools/src/Makefile.am (DEFS): Define EXEEXT.
	* gettext-tools/src/msginit.c (plural_forms): On Windows, invoke
	"cldr-plurals.exe", not "cldr-plurals".

2019-04-28  Bruno Haible  <bruno@clisp.org>

	In the POT files, talk about the "GNU gettext package".
	Reported by Benno Schulenberg <coordinator@translationproject.org>.

	* gettext-runtime/po/Makevars (XGETTEXT_OPTIONS): Add --package-name option.
	* gettext-tools/po/Makevars (XGETTEXT_OPTIONS): Likewise.
	* gettext-tools/examples/po/Makefile.am (XGETTEXT_OPTIONS): New variable.

2019-04-28  Bruno Haible  <bruno@clisp.org>

	po: Make it possible to override xgettext options from Makefile.in.in.
	* gettext-runtime/po/Makefile.in.in ($(DOMAIN).pot-update): List the
	XGETTEXT_OPTIONS and the XGETTEXT_EXTRA_OPTIONS after all other options.
	* gettext-tools/examples/po/Makefile.am ($(DOMAIN).pot-update): Likewise.
	* gettext-tools/examples/hello-*/po/Makefile.am ($(DOMAIN).pot-update):
	Likewise.
	* gettext-tools/examples/hello-objc-gnustep/po/GNUmakefile
	($(DOMAIN).pot-update): Likewise.
	* NEWS: Mention the change.
	* gettext-tools/doc/gettext.texi (po/Makevars): Fix typo.

2019-04-28  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Fix test-term-ostream-xterm test failure on TrueOS and Trident.
	The xterm description on these platforms includes support for italics.

	Reported by Nelson H. F. Beebe.

	* libtextstyle/gnulib-local/tests/test-term-ostream-xterm-freebsd-italic.out:
	New file.
	* libtextstyle/gnulib-local/tests/test-term-ostream-xterm.sh: Use it as possible
	expected result.
	* libtextstyle/gnulib-local/modules/term-ostream-tests (Files): Add it.

2019-04-28  Bruno Haible  <bruno@clisp.org>

	libxml: Avoid gcc warnings.
	Avoids "warning: too many arguments for format".

	* gnulib-local/lib/libxml/xmlerror.in.h (__xmlSimpleError): Remove
	LIBXML_ATTR_FORMAT annotation, because this function may be called with a
	NULL msg.

2019-04-28  Bruno Haible  <bruno@clisp.org>

	libxml: Avoid build failure due to "implicit declaration of function".
	* gnulib-local/lib/libxml/libxml.h: Include xmlstring.h only after config.h is
	included.

	libxml: Update included libxml2 to version 2.9.9.
	* gnulib-local/lib/libxml/*: Update from libxml2 2.9.9.
	* gnulib-local/m4/libxml.m4 (gl_LIBXML): Don't test for _stat.

	Update to newest gnulib.

2019-04-28  Bruno Haible  <bruno@clisp.org>

	Fix lang-csharp test failure on DragonFly BSD.
	Reported by Nelson H. F. Beebe.

	* gettext-tools/tests/lang-csharp: For the locale with ISO-8859-1 encoding,
	allow an expected result in UTF-8 encoding.

2019-04-28  Bruno Haible  <bruno@clisp.org>

	Add comment about a test that may fail.
	Reported by Nelson H. F. Beebe.

	* gettext-tools/tests/lang-csharp: Add comment about possible test failure.

2019-04-28  Bruno Haible  <bruno@clisp.org>

	Add comments about tests that fail on Alpine Linux.
	Reported by Nelson H. F. Beebe.

	* gettext-tools/tests/msgconv-2: Add comment about musl libc.
	* gettext-tools/tests/msgmerge-compendium-6: Likewise.
	* gettext-tools/tests/xgettext-python-3: Likewise.

2019-04-28  Bruno Haible  <bruno@clisp.org>

	build: Remove duplicate copy of test-lock.
	The master copy lives in gnulib now.

	* gettext-runtime/tests/test-lock.c: Remove file.
	* gettext-runtime/tests/Makefile.am (TESTS, check_PROGRAMS): Remove test-lock.
	(test_lock_SOURCES, test_lock_LDADD): Remove variables.

2019-04-28  Bruno Haible  <bruno@clisp.org>

	build: Verify that intl/threadlib.c is in sync with gnulib.
	* Makefile.am (distcheck-hook): Compare also intl/threadlib.c.

2019-04-28  Bruno Haible  <bruno@clisp.org>

	Fix autopoint-3 test failure on many platforms.
	Reported by Nelson H. F. Beebe.

	* gettext-tools/tests/autopoint-3: Create dummy ltmain.sh file before invoking
	"automake -a -c".

2019-04-28  Bruno Haible  <bruno@clisp.org>

	Avoid lang-guile test failure on many platforms.
	Reported by Nelson H. F. Beebe.

	* gettext-tools/tests/lang-guile: Skip the test if the guile version is < 2.0.

2019-04-28  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.

	Update to newest gnulib.

2019-04-27  Bruno Haible  <bruno@clisp.org>

	intl: Use the lookup optimization also on platforms without per-thread locales.
	This bug was introduced on 2007-01-27.

	* gettext-runtime/intl/dcigettext.c (DCIGETTEXT): Fix #ifdef/#endif chain.

2019-04-27  Bruno Haible  <bruno@clisp.org>

	po-mode: Fix warning.
	* gettext-tools/emacs/po-mode.el (entry-buffer): Declare as variable.

	libgettextpo: Don't rely on the undocumented variable libgettextpo_program_name.
	* gnulib-local/lib/xerror.c: If IN_LIBGETTEXTPO is defined, include
	getprogname.h instead of progname.h and define program_name as a macro.
	* gnulib-local/lib/error-progname.c: Likewise.
	* gettext-tools/src/po-xerror.c: Likewise.
	* autogen.sh (GNULIB_MODULES_LIBGETTEXTPO): Remove progname.
	Pass --avoid=progname to gnulib-tool invocation for libgettextpo.

	libgettextpo: Fix crash when iconv() does not support the PO file's encoding.
	* gettext-tools/src/po-charset.c (po_lex_charset_set): When IN_LIBGETTEXTPO is
	defined, don't use program_name.

	libgettextpo: Fix gcc warnings.
	* gettext-tools/src/write-po.c (begin_css_class, end_css_class): At least,
	evaluate the classname argument.

	Fix a gcc warning.
	* gettext-tools/src/urlget.c (java_exitcode, execute_it): Don't define if
	USEJAVA is 0.

	Fix a gcc warning on mingw.
	* gettext-tools/src/msginit.c (get_user_pwd): Don't define if HAVE_PWD_H is not
	set.
	(get_user_fullname): Don't call get_user_pwd if HAVE_PWD_H is not set.

	Fix gcc warnings on mingw and IRIX 6.5.
	* gettext-tools/src/msgexec.c (process_message): Don't assume that fprintf
	supports %zu.
	* gettext-tools/src/msgfilter.c (process_message): Likewise.

	Fix gcc warnings on mingw.
	* gettext-tools/src/msgexec.c (close): Undefine before redefinition.
	* gettext-tools/src/msggrep.c (close): Likewise.

	Fix a gcc warning (regression from 2017-05-04).
	* gettext-tools/src/read-java.c (msgdomain_read_java): Remove unused variable.

	search-path.c: Improve code style.
	* gettext-tools/src/search-path.h (get_search_path): Clarify memory allocation.
	* gettext-tools/src/search-path.c (struct path_array_ty): Add comment.
	(foreach_elements): Fix comment.
	(get_search_path): Improve comments. Perform each getenv() only once. Reduce
	scope of variables. Fix gcc warning.

	libxml: Fix width of fprintf argument on native Windows.
	* gnulib-local/lib/libxml/timsort.h (TIM_SORT_RESIZE): Cast fprintf argument to
	'unsigned long'.

	intl: Fix a gcc warning.
	* gettext-runtime/intl/langprefs.c (_nl_language_preferences_win32_95): Declare
	data as BYTE array, not char array.

2019-04-26  Bruno Haible  <bruno@clisp.org>

	build: Fix build failure on mingw with --disable-shared --enable-relocatable.
	Reported by Michele Locati <michele@locati.it>
	in <https://lists.gnu.org/archive/html/bug-gettext/2019-04/msg00052.html>.

	* gettext-runtime/intl/Makefile.am (AM_CPPFLAGS): Map 'relocate2' to a different
	symbol.

2019-04-26  Bruno Haible  <bruno@clisp.org>

	Document the OUTPUT_CHARSET environment variable.
	Reported by Václav Slavík <vaclav@slavik.io>
	via Michele Locati <michele@locati.it>.

	* gettext-tools/doc/gettext.texi (Working in a Windows console): New section.

2019-04-14  Bruno Haible  <bruno@clisp.org>

	Update translations (from the TP).
	* gettext-runtime/po/*.po: Update.
	* gettext-runtime/po/LINGUAS: Add 'ast'.
	* gettext-tools/po/*.po: Update.
	* gettext-tools/examples/po/*.po: Update.
	* gettext-tools/examples/po/LINGUAS: Add 'ta'.
	* gettext-tools/examples/hello-*/po/LINGUAS: Likewise.
	* gettext-tools/examples/Makefile.am (EXAMPLESPOFILES): Add ta.po.

	Prepare for 0.20 release.
	* gettext-runtime/intl/libgnuintl.in.h (LIBINTL_VERSION): Update.
	* gettext-tools/libgettextpo/gettext-po.in.h (LIBGETTEXTPO_VERSION): Update.
	* gettext-runtime/m4/gettext.m4: Bump version number in comment.
	* gettext-runtime/m4/intl.m4: Likewise.
	* gettext-runtime/m4/intlmacosx.m4: Likewise.
	* gettext-runtime/m4/po.m4: Likewise.
	(GETTEXT_MACRO_VERSION): Bump to 0.20.
	* gettext-runtime/po/Makefile.in.in (GETTEXT_MACRO_VERSION): Likewise.
	* gettext-runtime/intl/Makefile.am (LTV_*): Bump to 9:6:2.
	* gettext-tools/libgettextpo/Makefile.am (LTV_*): Bump to 5:5:5.
	* gettext-tools/configure.ac (ARCHIVE_VERSION): Set to 0.20.
	* gettext-tools/misc/autopoint.in: Accept version 0.20.
	* gettext-runtime/doc/matrix.texi: Update from TP.
	* gettext-runtime/doc/nls.texi (STATUS): Update.
	* gettext-runtime/src/envsubst.c (main): Update copyright year in --version
	output.
	* gettext-runtime/src/gettext.c (main): Likewise.
	* gettext-runtime/src/ngettext.c (main): Likewise.
	* gettext-tools/src/cldr-plurals.c (main): Likewise.
	* gettext-tools/src/hostname.c (main): Likewise.
	* gettext-tools/src/msgattrib.c (main): Likewise.
	* gettext-tools/src/msgcat.c (main): Likewise.
	* gettext-tools/src/msgcmp.c (main): Likewise.
	* gettext-tools/src/msgcomm.c (main): Likewise.
	* gettext-tools/src/msgconv.c (main): Likewise.
	* gettext-tools/src/msgen.c (main): Likewise.
	* gettext-tools/src/msgexec.c (main): Likewise.
	* gettext-tools/src/msgfilter.c (main): Likewise.
	* gettext-tools/src/msgfmt.c (main): Likewise.
	* gettext-tools/src/msggrep.c (main): Likewise.
	* gettext-tools/src/msginit.c (main): Likewise.
	* gettext-tools/src/msgmerge.c (main): Likewise.
	* gettext-tools/src/msgunfmt.c (main): Likewise.
	* gettext-tools/src/msguniq.c (main): Likewise.
	* gettext-tools/src/recode-sr-latin.c (main): Likewise.
	* gettext-tools/src/urlget.c (main): Likewise.
	* gettext-tools/src/xgettext.c (main): Likewise.
	* gettext-runtime/src/gettext.sh.in (func_version): Update copyright year.
	* gettext-tools/misc/convert-archive.in (func_version): Likewise.
	* gettext-tools/misc/gettextize.in (func_version): Likewise.
	* libtextstyle/version.sh: Use version number 0.20 here as well.
	* gettext-runtime/NEWS: Mention changes (from main NEWS).
	* libtextstyle/NEWS: Mention changes.

	autopoint: Reject AM_GNU_GETTEXT without 'external' for versions >= 0.20.
	* gettext-tools/misc/autopoint.in: Fail if AM_GNU_GETTEXT without 'external' is
	specified with a gettext version >= 0.20.
	* gettext-tools/tests/autopoint-2: Update. Add two more scenarios.
	* gettext-tools/tests/autopoint-3: Don't test AM_GNU_GETTEXT([use-libtool]) nor
	--with-included-gettext. Don't use libtoolize.

	build: Fix Makefile.am formatting.
	* gettext-runtime/man/Makefile.am: Start every indented line with a tab.

	build: Don't fail copyright header check on archive.dir.tar.
	* check-copyright-headers (func_check_file): Succeed for the archive.dir.tar
	file.

	Update to newest gnulib.

2019-04-13  Bruno Haible  <bruno@clisp.org>

	cldr-plurals: Fix a test failure on IRIX 6.5.
	* gettext-tools/src/cldr-plural-exp.c (cldr_plural_rule_list_print): Don't
	assume that fprintf supports %zu.

	build: Fix build failure when perl exists but not perl's Locale::gettext module.
	* gettext-runtime/man/x-to-1.in: Remove file.
	* gettext-tools/man/x-to-1.in: Remove file.
	* autogen.sh: Copy x-to-1.in from gnulib.

	build: Fix build failure with a preinstalled libxml (regression from 2019-04-02).
	* gettext-tools/src/Makefile.am (AM_CPPFLAGS): Remove -I options that point into
	libtextstyle/lib.
	(textstyle.h): New rule.
	(BUILT_SOURCES, MOSTLYCLEANFILES): Add textstyle.h and textstyle/*.h.

	build: Don't link libgettextlib and libgettextsrc against libgomp.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC): Add openmp-init. Remove openmp.
	* gettext-tools/configure.ac: Invoke AC_OPENMP.

	Update to newest gnulib.

2019-04-12  Bruno Haible  <bruno@clisp.org>

	msgfmt: Fix another buffer overrun.
	Reported and patch by Joshua Root <jmr@macports.org>
	at <https://savannah.gnu.org/bugs/?56126>.

	* gettext-tools/src/write-java.c (write_java_msgid): Allocate memory for the
	trailing NUL byte as well.
	* gettext-tools/src/write-csharp.c (write_csharp_msgid): Likewise.

2019-04-11  Bruno Haible  <bruno@clisp.org>

	build: Explicitly request some more gnulib modules.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC): Add localtime, unsetenv.

	build: Fix build failure on mingw (regression from 2019-04-02).
	* gettext-tools/woe32dll/gettextlib-exports.c: Remove
	gl_array_list_implementation, styled_ostream_typeinfo.
	* gettext-tools/woe32dll/gettextsrc-exports.c: Remove color_mode,
	color_test_mode, style_file_name.
	* autogen.sh: Don't import the gnulib array-list-tests and linkedhash-list-tests
	modules.

	build: Fix build failure on mingw (regression from 2019-04-02).
	* libtextstyle/autogen.sh: Pass a --macro-prefix option to gnulib-tool.
	* libtextstyle/configure.ac: Update accordingly.

	libtextstyle: Fix build failure on mingw (regression from 2019-03-17).
	* libtextstyle/lib/Makefile.am (config.h): Emit a line that ensures that
	isatty.c defines the symbol 'libtextstyle_isatty', not 'isatty'.

2019-04-11  Bruno Haible  <bruno@clisp.org>

	build: Fix build failure on mingw.
	For some reason, Automake puts a definition of CXXLD in
	gettext-tools/src/Makefile.in but not in
	gettext-tools/gnulib-lib/Makefile.in.

	* gettext-tools/gnulib-lib/Makefile.am (CXXLD): Define.

2019-04-10  Bruno Haible  <bruno@clisp.org>

	msgfmt: Fix a buffer overrun.
	Reported by Tobi Schäfer at <https://trac.macports.org/ticket/58323>,
	via Ryan Schmidt <@ryandesign.com> at <https://savannah.gnu.org/bugs/?56112>.
	Patch proposed by Joshua Root.

	* gettext-tools/src/write-java.c (msgid_hashcode): Allocate memory for the
	trailing NUL byte as well.

2019-04-09  Bruno Haible  <bruno@clisp.org>

	Fix test failures on AIX 7.2.
	* gettext-tools/tests/intl-thread-1-prg.c: Test HAVE_WORKING_USELOCALE instead
	of HAVE_USELOCALE.
	* gettext-tools/tests/intl-thread-2-prg.c: Likewise.
	* gettext-tools/tests/intl-thread-3-prg.c: Likewise.

	msgmerge: Fix crash on 32-bit AIX 7.2.
	* gettext-tools/src/msgmerge.c: Include <omp.h>.
	(main): Invoke openmp_init().

	Update to newest gnulib.

2019-04-08  Bruno Haible  <bruno@clisp.org>

	Make sure that libintl.h declares the *wprintf overrides on Windows.
	* gettext-runtime/m4/intl.m4 (AM_INTL_SUBDIR): Test for wprintf, not fwprintf.

	Update to newest gnulib.

2019-04-08  Bruno Haible  <bruno@clisp.org>

	autopoint: Don't risk failing because of user or system git configurations.
	Reported by Jamie Kirkpatrick <jkp@kirkconsulting.co.uk>
	in <https://savannah.gnu.org/support/?107689>.

	* gettext-tools/misc/autopoint.in: Set/unset environment variables, so that git
	does not read the user's git configuration nor the system's git configuration.
	* gettext-tools/misc/convert-archive.in: Likewise.

2019-04-08  Bruno Haible  <bruno@clisp.org>

	xgettext: Recognize ECMAScript-262 6th edition template literals.
	Reported by Philip Chimento <philip.chimento@gmail.com>
	in <https://savannah.gnu.org/bugs/index.php?50920>.

	* gettext-tools/src/x-javascript.c (P7_TEMPLATE_START_OF_EXPRESSION): New macro.
	(enum token_type_ty): Add token_type_template, token_type_ltemplate,
	token_type_mtemplate, token_type_rtemplate.
	(free_token): Treat token_type_template like token_type_string.
	(phase7_getuc): Add support for backquote quote_char.
	(brace_depth, template_literal_depth): New variables.
	(phase5_get): Parse template literals.
	(x_javascript_lex): Treat token_type_template like token_type_string. Handle the
	combination of symbol followed by template.
	(extract_balanced): Treat token_type_template like token_type_string, and
	token_type_ltemplate, token_type_mtemplate, token_type_rtemplate like
	token_type_other.
	(extract_javascript): Initialize brace_depth, template_literal_depth.
	* gettext-tools/tests/xgettext-javascript-7: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.
	* gettext-tools/doc/gettext.texi (JavaScript): Mention the template literal
	syntax for strings.
	* NEWS: Mention the improvement.

2019-04-08  Bruno Haible  <bruno@clisp.org>

	xgettext: Make JavaScript parser more robust.
	* gettext-tools/src/x-javascript.c (extract_javascript): Initialize
	inside_embedded_js_in_xml.

2019-04-07  Bruno Haible  <bruno@clisp.org>

	build: Verify that newly added files have an appropriate copyright notice.
	* check-copyright-headers: New file.
	* Makefile.am (EXTRA_DIST): Add it.
	(distcheck-hook): Run check-copyright-headers and fail if it fails.

2019-04-07  Bruno Haible  <bruno@clisp.org>

	doc: Add copyright notices in several files.
	Reported by <ineiev@gnu.org> in <https://savannah.gnu.org/bugs/?54809>.

	* gettext-runtime/doc/nls.texi: Add delegating copyright notice.
	* gettext-runtime/doc/rt-*.texi: Likewise.
	* gettext-tools/doc/autopoint.texi: Likewise.
	* gettext-tools/doc/gettextize.texi: Likewise.
	* gettext-tools/doc/msg*.texi: Likewise.
	* gettext-tools/doc/xgettext.texi: Likewise.

2019-04-07  Bruno Haible  <bruno@clisp.org>

	build: Unify the three copies of texi2html.
	* build-aux/texi2html: Moved to here from libtextstyle/build-aux/texi2html.
	* libtextstyle/autogen.sh: Copy texi2html.
	* gettext-runtime/libasprintf/texi2html: Remove file.
	* gettext-runtime/libasprintf/Makefile.am (TEXI2HTML): Use build-aux/texi2html.
	(EXTRA_DIST): Remove texi2html.
	* gettext-tools/doc/texi2html: Remove file.
	* gettext-tools/doc/Makefile.am (TEXI2HTML): Use build-aux/texi2html.
	(EXTRA_DIST): Remove texi2html.
	* Makefile.am (EXTRA_DIST): Add build-aux/texi2html.
	(distcheck-hook): Update.

2019-04-07  Bruno Haible  <bruno@clisp.org>

	doc: Use a version of texi2html which is under a good license.
	Reported by <ineiev@gnu.org> in <https://savannah.gnu.org/bugs/?54809>.

	* gettext-tools/doc/texi2html: Copied from texi2html-1.78, with changes made in
	libunistring/build-aux/texi2html and then in libtextstyle/build-aux/texi2html.
	* gettext-tools/doc/gettext.texi: Enable the Top node during texi2html
	processing.
	* gettext-tools/doc/Makefile.am (gettext.html): Use texi2html options
	-no-sec-nav -no-menu -toc-links.
	(gettext_toc.html): Likewise. Pull out generated files out of subdirectory.

2019-04-07  Bruno Haible  <bruno@clisp.org>

	libasprintf: Use a version of texi2html which is under a good license.
	Reported by <ineiev@gnu.org> in <https://savannah.gnu.org/bugs/?54809>.

	* gettext-runtime/libasprintf/texi2html: Copied from texi2html-1.78, with
	changes made in libunistring/build-aux/texi2html and then in
	libtextstyle/build-aux/texi2html.
	* gettext-runtime/libasprintf/fdl.texi: New file, copied from
	gettext-tools/doc/fdl.texi.
	* gettext-runtime/libasprintf/gpl.texi: New file, copied from
	gnulib/doc/gpl-2.0.texi.
	* gettext-runtime/libasprintf/lgpl.texi: New file, copied from
	gnulib/doc/lgpl-2.1.texi.
	* gettext-runtime/libasprintf/autosprintf.texi: Invoke @contents. Enable the
	Top node during texi2html processing.
	(Licenses): New appendix.
	* gettext-runtime/libasprintf/Makefile.am (TEXINCLUDES): New variable.
	(MAKEINFOFLAGS): Use it.
	(autosprintf_TEXINFOS): New variable.
	(autosprintf_all.html): Depend on it. Use texi2html options -no-sec-nav -no-menu
	-toc-links.

2019-04-07  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Tweak style of HTML documentation.
	* libtextstyle/build-aux/texi2html (BIG_RULE): Set to empty.

2019-04-07  Bruno Haible  <bruno@clisp.org>

	Add copyright notices in several files.
	Reported by <ineiev@gnu.org> in <https://savannah.gnu.org/bugs/?54809>.

	* gettext-tools/doc/FAQ.html: Fix copyright notice added on 2019-04-04.
	* gettext-tools/doc/tutorial.html: Add GFDL copyright notice. Permission given
	by Gora Mohanty <gora_mohanty@yahoo.co.in> through private email on 2004-11-13.
	* gettext-tools/po/Makevars.template: Don't mention the file name, since this
	file is meant to be copied and renamed to 'Makevars'.
	* gettext-tools/examples/hello-*/po/Makevars: Add all-permissive copyright
	notice.
	* gettext-tools/examples/hello-c-gnome3/hello.ui: Add public-domain notice.
	* gettext-tools/examples/hello-c-gnome3/hello.gresource.xml: Likewise.
	* gettext-tools/examples/hello-c-gnome3/hello.gschema.xml: Likewise.
	* gettext-tools/examples/hello-java-awt/m4/TestAWT.java: Likewise.
	* gettext-tools/examples/hello-java-swing/m4/TestAWT.java: Likewise.
	* gettext-tools/examples/hello-java-qtjambi/m4/Test15.java: Likewise.
	* gettext-tools/examples/check-examples: Add GPLv3+ copyright notice.
	* gettext-tools/examples/installpaths.in: Likewise.
	* gettext-tools/examples/po/mmsmallpo.sh: Likewise.
	* gettext-tools/examples/po/xsmallpot.sh: Likewise.
	* gettext-tools/its/glade.loc: Likewise.
	* gettext-tools/its/gsettings.loc: Likewise.
	* gettext-tools/its/metainfo.its: Likewise.
	* gettext-tools/its/metainfo.loc: Likewise.
	* gettext-tools/src/filters.h: Add missing copyright line.

2019-04-04  Bruno Haible  <bruno@clisp.org>

	Reduce ABOUT-NLS to just a hyperlink.
	The common way to distribute information, nowadays, is through the web,
	not by including files in tarballs of packages.  Also, the current
	contents of ABOUT-NLS is outdated.

	Reported by Samuel Thibault in <https://savannah.gnu.org/bugs/?54809>.

	* gettext-runtime/ABOUT-NLS: Replace text with a reference to the online
	documentation.
	* gettext-runtime/Makefile.am (MAKEINFO): Remove variable.
	(all-local, ABOUT-NLS): Remove rules.
	* gettext-tools/src/msginit.c (main): Point the user to the online documentation
	instead of the ABOUT-NLS file.
	* gettext-tools/doc/gettext.texi (Installing Localizations, Prerequisites,
	Makefile): Don't mention ABOUT-NLS any more.
	* gettext-tools/doc/gettextize.texi: Update description of ABOUT-NLS.
	* gettext-tools/doc/FAQ.html: Refer to the online documentation instead of the
	ABOUT-NLS file.
	* README: Don't mention ABOUT-NLS any more.

2019-04-04  Bruno Haible  <bruno@clisp.org>

	doc: Include the contents of ABOUT-NLS in the documentation.
	* gettext-runtime/doc/nls.texi (The original ABOUT-NLS): Renamed from
	'Translation Intro'. Turn into a section. Mark section as historical.
	* gettext-tools/doc/gettext.texi: Include nls.texi.
	* gettext-tools/doc/Makefile.am (gettext_TEXINFOS): Add nls.texi and
	matrix.texi.

	doc: Update ISO 639 list.
	* gettext-tools/doc/iso-639.texi: Regenerated.

2019-04-04  Bruno Haible  <bruno@clisp.org>

	Add copyright notices in several files.
	Reported by <ineiev@gnu.org> in <https://savannah.gnu.org/bugs/?54809>.

	* gettext-runtime/m4/Makefile.am: Add GPL copyright notice.
	* gettext-tools/m4/Makefile.am: Likewise.
	* gettext-tools/doc/iso-639.sed: Likewise.
	* gettext-tools/doc/iso-639-2.sed: Likewise.
	* gettext-tools/doc/iso-3166.sed: Likewise.
	* gettext-tools/its/glade1.its: Likewise.
	* gettext-tools/its/glade2.its: Likewise.
	* gettext-tools/its/gsettings.its: Likewise.
	* gettext-tools/its/gtkbuilder.its: Likewise.
	* gettext-tools/misc/cvsuser.c: Likewise.
	* gettext-tools/projects/team-address: Likewise.
	* gettext-tools/projects/GNOME/team-address: Likewise.
	* gettext-tools/projects/GNOME/trigger: Likewise.
	* gettext-tools/projects/KDE/team-address: Likewise.
	* gettext-tools/projects/KDE/trigger: Likewise.
	* gettext-tools/projects/TP/team-address: Likewise.
	* windows/windres-options: Likewise.
	* gettext-runtime/po/insert-header.sin: Add copyright notice, based on the one
	in Rules-quot.
	* gettext-tools/doc/FAQ.html: Add copyright notice, suitable for documentation.

2019-04-03  Bruno Haible  <bruno@clisp.org>

	Mention the support for Java 11.
	This support was added in gnulib on 2018-09-26.

	* NEWS: Mention the support for Java 11.

2019-04-03  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Clean up old TODO item.
	* libtextstyle/Makefile.am: Remove obsolete comment.

2019-04-02  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Distribute two more files.
	* libtextstyle/Makefile.am (EXTRA_DIST): Add
	gnulib-local/lib/libxml/xmlversion.in.h.diff, gnulib-local/modules/libxml.diff.

	build: Move local gnulib modules that are only needed in libtextstyle.
	* libtextstyle/gnulib-local/*: Many files moved to here from gnulib-local/*.
	* libtextstyle/gnulib-local/modules/libglib: Apply diff.
	* libtextstyle/gnulib-local/modules/libglib.diff: Remove file.
	* libtextstyle/gnulib-local/modules/libcroco: Apply diff.
	* libtextstyle/gnulib-local/modules/libcroco.diff: Remove file.
	* libtextstyle/gnulib-local/modules/term-styled-ostream: Apply diff.
	* libtextstyle/gnulib-local/modules/term-styled-ostream.diff: Remove file.
	* libtextstyle/gnulib-local/modules/html-styled-ostream: Apply diff.
	* libtextstyle/gnulib-local/modules/html-styled-ostream.diff: Remove file.
	* libtextstyle/gnulib-local/modules/noop-styled-ostream: Apply diff.
	* libtextstyle/gnulib-local/modules/noop-styled-ostream.diff: Remove file.
	* libtextstyle/woe32dll/c++term-styled-ostream.cc: Remove file.
	* libtextstyle/woe32dll/c++html-styled-ostream.cc: Remove file.
	* libtextstyle/woe32dll/c++noop-styled-ostream.cc: Remove file.
	* gettext-tools/woe32dll/c++term-styled-ostream.cc: Remove file.
	* gettext-tools/woe32dll/c++html-styled-ostream.cc: Remove file.
	* gnulib-local/Makefile.am (EXTRA_DIST): Remove the files that were moved away.
	* libtextstyle/Makefile.am (EXTRA_DIST): Add the files that were moved to
	libtextstyle/gnulib-local/. Add build-aux/moopp.
	* Makefile.am (EXTRA_DIST): Remove build-aux/moopp.

	libgettextpo: Avoid closing a FILE stream when it will still be used.
	* gettext-tools/src/write-catalog.c (msgdomain_list_print): Don't call
	ostream_free if we're using the dummy <textstyle.h>.

	libgettextpo: Use a dummy replacement for libtextstyle.
	* gnulib-local/modules/libtextstyle-dummy: New file, based on gnulib's
	modules/libtextstyle-optional.
	* gnulib-local/Makefile.am (EXTRA_DIST): Add it.
	* autogen.sh (GNULIB_MODULES_LIBGETTEXTPO): Add libtextstyle-dummy. Remove
	file-ostream, ostream.
	* gettext-tools/src/write-catalog.h: Include <textstyle.h> always.
	* gettext-tools/src/write-catalog.c: Likewise.
	* gettext-tools/src/write-po.h: Likewise.
	* gettext-tools/src/write-po.c: Likewise.

	Link the msg* and xgettext programs against libtextstyle.
	* libtextstyle/autogen.sh: Don't generate lib/color.h and lib/color.c.
	* libtextstyle/lib/color.h: Moved to here from gettext-tools/src/color.h.
	* libtextstyle/lib/color.c: Moved to here from gettext-tools/src/color.c.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC): Remove fd-ostream, file-ostream,
	html-styled-ostream, ostream, styled-ostream, term-styled-ostream. Add libxml.
	* gettext-tools/gnulib-lib/Makefile.am (MOOPPFLAGS): Remove customization.
	* gettext-tools/gnulib-tests/Makefile.am (test_term_ostream_LDADD): Remove
	customization.
	* gettext-tools/src/Makefile.am (noinst_HEADERS): Remove color.h.
	(AM_CPPFLAGS): Add -I directives to the libtextstyle/lib directory.
	(libgettextsrc_la_SOURCES): Remove color.c.
	(libgettextsrc_la_LDFLAGS): Link with libtextstyle.la.
	* gettext-tools/src/FILES: Update.
	* gettext-tools/src/write-catalog.h: Include <textstyle.h> instead of ostream.h.
	* gettext-tools/src/write-catalog.c: Include <textstyle.h> instead of color.h
	and *-ostream.h.
	(msgdomain_list_print): Use styled_ostream_create and
	noop_styled_ostream_create.
	* gettext-tools/src/write-po.h: Include <textstyle.h> instead of ostream.h.
	* gettext-tools/src/write-po.c: Include <textstyle.h> instead of *-ostream.h.
	(is_stylable): Remove function.
	(begin_css_class, end_css_class): Update. Mark as inline.
	* gettext-tools/src/write-properties.c: Include <textstyle.h> instead of
	ostream.h.
	* gettext-tools/src/write-stringtable.c: Likewise.
	* gettext-tools/src/msgattrib.c: Include <textstyle.h> instead of color.h.
	* gettext-tools/src/msgcat.c: Likewise.
	* gettext-tools/src/msgcomm.c: Likewise.
	* gettext-tools/src/msgconv.c: Likewise.
	* gettext-tools/src/msgen.c: Likewise.
	* gettext-tools/src/msgfilter.c: Likewise.
	* gettext-tools/src/msggrep.c: Likewise.
	* gettext-tools/src/msginit.c: Likewise.
	* gettext-tools/src/msgmerge.c: Likewise.
	* gettext-tools/src/msgunfmt.c: Likewise.
	* gettext-tools/src/msguniq.c: Likewise.
	* gettext-tools/src/xgettext.c: Likewise.

	libtextstyle: Generalize fd-styled-ostream to noop-styled-ostream.
	* gnulib-local/lib/noop-styled-ostream.oo.h: New file, based on
	gnulib-local/lib/fd-styled-ostream.oo.h.
	* gnulib-local/lib/noop-styled-ostream.oo.c: New file, based on
	gnulib-local/lib/fd-styled-ostream.oo.c.
	* gnulib-local/modules/noop-styled-ostream: New file, based on
	gnulib-local/modules/fd-styled-ostream.
	* gnulib-local/Makefile.am (EXTRA_DIST): Remove lib/fd-styled-ostream.oo.[hc]
	and modules/fd-styled-ostream. Add lib/noop-styled-ostream.oo.[hc] and
	modules/noop-styled-ostream.
	* libtextstyle/woe32dll/c++noop-styled-ostream.cc: New file, based on
	libtextstyle/woe32dll/c++fd-styled-ostream.cc.
	* libtextstyle/gnulib-local/modules/noop-styled-ostream.diff: New file, based
	on libtextstyle/gnulib-local/modules/fd-styled-ostream.diff.
	* gnulib-local/lib/fd-styled-ostream.oo.h: Remove file.
	* gnulib-local/lib/fd-styled-ostream.oo.c: Remove file.
	* gnulib-local/modules/fd-styled-ostream: Remove file.
	* libtextstyle/woe32dll/c++fd-styled-ostream.cc: Remove file.
	* libtextstyle/gnulib-local/modules/fd-styled-ostream.diff: Remove file.
	* libtextstyle/autogen.sh (GNULIB_MODULES): Add noop-styled-ostream. Remove
	fd-styled-ostream.
	* libtextstyle/lib/misc.c: Include noop-styled-ostream.h, fd-ostream.h.
	(styled_ostream_create): Call fd_ostream_create and noop_styled_ostream_create
	instead of fd_styled_ostream_create.
	* libtextstyle/lib/textstyle.h (noop_styled_ostream_t): New type.
	(noop_styled_ostream_*): New declarations.
	* libtextstyle/doc/libtextstyle.texi (The noop_styled_ostream class): New
	subsection.

	build: Build and install libtextstyle.
	* autogen.sh: Recurse into libtextstyle directory.
	* configure.ac: Likewise.
	* Makefile.am (SUBDIRS): Add libtextstyle.
	* DEPENDENCIES: Mention that libiconv and ncurses are also used by libtextstyle.
	* PACKAGING: Recommend to ship libtextstyle as a third binary package.
	* NEWS: Mention that libtextstyle is installed.

	build: Separate git operations from build operations.
	* gitsub.sh: New file, from gnulib.
	* autogen.sh: Remove all git operations and the --no-git option. Look at the
	GNULIB_SRCDIR environment variable. Ignore the GNULIB_TOOL environment variable.
	* HACKING: Explain when to use gitsub.sh.

	libtextstyle: Bump version number.

2019-04-01  Daiki Ueno  <ueno@gnu.org>

	desktop: Fix whitespace handling around '='
	While the spec only allows spaces before and after '=',
	xgettext/msgfmt previously accepted all whitespaces including '\n'.
	That was causing unwanted concatenation of desktop lines.

	Reported by Bastien Nocera in:
	https://lists.gnu.org/archive/html/bug-gettext/2019-03/msg00017.html

	* gettext-tools/src/read-desktop.c (desktop_lex): Properly handle
	space characters before and after '='.
	* gettext-tools/tests/msgfmt-desktop-1: Add a test case.

2019-04-01  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Bump version number.

2019-03-31  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Add support for true-color terminals.
	* gnulib-local/lib/term-ostream.oo.c (colormodel_t): Add cm_xtermrgb.
	(rgb_to_color_xtermrgb): New function.
	(attributes_t): Extend the color fields to 25 bits.
	(struct term_ostream): New fields active_attr_color, active_attr_bgcolor.
	(out_color_change, out_bgcolor_change, term_ostream::rgb_to_color): Handle
	cm_xtermrgb.
	(out_attr_change): Set also active_attr_color, active_attr_bgcolor.
	(async_set_attributes_from_default): Fetch also active_attr_color,
	active_attr_bgcolor.
	(term_ostream_create): Accept all $TERM values that end in -direct.
	* libtextstyle/doc/libtextstyle.texi (Terminal emulators): Document the
	prerequisites for true-color support.
	* libtextstyle/NEWS: Mention the change.

	maint: Make code more "git diff"-friendly.
	* gettext-runtime/src/envsubst.c: Prefer long lines to lines that start with a
	non-whitespace character.
	* gettext-tools/src/cldr-plurals.c: Likewise.
	* gettext-tools/src/format.c: Likewise.
	* gettext-tools/src/msgcmp.c: Likewise.
	* gettext-tools/src/msgfmt.c: Likewise.
	* gettext-tools/src/msggrep.c: Likewise.
	* gettext-tools/src/msgl-cat.c: Likewise.
	* gettext-tools/src/msgl-charset.c: Likewise.
	* gettext-tools/src/msgl-check.c: Likewise.
	* gettext-tools/src/msgl-iconv.c: Likewise.
	* gettext-tools/src/msgmerge.c: Likewise.
	* gettext-tools/src/po-lex.c: Likewise.
	* gettext-tools/src/read-stringtable.c: Likewise.
	* gettext-tools/src/recode-sr-latin.c: Likewise.
	* gettext-tools/src/write-catalog.c: Likewise.
	* gettext-tools/src/write-java.c: Likewise.
	* gettext-tools/src/write-po.c: Likewise.
	* gettext-tools/src/x-csharp.c: Likewise.
	* gettext-tools/src/x-elisp.c: Likewise.
	* gettext-tools/src/x-java.c: Likewise.
	* gettext-tools/src/x-javascript.c: Likewise.
	* gettext-tools/src/x-librep.c: Likewise.
	* gettext-tools/src/x-lisp.c: Likewise.
	* gettext-tools/src/x-perl.c: Likewise.
	* gettext-tools/src/x-python.c: Likewise.
	* gettext-tools/src/x-scheme.c: Likewise.
	* gettext-tools/src/x-sh.c: Likewise.
	* gettext-tools/src/x-tcl.c: Likewise.
	* gettext-tools/src/x-vala.c: Likewise.
	* gettext-tools/src/xg-encoding.c: Likewise.
	* gettext-tools/src/xgettext.c: Likewise.

	libtextstyle: Improve documentation regarding the TERM value.
	* libtextstyle/doc/libtextstyle.texi (The TERM variable): Many more details.
	(Terminal emulators, Consoles): New subsections.

	libtextstyle: Support for terminal types with 256 colors.
	* gnulib-local/lib/term-ostream.oo.c (term_ostream_create): Accept all $TERM
	values that end in -16color or -256 color (such as Eterm-256color,
	mlterm-256color, or putty-256color).
	* libtextstyle/NEWS: Mention the change.

2019-03-30  Takesi Ayanokoji  <ayanokoji.takesi@gmail.com>

	po-mode: Enable highlighting of #, lines.
	* gettext-tools/emacs/po-mode.el (po-font-lock-keywords): Add rule for #, lines.

2019-03-30  Bruno Haible  <bruno@clisp.org>

	po-mode: Remove support for Emacs versions < 22.
	Emacs 22 is the oldest version still in use, see
	<https://repology.org/project/emacs/versions>.

	* gettext-tools/emacs/po-compat.el: Remove conditional code for Emacs < 22.
	* gettext-tools/emacs/po-mode.el: Likewise.
	(po-rehighlight): Remove function.
	(po-check-all-pending-edits, po-check-for-pending-edit): Update.
	* gettext-tools/emacs/start-po.el: Update comment.

2019-03-30  Bruno Haible  <bruno@clisp.org>

	po-mode: Remove support for XEmacs.
	* gettext-tools/emacs/po-mode.el: Remove conditional code for XEmacs.
	* gettext-tools/emacs/po-compat.el: Likwise.

	build: Move the Emacs package sources to subdirectory gettext-tools/emacs/.
	* gettext-tools/emacs/*.el: Moved here from gettext-tools/misc/.
	* gettext-tools/emacs/Makefile.am: New file, based on
	gettext-tools/misc/Makefile.am.
	* gettext-tools/misc/Makefile.am (lisp_LISP): Remove variable.
	* gettext-tools/configure.ac (AC_CONFIG_FILES): Add emacs/Makefile.
	* gettext-tools/Makefile.am (SUBDIRS): Add 'emacs'.

	Update after gnulib changed.

2019-03-27  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Add support for Windows consoles.
	* gnulib-local/lib/term-ostream.oo.c: Include <windows.h>, msvc-nothrow.h,
	<io.h>.
	(struct term_ostream): Add fields handle, is_windows_console,
	default_console_attributes, current_console_attributes.
	(out_color_change, out_bgcolor_change, out_underline_change, out_attr_change,
	restore, async_restore, async_set_attributes_from_default, term_ostream::flush):
	Add separate code path for Windows consoles.
	(term_ostream_create): On Windows, test whether the handle refers to a console,
	and initialize the new fields.
	* gnulib-local/modules/term-ostream (Depends-on): Add msvc-nothrow.
	* libtextstyle/NEWS: Mention it.

	libtextstyle: Make the SIGCONT handler work more reliably.
	* gnulib-local/lib/term-ostream.oo.c (out_attr_change): Modify active_attr
	before emitting the escape sequences, not afterwards.
	* libtextstyle/NEWS: Mention the fix.

	libtextstyle: Mention fixes.
	* libtextstyle/NEWS: Mention two fixes done in the gnulib module
	'term-style-control'.

	libtextstyle: Small fix for last commit.
	* gnulib-local/lib/term-ostream.oo.c (struct term_ostream): Mark fd volatile.

	Update to newest gnulib.

2019-03-27  Bruno Haible  <bruno@clisp.org>

	its: Simplify code.
	Suggested by Daiki Ueno.

	* gettext-tools/src/its.c (normalize_whitespace): Remove local variable.

2019-03-26  Bruno Haible  <bruno@clisp.org>

	its: Fix test failure.
	* gettext-tools/src/its.c (normalize_whitespace): Fix detection of paragraph
	boundary. Get rid of initial trim() call.
	* gettext-tools/tests/xgettext-its-1: Fix typo. Verify removal of whitespace
	at the end of the last paragraph.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC): Add memchr.

	build: Use gnulib module 'strchrnul' explicitly.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC): Add strchrnul.

2019-03-24  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Use gnulib module 'term-style-control'.
	* gnulib-local/lib/term-ostream.oo.h: Include term-style-control.h.
	(ttyctl_t): Remove type.
	* gnulib-local/lib/term-ostream.oo.c (DEBUG_SIGNALS): Remove macro.
	Don't include <signal.h>, <stdio.h>, <sys/stat.h>, fatal-signal.h,
	sig-handler.h, same-inode.h.
	(SIZEOF): Remove macro.
	(nonintr_tcgetattr, nonintr_tcsetattr): Remove functions.
	(log_message, sprintf_integer, simple_errno_string, simple_signal_string,
	log_signal_handler_called): Remove functions.
	(struct term_ostream): Remove fields tty_control, same_as_stderr,
	non_default_active. Add control_data field instead.
	(get_control_data): New function.
	(BLOCK_SIGNALS_DURING_NON_DEFAULT_STYLE_OUTPUT): Remove macro.
	(term_fd): Remove variable.
	(pgrp_status_t): Remove type.
	(pgrp_status): Remove variable.
	(update_pgrp_status): Remove function.
	(out_filename): Remove variable.
	(out_error): Use out_stream instead of out_filename.
	(restore, tcsetattr_failed): Remove functions.
	(orig_lflag_set, orig_lflag): Remove variables.
	(clobber_local_mode, restore_local_mode): Remove functions.
	(job_control_signals): Remove variable.
	(num_job_control_signals): Remove macro.
	(relevant_signal_set, relevant_signal_set_initialized): Remove variables.
	(init_relevant_signal_set, block_relevant_signals, unblock_relevant_signals,
	is_ignored, show_signal_marker, fatal_or_stopping_signal_handler,
	fatal_signal_handler, stopping_signal_handler, continuing_signal_handler,
	ensure_continuing_signal_handler, ensure_other_signal_handlers): Remove
	functions.
	(out_attr_change): Set out_stream and out_fd.
	(activate_non_default_attr, deactivate_non_default_attr): Remove functions.
	(restore, async_restore, async_set_attributes_from_default): New functions.
	(controller): New variable.
	(activate_default_attr, output_buffer): Update.
	(term_ostream::free): Invoke deactivate_term_style_controller.
	(term_ostream_create): Invoke activate_term_style_controller.
	* gnulib-local/m4/term-ostream.m4 (gl_TERM_OSTREAM): Don't test for tcgetattr().
	* gnulib-local/modules/term-ostream (Depends-on): Add term-style-control. Remove
	fatal-signal, sigaction, sigprocmask, same-inode.

	moopp: Allow forward references to the <class>_representation type.
	* gnulib-local/build-aux/moopp (func_version): Bump copyright year.
	(func_emit_source_c): Move the <class>_representation type alias to the top
	of the file.

2019-03-20  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Fix a memory access from a signal handler.
	* gnulib-local/lib/term-ostream.oo.c (struct term_ostream): Mark active_attr
	field as volatile.

	libtextstyle: Bump version number.

	Use _GL_ASYNC_SAFE from gnulib.
	* gettext-tools/src/plural-eval.h (sigfpe_code): Mark as volatile.
	* gettext-tools/src/plural-eval.c (sigfpe_code): Likewise.
	(sigfpe_handler): Mark as _GL_ASYNC_SAFE.
	* gnulib-local/lib/term-ostream.oo.c (ASYNC_SAFE): Remove macro.
	Use _GL_ASYNC_SAFE instead.

	Update to newest gnulib.

	Update .gitignore after 2019-03-12 change.

2019-03-17  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Bump version number.

	libtextstyle: Bump version number.

	libtextstyle: Implement reliable tty control.
	* gnulib-local/lib/term-ostream.oo.c (DEBUG_SIGNALS): New macro.
	Include <stdio.h>, <sys/stat.h>.
	(NOFLSH): Define fallback value.
	Include sig-handler.h, same-inode.h.
	(ASYNC_SAFE): New macro.
	(color_bgr): Mark as ASYNC_SAFE.
	(nonintr_tcgetattr, nonintr_tcsetattr): New functions.
	(log_message, sprintf_integer, simple_errno_string, simple_signal_string,
	log_signal_handler_called): New functions.
	(struct term_ostream): Add fields restore_colors, restore_weight,
	restore_posture, restore_underline, tty_control, same_as_stderr.
	(BLOCK_SIGNALS_DURING_NON_DEFAULT_STYLE_OUTPUT): New macro.
	(term_fd): New variable.
	(pgrp_status_t): New type.
	(pgrp_status): New variable.
	(update_pgrp_status): New function.
	(out_stream): New variable.
	(restore_colors, restore_weight, restore_posture, restore_underline): Remove
	variables.
	(out_color_change, out_bgcolor_change, out_weight_change, out_posture_change,
	out_underline_change): New functions, extracted from out_attr_change.
	(out_attr_change): Call these functions.
	(restore): Use out_stream.
	(tcsetattr_failed): New function.
	(orig_lflag_set, orig_lflag): New variables.
	(clobber_local_mode, restore_local_mode): New functions.
	(job_control_signals): Renamed from stopping_signals. Add SIGCONT.
	(num_job_control_signals): Renamed from num_stopping_signals.
	(relevant_signal_set): Replaces stopping_signal_set.
	(relevant_signal_set_initialized): New variable.
	(init_relevant_signal_set): Replaces init_stopping_signal_set.
	(block_relevant_signals): Replaces block_stopping_signals.
	(unblock_relevant_signals): Replaces unblock_stopping_signals.
	(is_ignored): New function.
	(show_signal_marker): New function.
	(fatal_or_stopping_signal_handler, fatal_signal_handler,
	stopping_signal_handler, continuing_signal_handler,
	ensure_continuing_signal_handler, ensure_other_signal_handlers): New functions.
	(activate_non_default_attr, deactivate_non_default_attr): Rewritten.
	(term_ostream::free): Unset term_fd and call update_pgrp_status.
	(term_ostream_create): Initialize the fields restore_colors, restore_weight,
	restore_posture, restore_underline, tty_control, same_as_stderr. Call
	init_relevant_signal_set. Set term_fd and call ensure_continuing_signal_handler
	and update_pgrp_status.
	* gnulib-local/m4/term-ostream.m4 (gl_TERM_OSTREAM): Check for tcgetattr.
	* gnulib-local/modules/term-ostream (Depends-on): Add sigaction, same-inode.
	* libtextstyle/NEWS: Mention the change.

	libtextstyle: Fix build failure on Cygwin (regression from 2019-03-15).
	* libtextstyle/lib/Makefile.am ($(srcdir)/libtextstyle.sym.in): Renamed
	from $(srcdir)/libtextstyle.sym.
	(libtextstyle.sym): New rule.
	(MOSTLYCLEANFILES, MAINTAINERCLEANFILES, EXTRA_DIST): Update accordingly.
	(config.h): Depend on libtextstyle.sym in the build directory.
	(libtextstyle_la_LDFLAGS: Use libtextstyle.sym in the build directory.

	libtextstyle: Clean up leftovers from 2019-03-13 commit.
	* libtextstyle/lib/Makefile.am (libtextstyle_la_LINK): Remove variable.

2019-03-16  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Complete styled_ostream_flush_to_current_style declaration.
	* libtextstyle/lib/textstyle.h (term_styled_ostream_flush_to_current_style,
	html_styled_ostream_flush_to_current_style): New declarations.

	libtextstyle: Protect better against EINTR.
	* gnulib-local/lib/fd-ostream.oo.c (nonintr_tcdrain): New function.
	(fd_ostream::flush): Use it instead of tcdrain.
	* gnulib-local/lib/file-ostream.oo.c: Include <errno.h>.
	(nonintr_tcdrain): New function.
	(file_ostream::flush): Use it instead of tcdrain.
	* gnulib-local/lib/term-ostream.oo.c (nonintr_tcdrain): New function.
	(term_ostream::flush): Use it instead of tcdrain.

2019-03-15  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Reexport isatty() override from gnulib.
	This is necessary for programs that are compiled for native Windows and
	run in a Cygwin console.

	* libtextstyle/autogen.sh (GNULIB_MODULES): Add 'isatty'.
	* libtextstyle/configure.ac: Set GNULIB_ISATTY to 0.
	* libtextstyle/lib/textstyle.h (libtextstyle_isatty): New declaration.
	(isatty): Redirect to libtextstyle_isatty.

2019-03-14  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Use less code from libxml.
	* libtextstyle/gnulib-local/lib/libxml/xmlversion.in.h.diff: New file.
	* gnulib-local/lib/libxml/save.h (xmlEncodeAttributeEntities): Declare also when
	LIBXML_OUTPUT_ENABLED is 0.

	libtextstyle: Fix "make clean" failure in VPATH builds.
	* libtextstyle/lib/Makefile.am (CLEANDIRS_NOT_IN_SRCDIR): Remove 'textstyle'.
	(DISTCLEANDIRS_NOT_IN_SRCDIR): Add 'textstyle'.

	libtextstyle: Make sure we get new versions also of mdate-sh.
	* libtextstyle/autogen.sh: Erase more files in build-aux.

2019-03-14  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Remove unused code for exporting variables from Windows DLLs.
	Here we use the third approach listed in gettext-tools/woe32dll/export.h, not
	the fourth approach.

	* libtextstyle/Makefile.am: Remove code that was never enabled.
	* libtextstyle/lib/Makefile.am: Likewise.
	* libtextstyle/configure.ac (false): Remove conditional.

2019-03-14  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Add metainformation for Windows.

	libtextstyle: Add metainformation for Windows.
	* libtextstyle/lib/libtextstyle.rc: New file.
	* libtextstyle/lib/Makefile.am (EXTRA_DIST): Add it.
	(WOE32_LIBADD): New variable.
	(libtextstyle.res.lo): New rule.
	(libtextstyle_la_LIBADD, libtextstyle_la_DEPENDENCIES): Augment.

2019-03-13  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Don't use a C++ compiler.
	* libtextstyle/gnulib-local/modules/fd-styled-ostream.diff: New file.
	* libtextstyle/gnulib-local/modules/html-styled-ostream.diff: New file.
	* libtextstyle/gnulib-local/modules/term-styled-ostream.diff: New file.
	* libtextstyle/lib/Makefile.am (libtextstyle_la_LINK): Use the C compiler
	always.
	* libtextstyle/configure.ac: Remove LT_LANG([C++]), AC_PROG_CXX, and related
	invocations.

	libasprintf: Add metainformation for Windows.
	* gettext-runtime/libasprintf/configure.ac: Set RC and WOE32 variables.
	* gettext-runtime/libasprintf/libasprintf.rc: New file.
	* gettext-runtime/libasprintf/Makefile.am (EXTRA_DIST): Add it.
	(WOE32_LIBADD): New variable.
	(libasprintf.res.lo): New rule.
	(libasprintf_la_LIBADD, libasprintf_la_DEPENDENCIES): New variables.

	build: Update Windows support.
	* gettext-runtime/intl/libintl.rc: Update.
	* gettext-tools/libgettextpo/libgettextpo.rc: Likewise.
	* windows/gettext.rc: Likewise.

	libtextstyle: Bump version number.

2019-03-12  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Bump version number.

	libtextstyle: New function styled_ostream_flush_to_current_style.
	* gnulib-local/lib/styled-ostream.oo.h (struct styled_ostream): Add method
	flush_to_current_style.
	* gnulib-local/lib/fd-styled-ostream.oo.c
	(fd_styled_ostream::flush_to_current_style): New method.
	* gnulib-local/lib/term-styled-ostream.oo.c
	(term_styled_ostream::flush_to_current_style): New method.
	* gnulib-local/lib/html-styled-ostream.oo.c
	(html_styled_ostream::flush_to_current_style): New method.
	* libtextstyle/lib/textstyle.h (styled_ostream_flush_to_current_style): New
	declaration.
	* libtextstyle/doc/libtextstyle.texi (The styled_ostream class): Document
	styled_ostream_flush_to_current_style.
	* libtextstyle/NEWS: Mention the change.

	libtextstyle: New function html_ostream_flush_to_current_style.
	* gnulib-local/lib/html-ostream.oo.h (struct html_ostream): Add method
	flush_to_current_style.
	* gnulib-local/lib/html-ostream.oo.c (html_ostream::flush_to_current_style): New
	method.
	* libtextstyle/lib/textstyle.h (html_ostream_flush_to_current_style): New
	declaration.
	* libtextstyle/doc/libtextstyle.texi (The html_ostream class): Document
	html_ostream_flush_to_current_style.
	* libtextstyle/NEWS: Mention the change.

	libtextstyle: New function term_ostream_flush_to_current_style.
	* gnulib-local/lib/term-ostream.oo.h (struct term_ostream): Add method
	flush_to_current_style.
	* gnulib-local/lib/term-ostream.oo.c (struct term_ostream): Add fields
	default_attr, active_attr, non_default_active.
	(out_attr_change): Remove second argument. Update active_attr.
	(activate_non_default_attr, deactivate_non_default_attr, activate_default_attr):
	New functions, extracted from output_buffer.
	(output_buffer): Use them. Add a second argument.
	(term_ostream::write_mem, term_ostream::flush): Update output_buffer calls.
	(term_ostream::free): Add an assertion.
	(term_ostream::flush_to_current_style): New method.
	(term_ostream_create): Initialize the fields default_attr, active_attr,
	non_default_active.
	* libtextstyle/lib/textstyle.h (term_ostream_flush_to_current_style): New
	declaration.
	* libtextstyle/doc/libtextstyle.texi (The term_ostream class): Document
	term_ostream_flush_to_current_style.
	* libtextstyle/NEWS: Mention the change.

2019-03-12  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Add a second argument to the 'flush' operations.
	* gnulib-local/lib/ostream.oo.h (ostream_flush_scope_t): New type.
	(ostream::flush): Add scope parameter.

	* gnulib-local/lib/file-ostream.oo.c: Include <unistd.h>, <termios.h>.
	(file_ostream::flush): Add a scope parameter.
	* gnulib-local/modules/file-ostream (Depends-on): Add 'fsync'.
	(configure.ac): Check for tcdrain.

	* gnulib-local/lib/fd-ostream.oo.c: Include <unistd.h>, <termios.h>.
	(fd_ostream::flush): Add a scope parameter.
	(fd_ostream::free): Update flush call.
	* gnulib-local/modules/fd-ostream (Depends-on): Add 'fsync'.
	(configure.ac): Check for tcdrain.

	* gnulib-local/lib/term-ostream.oo.c: Include <unistd.h>, <termios.h>.
	(term_ostream::flush): Add scope parameter.
	(term_ostream::free): Update flush call.
	* gnulib-local/m4/term-ostream.m4 (gl_TERM_OSTREAM): Check for tcdrain.
	* gnulib-local/modules/term-ostream (Depends-on): Add 'fsync'.

	* gnulib-local/lib/memory-ostream.oo.c (memory_ostream::flush): Add scope
	parameter.

	* gnulib-local/lib/iconv-ostream.oo.c (iconv_ostream::flush): Add scope
	parameter.

	* gnulib-local/lib/html-ostream.oo.c (html_ostream::flush): Add scope parameter.
	Emit closing </span> tags.

	* gnulib-local/lib/fd-styled-ostream.oo.c (fd_styled_ostream::flush): Add scope
	parameter.
	* gnulib-local/lib/term-styled-ostream.oo.c (term_styled_ostream::flush): Add
	scope parameter.
	* gnulib-local/lib/html-styled-ostream.oo.c (html_styled_ostream::flush): Add
	scope parameter.

	* libtextstyle/lib/textstyle.h (ostream_flush_scope_t): New type.
	(ostream_flush, styled_ostream_flush, file_ostream_flush, fd_ostream_flush,
	term_ostream_flush, memory_ostream_flush, iconv_ostream_flush,
	html_ostream_flush, term_styled_ostream_flush, html_styled_ostream_flush): Add
	scope parameter.
	* libtextstyle/doc/libtextstyle.texi (The ostream class): Add scope parameter to
	flush method.
	* libtextstyle/NEWS: Mention the change.

2019-03-11  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Add a program for ad-hoc testing.
	* libtextstyle/adhoc-tests/README: New file.
	* libtextstyle/adhoc-tests/hello.c: New file, based on
	libtextstyle/examples/color-hello/hello.c.
	* libtextstyle/adhoc-tests/hello-default.css: New file, copied from
	libtextstyle/examples/color-hello/hello-default.css.
	* libtextstyle/adhoc-tests/Makefile.am: New file.
	* libtextstyle/configure.ac (AC_CONFIG_FILES): Add adhoc-tests/Makefile.
	* libtextstyle/Makefile.am (SUBDIRS): Add adhoc-tests.

	doc: Clarify locale name syntax.
	* gettext-tools/doc/gettext.texi (Locale Names): Fix typo in locale name syntax.
	* gettext-tools/doc/msginit.texi: Clarify that the '-l' argument optionally
	contains an encoding.
	* gettext-tools/src/msginit.c (usage): Likewise.

2019-03-10  Bruno Haible  <bruno@clisp.org>

	doc: Add reference to Pology.
	* gettext-tools/doc/gettext.texi (Other tools): New section.

2019-03-04  Bruno Haible  <bruno@clisp.org>

	build: Make shared library dependencies work in relocatable installation.
	* gettext-tools/gnulib-lib/Makefile.am (RELOCATABLE_LIBRARY_PATH): New variable.
	(libgettextlib_la_LDFLAGS): Augment for relocatable installation.
	* gettext-tools/src/Makefile.am (libgettextsrc_la_LDFLAGS): Augment for
	relocatable installation.
	* gettext-tools/libgettextpo/Makefile.am (RELOCATABLE_LIBRARY_PATH): New
	variable.
	(libgettextpo_la_LDFLAGS): Augment for relocatable installation.

	Update after gnulib changed.

	Update to newest gnulib.

2019-02-24  Bruno Haible  <bruno@clisp.org>

	libintl: Fix installation with BSD 'make'.
	* gettext-runtime/intl/Makefile.am (install-exec-libintl): Create destination
	directory first.

2019-02-16  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Improve the way the library is built.
	* libtextstyle/lib/Makefile.am (libtextstyle_la_LDFLAGS): Add '-no-undefined',
	needed for building on older versions of AIX and useful to verify no undefined
	symbols are used by mistake. Add '-export-symbols', to reduce the loading time
	of the shared library.

2019-02-15  Daiki Ueno  <ueno@gnu.org>

	its: Avoid uninitialized variable
	* gettext-tools/src/its.c (normalize_whitespace): Initialize last_ws.
	Fixes commit 89e7d2663bd27b8cdd300f26095f49d2c7519030.

2019-02-15  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Omit tests that rely on more than the public libtextstyle API.
	* libtextstyle/autogen.sh: Don't pass --with-tests to gnulib-tool.
	(GNULIB_MODULES): Add term-ostream-tests.
	* gnulib-local/modules/term-ostream-tests (Makefile.am): Don't add
	@INTL_MACOSX_LIBS@ to test_term_ostream_LDADD.
	* gettext-tools/gnulib-tests/Makefile.am (test_term_ostream_LDADD): Add
	@INTL_MACOSX_LIBS@ here.

	libtextstyle: Don't use an external libglib.
	* gnulib-local/m4/libglib.m4 (gl_LIBGLIB): Accept an optional FORCE-INCLUDED
	argument.
	* libtextstyle/gnulib-local/modules/libglib.diff: New file.

	libtextstyle: Don't use an external libxml.
	* gnulib-local/m4/libxml.m4 (gl_LIBXML): Accept an optional FORCE-INCLUDED
	argument.
	* libtextstyle/gnulib-local/modules/libxml.diff: New file.

	libtextstyle: Don't use an external libcroco.
	* gnulib-local/m4/libcroco.m4 (gl_LIBCROCO): Accept an optional FORCE-INCLUDED
	argument.
	* libtextstyle/gnulib-local/modules/libcroco.diff: New file.
	* libtextstyle/autogen.sh: Pass another --local-dir option to gnulib-tool.

	libtextstyle: Fix build error on Cygwin and mingw.
	* libtextstyle/lib/Makefile.am (AM_CPPFLAGS): Define LIBXML_STATIC.

	libtextstyle: Really fix hyperlinks to table of contents in HTML doc.
	* libtextstyle/doc/Makefile.am (libunistring_toc.html): Fix typo in last commit.

	libtextstyle: Document when and how to turn off styling.
	* libtextstyle/doc/libtextstyle.texi (Basic use): Document when and how to turn
	off styling.
	* gnulib-local/lib/term-styled-ostream.oo.c (term_styled_ostream_create): Handle
	a NULL css_filename explicitly.

2019-02-15  Daiki Ueno  <ueno@gnu.org>

	its: Add new preserveSpaceRule "paragraph"
	This implements a new text extraction rule preserving paragraph
	boundaries, as mentioned in:
	https://gitlab.gnome.org/GNOME/glib/issues/1350

	* gettext-tools/doc/gettext.texi (Preparing ITS Rules): Mention "paragraph".
	* gettext-tools/src/its.c (its_rule_list_extract_text): Accept "paragraph".
	(its_merge_context_merge_node): Likewise.
	(normalize_whitespace): Handle "paragraph" rule.
	* gettext-tools/src/its.h (ITS_WHITESPACE_NORMALIZE_PARAGRAPH): New enum value.
	* gettext-tools/tests/xgettext-its-1: Add test for "paragraph" rule.

2019-02-15  Daiki Ueno  <ueno@gnu.org>

	its: Make whitespace normalization logic simpler
	* gettext-tools/src/its.c (normalize_whitespace): Use parallel
	pointers for normalizing whitespaces, instead of memmove.
	Suggested by Bruno Haible.

2019-02-14  Bruno Haible  <bruno@clisp.org>

	libtextstyle: In the examples, actually respect the --color option.
	Reported by Akim Demaille <akim.demaille@gmail.com>.

	* libtextstyle/examples/color-filter/filter.c (main): Set style_file_name to
	NULL when styling should be disabled.
	* libtextstyle/examples/color-hello/hello.c (main): Likewise.

2019-02-14  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Assume that the texinfo sources are in the source dir.
	* libtextstyle/doc/Makefile.am (stamp-vti, libtextstyle.html,
	libtextstyle_toc.html): Lookup libunistring.texi in $(srcdir).

2019-02-14  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Fix hyperlinks to table of contents in HTML doc.
	Reported by Akim Demaille <akim.demaille@gmail.com>.

	* libtextstyle/doc/Makefile.am (libunistring_toc.html): Replace references to
	libtextstyle.html with references to libtextstyle_toc.html.

2019-02-14  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Document the link options more precisely.
	* libtextstyle/doc/libtextstyle.texi (Link options): Document the link
	dependencies.

	libtextstyle: Fix build failure on mingw.
	* gnulib-local/modules/html-styled-ostream (Depends-on): Add 'close'.

	libtextstyle: Add support for VPATH builds with OpenBSD 'make'.
	* gnulib-local/modules/*ostream (Makefile.am): In the rules that use moopp,
	prefix the target file names with '$(srcdir)/'.

2019-02-13  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Put the .sym file in the source directory.
	* libtextstyle/lib/Makefile.am (libtextstyle.sym): Generate in the source
	directory.
	(config.h): Update rule.

2019-02-12  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Fix configuration of the example programs.
	Reported by Akim Demaille <akim.demaille@gmail.com>.

	* libtextstyle/Makefile.am (EXTRA_DIST): Add m4/libtextstyle.m4.

2019-02-12  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Bump version number.
	* libtextstyle/version.sh (VERSION): Set to 0.6.

2019-02-10  Bruno Haible  <bruno@clisp.org>

	libtextstyle: New project.
	* libtextstyle/AUTHORS: New file, extracted from gettext/AUTHORS.
	* libtextstyle/COPYING: New file, copied from gettext/COPYING.
	* libtextstyle/DEPENDENCIES: New file, based on gettext/DEPENDENCIES.
	* libtextstyle/HACKING: New file, based on gettext/HACKING.
	* libtextstyle/INSTALL: New file, copied from gettext/INSTALL.
	* libtextstyle/Makefile.am: New file, based on libunistring/Makefile.am.
	* libtextstyle/NEWS: New file.
	* libtextstyle/README: New file, based on libunistring/README.
	* libtextstyle/autogen.sh: New file, based on libunistring/autogen.sh.
	* libtextstyle/configure.ac: New file, based on libunistring/configure.ac.
	* libtextstyle/build-aux/texi2html: New file, copied from
	libunistring/build-aux/texi2html.
	* libtextstyle/doc/Makefile.am: New file, based on libunistring/doc/Makefile.am.
	* libtextstyle/doc/fdl.texi: New file, copied from gnulib/doc/fdl.texi.
	* libtextstyle/doc/gpl.texi: New file, copied from gnulib/doc/gpl-3.0.texi.
	* libtextstyle/doc/libtextstyle.texi: New file, partially based on
	gettext/gettext-tools/doc/gettext.texi.
	* libtextstyle/examples/color-filter/INSTALL: New file, based on
	gettext/gettext-tools/examples/hello-c/INSTALL.
	* libtextstyle/examples/color-filter/Makefile.am: New file, based on
	gettext/gettext-tools/examples/hello-c/Makefile.am.
	* libtextstyle/examples/color-filter/README: New file.
	* libtextstyle/examples/color-filter/autoclean.sh: New file, based on
	gettext/gettext-tools/examples/hello-c/autoclean.sh.
	* libtextstyle/examples/color-filter/autogen.sh: New file, based on
	gettext/gettext-tools/examples/hello-c/autogen.sh.
	* libtextstyle/examples/color-filter/configure.ac: New file.
	* libtextstyle/examples/color-filter/filter.c: New file.
	* libtextstyle/examples/color-filter/filter-default.css: New file.
	* libtextstyle/examples/color-hello/INSTALL: New file, based on
	gettext/gettext-tools/examples/hello-c/INSTALL.
	* libtextstyle/examples/color-hello/Makefile.am: New file, based on
	gettext/gettext-tools/examples/hello-c/Makefile.am.
	* libtextstyle/examples/color-hello/README: New file.
	* libtextstyle/examples/color-hello/autoclean.sh: New file, based on
	gettext/gettext-tools/examples/hello-c/autoclean.sh.
	* libtextstyle/examples/color-hello/autogen.sh: New file, based on
	gettext/gettext-tools/examples/hello-c/autogen.sh.
	* libtextstyle/examples/color-hello/configure.ac: New file.
	* libtextstyle/examples/color-hello/hello.c: New file.
	* libtextstyle/examples/color-hello/hello-default.css: New file.
	* libtextstyle/examples/color-hello/names.c: New file.
	* libtextstyle/lib/Makefile.am: New file, based on libunistring/lib/Makefile.am.
	* libtextstyle/lib/misc.h: New file.
	* libtextstyle/lib/misc.c: New file.
	* libtextstyle/lib/notinline.h: New file, based on
	libunistring/lib/unistring-notinline.h.
	* libtextstyle/lib/stdbool.mini.h: New file, based on
	libunistring/lib/stdbool.mini.h.
	* libtextstyle/lib/textstyle.h: New file, based on
	gnulib-local/lib/*ostream.oo.h.
	* libtextstyle/lib/textstyle/version.in.h: New file, based on
	libunistring/lib/unistring/version.in.h.
	* libtextstyle/lib/textstyle/woe32dll.in.h: New file, based on
	libunistring/lib/unistring/woe32dll.in.h.
	* libtextstyle/lib/version.c: New file, based on libunistring/lib/version.c.
	* libtextstyle/m4/init-package-version.m4: New file, copied from
	libunistring/m4/init-package-version.m4.
	* libtextstyle/tests/Makefile.am: New file, based on
	libunistring/tests/Makefile.am.
	* libtextstyle/version.sh: New file, based on libunistring/version.sh.
	* libtextstyle/woe32dll/c++fd-styled-ostream.cc: New file.
	* libtextstyle/woe32dll/c++html-styled-ostream.cc: New file.
	* libtextstyle/woe32dll/c++term-styled-ostream.cc: New file.
	* gnulib-local/lib/glib/gstring.c (g_string_append_c): In libtextstyle, honor a
	macro definition.
	* gnulib-local/lib/libxml/elfgcchack.h: In libtextstyle, make this entire file a
	no-op.
	* gnulib-local/lib/libxml/globals.in.h (docbDefaultSAXHandler,
	htmlDefaultSAXHandler, oldXMLWDcompatibility, xmlBufferAllocScheme,
	xmlDefaultBufferSize, xmlDefaultSAXHandler, xmlDefaultSAXLocator,
	xmlDoValidityCheckingDefaultValue, xmlFree, xmlGenericError, xmlStructuredError,
	xmlGenericErrorContext, xmlStructuredErrorContext, xmlGetWarningsDefaultValue,
	xmlIndentTreeOutput, xmlTreeIndentString, xmlKeepBlanksDefaultValue,
	xmlLineNumbersDefaultValue, xmlLoadExtDtdDefaultValue, xmlMalloc,
	xmlMallocAtomic, xmlMemStrdup, xmlParserDebugEntities, xmlParserVersion,
	xmlPedanticParserDefaultValue, xmlRealloc, xmlSaveNoEmptyTags,
	xmlSubstituteEntitiesDefaultValue, xmlRegisterNodeDefaultValue,
	xmlDeregisterNodeDefaultValue, xmlLastError,
	xmlParserInputBufferCreateFilenameValue, xmlOutputBufferCreateFilenameValue): In
	libtextstyle, honor a macro definition.
	* gnulib-local/lib/libxml/globals.c (xmlFree, xmlMalloc, xmlMallocAtomic,
	xmlMemStrdup, xmlRealloc, docbDefaultSAXHandler, htmlDefaultSAXHandler,
	oldXMLWDcompatibility, xmlBufferAllocScheme, xmlDefaultBufferSize,
	xmlDefaultSAXHandler, xmlDefaultSAXLocator, xmlDoValidityCheckingDefaultValue,
	xmlGenericError, xmlStructuredError, xmlGenericErrorContext,
	xmlStructuredErrorContext, xmlGetWarningsDefaultValue, xmlIndentTreeOutput,
	xmlTreeIndentString, xmlKeepBlanksDefaultValue, xmlLineNumbersDefaultValue,
	xmlLoadExtDtdDefaultValue, xmlParserDebugEntities, xmlParserVersion,
	xmlPedanticParserDefaultValue, xmlSaveNoEmptyTags,
	xmlSubstituteEntitiesDefaultValue, xmlRegisterNodeDefaultValue,
	xmlDeregisterNodeDefaultValue, xmlLastError,
	xmlParserInputBufferCreateFilenameValue, xmlOutputBufferCreateFilenameValue):
	Likewise.
	* gnulib-local/lib/libxml/xmlmemory.c (xmlMalloc): Likewise.

	gnulib-local: New module 'fd-styled-ostream'.
	* gnulib-local/lib/fd-styled-ostream.oo.h: New file.
	* gnulib-local/lib/fd-styled-ostream.oo.c: New file.
	* gnulib-local/modules/fd-styled-ostream: New file.
	* gnulib-local/Makefile.am (EXTRA_DIST): Add them.

	term-ostream: Remove the need for an exit handler.
	* gnulib-local/lib/term-ostream.oo.c (output_buffer): Delay the error() call
	until the default state has been restored.

	term-ostream: Prepare for robustness through signal handling.
	* gnulib-local/lib/term-ostream.oo.h (ttyctl_t): New type.
	(term_ostream_create): Add tty_control argument.
	* gnulib-local/lib/term-ostream.oo.c (term_ostream_create): Likewise.
	* gnulib-local/lib/term-styled-ostream.oo.h: Include term-ostream.h.
	(term_styled_ostream_create): Add tty_control argument.
	* gnulib-local/lib/term-styled-ostream.oo.c (term_styled_ostream_create):
	Likewise.
	* gnulib-local/tests/test-term-ostream.c (main): Use TTYCTL_AUTO.
	* gettext-tools/src/color.c (print_color_test): Likewise.
	* gettext-tools/src/write-catalog.c (msgdomain_list_print): Likewise.

	libasprintf: Tweak documentation formatting.
	* gettext-runtime/libasprintf/autosprintf.texi: Indent all paragraphs the same
	way.

	Fix typo in comment.
	* gettext-tools/src/color.h (style_file_prepare): Fix typo in comment.

	doc: Fix typo.
	* gettext-tools/doc/gettext.texi (Styles rules): Fix typo.

2019-02-09  Bruno Haible  <bruno@clisp.org>

	Update copyright years.

	Remove automatically generated files from version control.

	html-styled-ostream: Fix memory leak.
	* gnulib-local/lib/html-styled-ostream.oo.c (html_styled_ostream::free): Free
	the stream.

	html-ostream: Fix memory leak.
	* gnulib-local/lib/html-ostream.oo.c: Include minmax.h.
	(verify_invariants, shrink_class_stack): New functions.
	(emit_pending_spans): Use them.
	(html_ostream::write_mem): Shrink class stack during newline processing.
	(html_ostream::free, html_ostream::begin_span): Verify invariants.
	(html_ostream::end_span): Likewise. Shrink class stack.
	* gnulib-local/modules/html-ostream (Depends-on): Add 'minmax'.

2019-02-08  Bruno Haible  <bruno@clisp.org>

	examples: Fix build failure when building from git (regression from 2018-10-23).
	* gettext-tools/examples/po/xsmallpot.sh: Build less of 'hello-pascal'.

	color: Make color.c package-neutral.
	* gettext-tools/src/color.h (style_file_prepare): Add arguments.
	* gettext-tools/src/color.c: Don't include relocatable.h.
	(style_file_lookup): Add stylesdir_after_install argument.
	(style_file_prepare): Add arguments.
	* gettext-tools/src/write-catalog.c: Include relocatable.h.
	(GETTEXTSTYLESDIR): New macro.
	(msgdomain_list_print): Update style_file_prepare calls.
	* gettext-tools/tests/init-env.in (GETTEXTSTYLESDIR): New environment variable.

	term-ostream: Accommodate a shell that is not in /bin/sh.
	* gnulib-local/tests/test-term-ostream-xterm.sh: Renamed from
	gnulib-local/tests/test-term-ostream-xterm.
	* gnulib-local/modules/term-ostream-tests (Files, Makefile.am): Update
	accordingly.
	* gnulib-local/Makefile.am (EXTRA_DIST): Likewise.

	libglib: Fix list of files to clean.
	* gnulib-local/modules/libglib (MOSTLYCLEANFILES): Add glib.h-t, glibconfig.h-t.

	build: Code style.
	* autogen.sh: Make it clear that 'touch config.h.in' is tied to autoheader.

2019-02-05  Bruno Haible  <bruno@clisp.org>

	Remove left-over empty directories in 'make distclean'.
	* gettext-tools/gnulib-tests/Makefile.am (distclean-local): New target.

2019-02-04  Bruno Haible  <bruno@clisp.org>

	Fix copyright years.

2019-01-25  Bruno Haible  <bruno@clisp.org>

	doc: Mention --color=test in the description of the --color option.
	Reported by Nathaniel M. Beaver <nathanielmbeaver@gmail.com>
	in <https://savannah.gnu.org/bugs/?55573>.

	* gettext-tools/doc/gettext.texi (Colorizing): Mention that the --color and
	--style options are applicable to many programs.
	(The --color option): Mention the 'test' value.

2019-01-21  Bruno Haible  <bruno@clisp.org>

	msginit: Update for current shape of Translation Project.
	Reported by Karl Ove Hufthammer <karl@huftis.org>
	in <https://lists.gnu.org/archive/html/bug-gettext/2019-01/msg00014.html>.

	* gettext-tools/projects/TP/teams.html: Fetched from teams.url.
	* gettext-tools/projects/TP/team-address: Update sed expressions for current
	structure of teams page.

2019-01-06  Bruno Haible  <bruno@clisp.org>

	Make cldr-plurals program more robust.
	* gettext-tools/src/cldr-plurals.c: Include closeout.h.
	(main): Arrange to invoke close_stdout at program exit.

	Assume setlocale function.
	* gettext-runtime/src/envsubst.c (main): Assume setlocale exists.
	* gettext-runtime/src/gettext.c (main): Likewise.
	* gettext-runtime/src/ngettext.c (main): Likewise.
	* gettext-tools/src/cldr-plurals.c (main): Likewise.
	* gettext-tools/src/hostname.c (main): Likewise.
	* gettext-tools/src/msgattrib.c (main): Likewise.
	* gettext-tools/src/msgcat.c (main): Likewise.
	* gettext-tools/src/msgcmp.c (main): Likewise.
	* gettext-tools/src/msgcomm.c (main): Likewise.
	* gettext-tools/src/msgconv.c (main): Likewise.
	* gettext-tools/src/msgen.c (main): Likewise.
	* gettext-tools/src/msgexec.c (main): Likewise.
	* gettext-tools/src/msgfilter.c (main): Likewise.
	* gettext-tools/src/msgfmt.c (main): Likewise.
	* gettext-tools/src/msggrep.c (main): Likewise.
	* gettext-tools/src/msginit.c (main, canonical_locale_charset, get_title):
	Likewise.
	* gettext-tools/src/msgmerge.c (main): Likewise.
	* gettext-tools/src/msgunfmt.c (main): Likewise.
	* gettext-tools/src/msguniq.c (main): Likewise.
	* gettext-tools/src/recode-sr-latin.c (main): Likewise.
	* gettext-tools/src/urlget.c (main): Likewise.
	* gettext-tools/src/xgettext.c (main): Likewise.
	* gettext-tools/tests/testlocale.c (main): Likewise.
	* gettext-tools/tests/tstgettext.c (main): Likewise.
	* gettext-tools/tests/tstngettext.c (main): Likewise.
	* gettext-runtime/m4/intl.m4 (AM_INTL_SUBDIR): Don't test whether setlocale
	exists.

	Update after gnulib changed.

	Update to newest gnulib.

2018-12-17  Bruno Haible  <bruno@clisp.org>

	Fix compilation error on HP-UX with gcc.
	* gnulib-local/lib/libxml/trionan.c: Include <float.h>.

2018-12-16  Bruno Haible  <bruno@clisp.org>

	Add comment regarding HP-UX cc in C99 mode.
	* gnulib-local/lib/gettext.h (_LIBGETTEXT_HAVE_VARIABLE_SIZE_ARRAYS): Update
	comment.

2018-11-25  Bruno Haible  <bruno@clisp.org>

	intl: Really uninstall the intl/ subdir sources.
	* gettext-runtime/intl/Makefile.am (uninstall-sources): New target.

	Fix compilation error (regression from today).
	* autogen.sh (GNULIB_MODULES_RUNTIME_FOR_SRC): Add 'unistd'.
	* gettext-runtime/src/envsubst.c: Include <unistd.h>.

	build: Use Automake in intl subdirectory.
	* gettext-runtime/intl/Makefile.am: New file, based on
	gettext-runtime/intl/Makefile.in.
	* gettext-runtime/intl/Makefile.in: Remove file.
	* autogen.sh: Copy gettext-runtime/intl/Makefile.am to
	gettext-tools/intl/Makefile.am.
	* gettext-runtime/configure.ac (USE_INCLUDED_LIBINTL, BUILD_INCLUDED_LIBINTL,
	PACKAGE_IS_GETTEXT_TOOLS, PRELOADABLE_LIBINTL): New conditionals.
	* gettext-tools/configure.ac: Likewise.

	build: Stop generating a VERSION file.
	* gettext-tools/configure.ac: Don't create intl/VERSION.
	* gettext-runtime/intl/Makefile.in (DISTFILES.normal): Remove variable.
	(distclean): Simplify accordingly.

	build: Remove some duplicate .m4 files.
	* autogen.sh: Copy wchar_t.m4 and wint_t.m4 for libasprintf.
	* gettext-runtime/m4/codeset.m4: Remove file.
	* gettext-runtime/m4/extern-inline.m4: Remove file.
	* gettext-runtime/m4/intl-thread-locale.m4: Remove file.
	* gettext-runtime/m4/lcmessage.m4: Remove file.
	* gettext-runtime/m4/lock.m4: Remove file.
	* gettext-runtime/m4/longlong.m4: Remove file.
	* gettext-runtime/m4/threadlib.m4: Remove file.
	* gettext-runtime/m4/wchar_t.m4: Remove file.
	* gettext-runtime/m4/wint_t.m4: Remove file.
	* gettext-runtime/m4/Makefile.am (EXTRA_DIST): Don't distribute them.
	* Makefile.am (distcheck-hook): Don't verify that they are identical copies.

	build: Fix #line statements in bison-generated files.
	* gettext-tools/src/plural-exp.c: Revert changes from 2014-12-03 and 2014-12-04.
	* gettext-runtime/intl/Makefile.in (PLURAL_OBJECT): Remove variable.
	(OBJECTS): Use plural.lo always.
	($(srcdir)/plural.c): New rule.
	(.y.c, pluralx.c, pluralx.lo): Remove rules.
	(mostlyclean): Delete the temporary file of the plural.c rule.
	(maintainer-clean): Delete plural.c.
	* gettext-tools/configure.ac (intl/Makefile): Remove PLURAL_OBJECT hack.

	build: Fix #line statements in bison-generated files.
	* gettext-tools/src/Makefile.am (po-gram-gen.c, cldr-plural.c): Override the
	Automake .y.c rule.
	(po-gram-gen.h, cldr-plural.h): Remove separate target.
	(po-gram-gen2.h): Generate in the source directory.

	maint: Add write-up of how to do code coverage.

2018-11-25  Bruno Haible  <bruno@clisp.org>

	libasprintf: On mingw, really use our vasprintf function, not mingw_vasprintf.
	mingw now has a definition of 'vasprintf' in <stdio.h> that redirects to
	mingw_vasprintf, which does not support argument reordering (i.e.
	HAVE_POSIX_PRINTF is not defined). Make sure to avoid this function and use
	the one defined in our lib-asprintf.c instead.

	* gettext-runtime/libasprintf/lib-asprintf.h (asprintf): Define as macro
	redirecting to libasprintf_asprintf.
	(vasprintf): Define as macro redirecting to libasprintf_vasprintf.
	* gettext-runtime/libasprintf/lib-asprintf.c: Define also libasprintf_asprintf
	and libasprintf_vasprintf.
	* gettext-runtime/libasprintf/autosprintf.cc: Include lib-asprintf.h last.

2018-11-25  Bruno Haible  <bruno@clisp.org>

	msginit: Add comment about test failure on native Windows.
	* gettext-tools/tests/msginit-3: Add comment.

	msginit: On native Windows, produce same PO header as on Unix.
	* gettext-tools/src/msginit.c (plural_forms): Eliminate a trailing CR.

	envsubst: On native Windows, produce output suitable for the shell.
	* autogen.sh (GNULIB_MODULES_RUNTIME_FOR_SRC): Add 'binary-io'.
	* gettext-runtime/src/envsubst.c (main): In --variables mode, put stdout in
	binary mode.

	Fix some mingw test failures.
	* gettext-tools/tests/intl-1: Ignore different end-of-line convention in the
	output.
	* gettext-tools/tests/intl-2: Likewise.
	* gettext-tools/tests/intl-3: Likewise.
	* gettext-tools/tests/msgfmt-desktop-1: Likewise.
	* gettext-tools/tests/msgfmt-desktop-2: Likewise.
	* gettext-tools/tests/sentence-1: Likewise.
	* gettext-tools/tests/cldr-plurals-1: Likewise.
	* gettext-tools/tests/lang-c: On native Windows, ignore different end-of-line
	convention in the output.
	* gettext-tools/tests/lang-c++: Likewise.
	* gettext-tools/tests/msgfilter-8: On native Windows, use sh, not /bin/sh.

	Fix some mingw test failures.
	* gettext-tools/tests/init-env.in (wabs_srcdir, wabs_top_srcdir): New variables.
	(GETTEXTDATADIR): On mingw, use native Windows syntax.
	* gettext-tools/tests/format-c-3: Use wabs_srcdir instead of abs_srcdir, and
	wabs_top_srcdir instead of abs_top_srcdir.
	* gettext-tools/tests/format-c-4: Likewise.
	* gettext-tools/tests/format-c-5: Likewise.
	* gettext-tools/tests/gettextpo-1: Likewise.
	* gettext-tools/tests/intl-1: Likewise.
	* gettext-tools/tests/intl-2: Likewise.
	* gettext-tools/tests/intl-3: Likewise.
	* gettext-tools/tests/intl-4: Likewise.
	* gettext-tools/tests/intl-setlocale-1: Likewise.
	* gettext-tools/tests/intl-setlocale-2: Likewise.
	* gettext-tools/tests/intl-thread-1: Likewise.
	* gettext-tools/tests/intl-thread-2: Likewise.
	* gettext-tools/tests/intl-thread-3: Likewise.
	* gettext-tools/tests/msgfmt-qt-1: Likewise.
	* gettext-tools/tests/msgfmt-qt-2: Likewise.
	* gettext-tools/tests/msginit-3: Likewise.
	* gettext-tools/tests/msginit-4: Likewise.
	* gettext-tools/tests/msgmerge-compendium-5: Likewise.
	* gettext-tools/tests/msgmerge-compendium-6: Likewise.
	* gettext-tools/tests/msgunfmt-3: Likewise.
	* gettext-tools/tests/msgunfmt-tcl-1: Likewise.
	* gettext-tools/tests/msguniq-1: Likewise.
	* gettext-tools/tests/msguniq-2: Likewise.
	* gettext-tools/tests/msguniq-3: Likewise.
	* gettext-tools/tests/msguniq-4: Likewise.
	* gettext-tools/tests/plural-1: Likewise.
	* gettext-tools/tests/xgettext-1: Likewise.
	* gettext-tools/tests/xgettext-c-1: Likewise.
	* gettext-tools/tests/xgettext-c-comment-6: Likewise.
	* gettext-tools/tests/xgettext-c-escape-3: Likewise.
	* gettext-tools/tests/xgettext-vala-2: Likewise.

	intl: Fix gettext test failures on mingw.
	* gettext-runtime/intl/localename.c (gl_locale_name_posix): Convert the result
	of gl_locale_name_environ to XPG syntax.

	Update to newest gnulib.

	Fix typo in comment.
	* gettext-tools/src/msgexec.c (process_string): Fix typo in comment.

	Fix typos in tests.
	* gettext-tools/tests/msgfmt-desktop-1: Fix reference to MSGFMT variable.
	* gettext-tools/tests/msgfmt-desktop-2: Likewise.
	* gettext-tools/tests/msgfmt-xml-1: Likewise.
	* gettext-tools/tests/msgfmt-xml-2: Likewise.

2018-11-25  Bruno Haible  <bruno@clisp.org>

	build: Remove generated files from version control.
	This creates a bootstrapping issue, but it can be mitigated:
	If a user wants to build GNU gettext on a platform which does not have the
	GNU gettext programs installed, they first need to build and install a tarball
	of GNU gettext; then only they can build GNU gettext from the git repository.

	* gettext-runtime/po/gettext-runtime.pot: Remove file.
	* gettext-tools/po/gettext-tools.pot: Remove file.
	* gettext-tools/examples/po/gettext-examples.pot: Remove file.

2018-11-25  Bruno Haible  <bruno@clisp.org>

	build: Update .gitignore for 2018-05-19 change in gnulib.

	build: Update .gitignore for 2018-02-02 change in gnulib.

	build: Update .gitignore for 2017-05-01 change in gnulib.

	build: Update .gitignore for 2017-03-11 change in gnulib.

	build: Update .gitignore for 2017-05-04 change.

	build: Fix mistake in .gitignore (from 2016-12-11).

	Amend 'Stop installing the intl/ subdir sources.' commit from 2018-11-11.
	* gettext-runtime/intl/Makefile.in (install-data, uninstall): Remove the entire
	$prefix/share/gettext/intl directory.

	Fix compilation error on mingw (regression from 2018-11-04).
	* gettext-tools/src/x-appdata.h (SCANNERS_APPDATA): Remove
	literalstring_parser initializer.

2018-11-21  Pavel Raiskup  <praiskup@redhat.com>

	msgfmt: fix C&P issue
	* gettext-tools/src/msgl-check.c (syntax_check_space_ellipsis):
	Use 'end' for buffer size computation, instead of NULL 'ellipsis'.

	format-kde-kuit: really use fallback markup
	* gettext-tools/src/format-kde-kuit.c (format_parse): Use markup.h
	methods when FORMAT_KDE_KUIT_USE_FALLBACK_MARKUP is defined.  Also
	free buffer if there's no support for XML.

2018-11-18  Bruno Haible  <bruno@clisp.org>

	msgmerge must produce output that is stable under msgcat.
	Reported by Ludovic Courtès <ludo@gnu.org>
	in <https://savannah.gnu.org/bugs/?51027>.

	* gettext-tools/src/write-po.c (message_print_obsolete): Preserve the 'no-wrap'
	and '*-format' flags.
	* gettext-tools/tests/msgmerge-27: New file.
	* gettext-tools/tests/msgmerge-28: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add them.
	* gettext-tools/tests/msgmerge-19: Update expected result.

2018-11-18  Bruno Haible  <bruno@clisp.org>

	gettextize: Give more advice.
	* gettext-tools/misc/gettextize.in: Tell the user to remove
	AM_GNU_GETTEXT_INTL_SUBDIR invocations.

	Simplify Autoconf macros.
	* gettext-runtime/m4/intldir.m4: Remove file.
	* gettext-runtime/m4/Makefile.am (EXTRA_DIST): Remove intldir.m4.
	* gettext-runtime/m4/gettext.m4 (AM_GNU_GETTEXT): Disallow 'no-libtool'
	argument. Use libtool always. Remove variables that existed only for backward
	compatibility.
	* gettext-runtime/m4/intl.m4: Update comments.
	* autogen.sh: Ignore gettext.m4 and intl.m4 from gnulib.
	* gettext-runtime/intl/Makefile.in: Use libtool always.
	(libintl.a, libgnuintl.a): Remove rule.
	(.o): Remove suffix rule.
	(install-exec, installdirs, uninstall, distclean, dist, distdir): PACKAGE cannot
	be anything else than gettext-runtime and gettext-tools any more.
	* gettext-tools/configure.ac (intl/Makefile): Update.
	* NEWS: Mention that AM_GNU_GETTEXT_INTL_SUBDIR is gone.

2018-11-17  Bruno Haible  <bruno@clisp.org>

	Make 'make distcheck' work in a VPATH build.
	* Makefile.am (distcheck-hook): Compare files in $(srcdir).
	* gettext-tools/examples/po/xsmallpot.sh: Put the resulting POT file in the
	source dir, not in the build dir.
	* gettext-tools/examples/po/Makefile.am (update-po): Execute sub-make in the
	build dir, not in the source dir.
	(SMALLPOFILES_FOR_lang): Prefix file names with $(srcdir).
	(hello-*/po/*.po): Likewise. Execute mmsmallpo.sh in $(srcdir).

2018-11-11  Bruno Haible  <bruno@clisp.org>

	gettextize: Install also host-cpu-c-abi.m4 (needed since 2018-03-24).
	* gettext-tools/m4/Makefile.am (aclocal_DATA): Install host-cpu-c-abi.m4.
	* PACKAGING: Mention host-cpu-c-abi.m4.
	* gettext-tools/misc/gettextize.in (m4filelist): Add host-cpu-c-abi.m4.
	* gettext-tools/doc/gettext.texi (aclocal): Mention host-cpu-c-abi.m4.

	Update to newest gnulib.

	Update packaging instructions.
	* PACKAGING: Update file list.

	gettextize: Require automake >= 1.9.
	* gettext-tools/misc/gettextize.in: Signal an error if 'aclocal' from
	automake >= 1.9 is not found. Stop installing intldir.m4, intl.m4 and its
	dependencies.
	* gettext-tools/doc/gettext.texi (mkinstalldirs, aclocal): State the requirement
	to have automake >= 1.9.
	* gettext-tools/m4/Makefile.am (aclocal_DATA): Don't install codeset.m4,
	extern-inline.m4, fcntl-o.m4, glibc2.m4, glibc21.m4, intdiv0.m4, intl.m4,
	intl-thread-locale.m4, intldir.m4, intmax.m4, inttypes_h.m4, inttypes-pri.m4,
	lcmessage.m4, lock.m4, longlong.m4, printf-posix.m4, size_max.m4, stdint_h.m4,
	threadlib.m4, uintmax_t.m4, visibility.m4, wchar_t.m4, wint_t.m4, xsize.m4.
	* PACKAGING: Remove the *.m4 files that are no longer installed.

	Stop installing the intl/ subdir sources.
	* gettext-runtime/intl/Makefile.in (gettextsrcdir): Remove variable.
	(DISTFILES.obsolete): Remove variable.
	(install-data): Don't install nor remove anything.
	(installdirs): Don't create $(gettextsrcdir).
	* gettext-tools/misc/add-to-archive: Don't add the intl directory to the
	archive.
	* PACKAGING: Remove mention of $prefix/share/gettext/intl/ directory.

	gettextize: Remove --intl option.
	* gettext-tools/misc/gettextize.in (func_usage): Don't mention --intl option.
	Signal an error if the --intl option is specified.
	Simplify main code accordingly.
	* gettext-tools/doc/gettextize.texi: Remove --intl option description.
	* gettext-tools/doc/gettext.texi (Prerequisites): Remove mention of intl/
	directory.
	(configure.ac): Suggest to use AM_GNU_GETTEXT([external]) always. Remove mention
	of intl/ directory.
	(config.guess): Suggest them always.
	(aclocal): Shrink the list of .m4 files.
	(acconfig): Remove subsection.
	(config.h.in): Remove mention of intl/ directory.
	(Makefile, src/Makefile, lib/gettext.h): Likewise.
	(AM_GNU_GETTEXT): First argument must be 'external'. Remove third argument.
	(AM_GNU_GETTEXT_INTL_SUBDIR): Remove subsection.
	(Language Implementors): Remove mention of intl/ directory. Mention that
	Solaris 11 gettext works like GNU gettext.
	(Maintainers for other Languages): Remove mention of intl/ directory.
	* gettext-tools/doc/autopoint.texi: Update explanation of name.
	* NEWS: Mention the change.

2018-11-09  Bruno Haible  <bruno@clisp.org>

	xgettext tests: Rename xgettext-c-18 to xgettext-c-6.
	* gettext-tools/tests/xgettext-c-6: Renamed from
	gettext-tools/tests/xgettext-c-18.
	* Makefile.am (TESTS): Update.

	xgettext tests: Rename xgettext-c-25 to xgettext-c-5.
	* gettext-tools/tests/xgettext-c-5: Renamed from
	gettext-tools/tests/xgettext-c-25.
	* Makefile.am (TESTS): Update.

2018-11-08  Bruno Haible  <bruno@clisp.org>

	xgettext tests: Rename xgettext-c-24 to xgettext-c-comment-6.
	* gettext-tools/tests/xgettext-c-comment-6: Renamed from
	gettext-tools/tests/xgettext-c-24.
	* gettext-tools/tests/xg-c-comment-6.c: Renamed from
	gettext-tools/tests/xg-c-24.c.
	* Makefile.am (TESTS, EXTRA_DIST): Update.

	xgettext tests: Rename xgettext-c-9 to xgettext-c-comment-5.
	* gettext-tools/tests/xgettext-c-comment-5: Renamed from
	gettext-tools/tests/xgettext-c-9.
	* Makefile.am (TESTS): Update.

	xgettext tests: Rename xgettext-c-6 to xgettext-c-comment-4.
	* gettext-tools/tests/xgettext-c-comment-4: Renamed from
	gettext-tools/tests/xgettext-c-6.
	* Makefile.am (TESTS): Update.

	xgettext tests: Rename xgettext-c-16 to xgettext-c-comment-3.
	* gettext-tools/tests/xgettext-c-comment-3: Renamed from
	gettext-tools/tests/xgettext-c-16.
	* Makefile.am (TESTS): Update.

	xgettext tests: Rename xgettext-c-7 to xgettext-c-comment-2.
	* gettext-tools/tests/xgettext-c-comment-2: Renamed from
	gettext-tools/tests/xgettext-c-7.
	* Makefile.am (TESTS): Update.

	xgettext tests: Rename xgettext-c-5 to xgettext-c-comment-1.
	* gettext-tools/tests/xgettext-c-comment-1: Renamed from
	gettext-tools/tests/xgettext-c-5.
	* Makefile.am (TESTS): Update.

	xgettext tests: Rename xgettext-c-21 to xgettext-c-escape-3.
	* gettext-tools/tests/xgettext-c-escape-3: Renamed from
	gettext-tools/tests/xgettext-c-21.
	* gettext-tools/tests/xg-c-escape-3.c: Renamed from
	gettext-tools/tests/xg-c-21.c.
	* Makefile.am (TESTS, EXTRA_DIST): Update.

	xgettext tests: Rename xgettext-c-23 to xgettext-c-escape-2.
	* gettext-tools/tests/xgettext-c-escape-2: Renamed from
	gettext-tools/tests/xgettext-c-23.
	* Makefile.am (TESTS): Update.

	xgettext tests: Rename xgettext-c-19 to xgettext-c-escape-1.
	* gettext-tools/tests/xgettext-c-escape-1: Renamed from
	gettext-tools/tests/xgettext-c-19.
	* Makefile.am (TESTS): Update.

	xgettext tests: Rename xgettext-c-14 to xgettext-c-format-5.
	* gettext-tools/tests/xgettext-c-format-5: Renamed from
	gettext-tools/tests/xgettext-c-14.
	* Makefile.am (TESTS): Update.

	xgettext tests: Rename xgettext-c-17 to xgettext-c-format-4.
	* gettext-tools/tests/xgettext-c-format-4: Renamed from
	gettext-tools/tests/xgettext-c-17.
	* Makefile.am (TESTS): Update.

	xgettext tests: Rename xgettext-c-13 to xgettext-c-format-3.
	* gettext-tools/tests/xgettext-c-format-3: Renamed from
	gettext-tools/tests/xgettext-c-13.
	* Makefile.am (TESTS): Update.

	xgettext tests: Rename xgettext-c-8 to xgettext-c-format-2.
	* gettext-tools/tests/xgettext-c-format-2: Renamed from
	gettext-tools/tests/xgettext-c-8.
	* Makefile.am (TESTS): Update.

	xgettext tests: Rename xgettext-c-12 to xgettext-c-format-1.
	* gettext-tools/tests/xgettext-c-format-1: Renamed from
	gettext-tools/tests/xgettext-c-12.
	* Makefile.am (TESTS): Update.

	xgettext tests: Rename xgettext-c-15 to xgettext-c-ctxt-3.
	* gettext-tools/tests/xgettext-c-ctxt-3: Renamed from
	gettext-tools/tests/xgettext-c-15.
	* Makefile.am (TESTS): Update.

	xgettext tests: Rename xgettext-c-11 to xgettext-c-ctxt-2.
	* gettext-tools/tests/xgettext-c-ctxt-2: Renamed from
	gettext-tools/tests/xgettext-c-11.
	* Makefile.am (TESTS): Update.

	xgettext tests: Rename xgettext-c-10 to xgettext-c-ctxt-1.
	* gettext-tools/tests/xgettext-c-ctxt-1: Renamed from
	gettext-tools/tests/xgettext-c-10.
	* Makefile.am (TESTS): Update.

	xgettext tests: Rename xgettext-c-22 to xgettext-c-c++-2.
	* gettext-tools/tests/xgettext-c-c++-2: Renamed from
	gettext-tools/tests/xgettext-c-22.
	* Makefile.am (TESTS): Update.

	xgettext tests: Rename xgettext-c-20 to xgettext-c-c++-1.
	* gettext-tools/tests/xgettext-c-c++-1: Renamed from
	gettext-tools/tests/xgettext-c-20.
	* Makefile.am (TESTS): Update.

2018-11-05  Bruno Haible  <bruno@clisp.org>

	xgettext: C: Treat invalid escape sequences like GCC does.
	* gettext-tools/src/x-c.c (phase7_getc): For invalid escape sequences "\c",
	produce c, not a backslash.

	xgettext: Simplify calling convention of arglist_parser_remember.
	* gettext-tools/src/xg-arglist-parser.h (struct partial_call): Add
	'msgid_comment_is_utf8' field.
	(arglist_parser_remember): Add comment_is_utf8 argument.
	* gettext-tools/src/xg-arglist-parser.c (arglist_parser_alloc,
	arglist_parser_clone): Update.
	(arglist_parser_remember): Add comment_is_utf8 argument.
	(arglist_parser_done): Pass comment_is_utf8 value down to remember_a_message.
	* gettext-tools/src/x-c.c (extract_parenthesized): Update callers. Don't set
	xgettext_current_source_encoding around arglist_parser_remember calls.
	* gettext-tools/src/x-csharp.c (extract_parenthesized): Likewise.
	* gettext-tools/src/x-java.c (extract_parenthesized): Likewise.
	* gettext-tools/src/x-javascript.c (extract_balanced): Likewise.
	* gettext-tools/src/x-perl.c (extract_balanced): Likewise.
	* gettext-tools/src/x-python.c (extract_balanced): Likewise.
	* gettext-tools/src/x-vala.c (extract_balanced): Likewise.
	* gettext-tools/src/x-awk.c (extract_parenthesized): Update callers.
	* gettext-tools/src/x-elisp.c (read_object): Likewise.
	* gettext-tools/src/x-librep.c (read_object): Likewise.
	* gettext-tools/src/x-lisp.c (read_object): Likewise.
	* gettext-tools/src/x-lua.c (extract_balanced): Likewise.
	* gettext-tools/src/x-php.c (extract_balanced): Likewise.
	* gettext-tools/src/x-scheme.c (read_object): Likewise.
	* gettext-tools/src/x-sh.c (read_command): Likewise.
	* gettext-tools/src/x-tcl.c (read_command): Likewise.

	xgettext: Delay calls to from_current_source_encoding, part 2.
	* gettext-tools/src/xg-arglist-parser.h: Include xg-mixed-string.h.
	(struct partial_call): Change type of fields msgctxt, msgid, msgid_plural to
	'mixed_string_ty *'.
	(arglist_parser_remember, arglist_parser_remember_msgctxt): Take a
	'mixed_string_ty *' argument instead of a 'char *' argument.
	* gettext-tools/src/xg-arglist-parser.c (arglist_parser_clone): Update
	accordingly.
	(arglist_parser_remember, arglist_parser_remember_msgctxt): Take a
	'mixed_string_ty *' argument.
	(arglist_parser_done): Convert the mixed_string to UTF-8 encoded 'char *' here.
	This is where from_current_source_encoding gets invoked now: immediately before
	invoking remember_a_message, that is, only when we really need to know the
	--from-source encoding.
	* gettext-tools/src/x-c.c (extract_parenthesized): Pass the mixed_string to
	arglist_parser_remember. Don't set xgettext_current_source_encoding around
	arglist_parser_done calls.
	* gettext-tools/src/x-csharp.c (extract_parenthesized): Likewise.
	* gettext-tools/src/x-java.c (extract_parenthesized): Likewise.
	* gettext-tools/src/x-javascript.c (extract_balanced): Likewise.
	* gettext-tools/src/x-python.c (extract_balanced): Likewise.
	* gettext-tools/src/x-vala.c (extract_balanced): Likewise.
	* gettext-tools/src/x-lisp.c: Include xg-mixed-string.h.
	(read_object): Convert the string to a mixed_string_ty before passing it to
	arglist_parser_remember.
	* gettext-tools/src/x-elisp.c: Likewise.
	* gettext-tools/src/x-librep.c: Likewise.
	* gettext-tools/src/x-scheme.c: Likewise.
	* gettext-tools/src/x-awk.c: Include xg-mixed-string.h.
	(extract_parenthesized): Convert the string to a mixed_string_ty before passing
	it to arglist_parser_remember.
	* gettext-tools/src/x-lua.c: Include xg-mixed-string.h.
	(extract_balanced): Convert the string to a mixed_string_ty before passing it to
	arglist_parser_remember.
	* gettext-tools/src/x-php.c: Include xg-mixed-string.h.
	(extract_balanced): Convert the string to a mixed_string_ty before passing it to
	arglist_parser_remember.
	* gettext-tools/src/x-sh.c: Include xg-mixed-string.h.
	(read_command): Convert the string to a mixed_string_ty before passing it to
	arglist_parser_remember.
	* gettext-tools/src/x-tcl.c: Include xg-mixed-string.h.
	(read_command): Convert the string to a mixed_string_ty before passing it to
	arglist_parser_remember.
	* gettext-tools/src/x-perl.c (extract_balanced): Convert the string to a
	mixed_string_ty before passing it to arglist_parser_remember. Don't set
	xgettext_current_source_encoding around arglist_parser_done calls.

	xgettext: Simplify calling convention of remember_a_message.
	* gettext-tools/src/xg-message.h (remember_a_message,
	remember_a_message_plural): Add is_utf8, comment_is_utf8 arguments.
	* gettext-tools/src/xg-message.c (remember_a_message,
	remember_a_message_plural): Likewise.
	* gettext-tools/src/xg-arglist-parser.c (arglist_parser_done): Update callers.
	* gettext-tools/src/x-awk.c (extract_parenthesized): Likewise.
	* gettext-tools/src/x-c.c (extract_parenthesized): Likewise.
	* gettext-tools/src/x-csharp.c (extract_parenthesized): Likewise.
	* gettext-tools/src/x-desktop.c (extract_desktop_handle_pair): Likewise.
	* gettext-tools/src/x-elisp.c (read_object): Likewise.
	* gettext-tools/src/x-java.c (extract_parenthesized): Likewise.
	* gettext-tools/src/x-javascript.c (extract_balanced): Likewise.
	* gettext-tools/src/x-librep.c (read_object): Likewise.
	* gettext-tools/src/x-lisp.c (read_object): Likewise.
	* gettext-tools/src/x-lua.c (extract_balanced): Likewise.
	* gettext-tools/src/x-perl.c (extract_variable, interpolate_keywords,
	extract_balanced): Likewise.
	* gettext-tools/src/x-php.c (extract_balanced): Likewise.
	* gettext-tools/src/x-python.c (extract_balanced): Likewise.
	* gettext-tools/src/x-rst.c (extract_rst, extract_rsj): Likewise.
	* gettext-tools/src/x-scheme.c (read_object): Likewise.
	* gettext-tools/src/x-sh.c (read_word, read_command): Likewise.
	* gettext-tools/src/x-smalltalk.c (extract_smalltalk): Likewise.
	* gettext-tools/src/x-tcl.c (read_command): Likewise.
	* gettext-tools/src/x-vala.c (extract_balanced): Likewise.
	* gettext-tools/src/x-ycp.c (extract_parenthesized): Likewise.
	* gettext-tools/src/xgettext.c (xgettext_its_extract_callback): Likewise.

	xgettext: Delay calls to from_current_source_encoding, part 1.
	* xg-mixed-string.h (enum segment_type, struct mixed_string_segment,
	struct mixed_string, mixed_string_ty): New types.
	(mixed_string_alloc_simple, mixed_string_alloc_utf8, mixed_string_clone,
	mixed_string_contents, mixed_string_free, mixed_string_contents_free1,
	mixed_string_concat, mixed_string_concat_free1): New declarations.
	(struct mixed_string_buffer): Change internal representation to use segments.
	(mixed_string_buffer_result): Change return type to 'mixed_string_ty *'.
	* xg-mixed-string.c: Include flexmember.h, msgl-ascii.h, po-charset.h.
	(segment_alloc, segment_clone, mixed_string_alloc_simple,
	mixed_string_alloc_utf8, mixed_string_clone, mixed_string_contents,
	mixed_string_free, mixed_string_contents_free1, mixed_string_concat,
	mixed_string_concat_free1): New functions.
	(mixed_string_buffer_init, mixed_string_buffer_is_empty): Change to match new
	internal representation.
	(mixed_string_buffer_grow_curr_buffer): New function.
	(mixed_string_buffer_grow_utf8_buffer): Remove function.
	(mixed_string_buffer_append_to_utf8_buffer): Update accordingly.
	(mixed_string_buffer_flush_curr_buffer): Remove function.
	(mixed_string_buffer_add_segment, mixed_string_buffer_flush_curr): New
	functions.
	(mixed_string_buffer_append_char, mixed_string_buffer_append_unicode,
	mixed_string_buffer_destroy, mixed_string_buffer_result): Change to match new
	internal representation.
	* x-c.c (struct token_ty): New field 'mixed_string'.
	(free_token): Update accordingly.
	(phase5_get, phase6_get, phase8a_get): For tokens of type
	token_type_string_literal, use a mixed_string.
	(phase8_get): Use mixed_string_concat_free1.
	(struct xgettext_token_ty): New field 'mixed_string'.
	(x_c_lex, extract_parenthesized): For tokens of type
	xgettext_token_type_string_literal, use a mixed_string.
	* x-csharp.c (comment_line_end): Update.
	(struct token_ty): New field 'mixed_string'.
	(free_token): Update accordingly.
	(phase6_get): For tokens of type token_type_string_literal, use a mixed_string.
	(phase7_get): Use mixed_string_concat_free1.
	(extract_parenthesized): For tokens of type token_type_string_literal, use a
	mixed_string.
	* x-java.c (comment_line_end): Update.
	(struct token_ty): New field 'mixed_string'.
	(free_token): Update accordingly.
	(phase5_get): For tokens of type token_type_string_literal, use a mixed_string.
	(phase6_get): Use mixed_string_concat_free1.
	(extract_parenthesized): For tokens of type token_type_string_literal, use a
	mixed_string.
	* x-javascript.c (comment_line_end): Update.
	(struct token_ty): New field 'mixed_string'.
	(free_token): Update accordingly.
	(phase5_get): For tokens of type token_type_string, use a mixed_string.
	(x_javascript_lex): Use mixed_string_concat_free1.
	(extract_balanced): For tokens of type token_type_string, use a mixed_string.
	* x-python.c (comment_line_end): Update.
	(struct token_ty): New field 'mixed_string'.
	(free_token): Update accordingly.
	(phase5_get): For tokens of type token_type_string, use a mixed_string.
	(x_python_lex): Use mixed_string_concat_free1.
	(extract_balanced): For tokens of type token_type_string, use a mixed_string.
	* x-rst.c (extract_rsj): Update.
	* x-vala.c (struct token_ty): New field 'mixed_string'.
	(free_token): Update accordingly.
	(phase3_get): For tokens of type token_type_string_literal, use a mixed_string.
	For tokens of type token_type_string_template, fix a memory leak.
	(x_vala_lex): Use mixed_string_concat_free1.
	(extract_balanced): For tokens of type token_type_string_literal, use a
	mixed_string.

	xgettext: JavaScript: Make more use of mixed_string_buffer.
	* gettext-tools/src/x-javascript.c (struct unicode_string_buffer): Remove type.
	(init_unicode_string_buffer, unicode_string_buffer_append_unicode_grow,
	unicode_string_buffer_append_unicode, unicode_string_buffer_result,
	free_unicode_string_buffer): Remove functions.
	(comment_buffer, comment_start, comment_at_start, comment_add,
	comment_line_end): Use mixed_string_buffer API.

	xgettext: Python: Make more use of mixed_string_buffer.
	* gettext-tools/src/x-python.c (struct unicode_string_buffer): Remove type.
	(init_unicode_string_buffer, unicode_string_buffer_append_unicode_grow,
	unicode_string_buffer_append_unicode, unicode_string_buffer_result,
	free_unicode_string_buffer): Remove functions.
	(comment_buffer, comment_start, comment_at_start, comment_add,
	comment_line_end): Use mixed_string_buffer API.

	xgettext: Change the C# extractor to make use of mixed_string_buffer.
	* gettext-tools/src/x-csharp.c (struct string_buffer): Remove type.
	(init_string_buffer, string_buffer_append_unicode_grow,
	string_buffer_append_unicode, string_buffer_result, free_string_buffer): Remove
	functions.
	(comment_buffer, comment_start, comment_at_start, comment_add,
	comment_line_end): Use mixed_string_buffer API.
	(phase6_get): Likewise.

	xgettext: Optimize away a memory allocation.
	* gettext-tools/src/x-c.c (phase5_get): Allocate the mixed_string_buffer on the
	stack, not on the heap.
	* gettext-tools/src/x-csharp.c (phase6_get): Likewise.
	* gettext-tools/src/x-javascript.c (phase5_get): Likewise.
	* gettext-tools/src/x-python.c (phase5_get): Likewise.
	* gettext-tools/src/x-vala.c (phase3_get): Likewise.
	* gettext-tools/src/x-rst.c (stringbuf, parse_string, extract_rsj): Allocate the
	mixed_string_buffer statically, not on the heap.
	* gettext-tools/src/xg-mixed-string.h (mixed_string_buffer_alloc,
	mixed_string_buffer_done): Remove declarations.
	* gettext-tools/src/xg-mixed-string.c (mixed_string_buffer_alloc,
	mixed_string_buffer_done): Remove functions.

	xgettext: Change the Java extractor to make use of mixed_string_buffer.
	* gettext-tools/src/xg-mixed-string.h: Include <stdbool.h>.
	(mixed_string_buffer_init, mixed_string_buffer_is_empty,
	mixed_string_buffer_destroy, mixed_string_buffer_result): New declarations.
	* gettext-tools/src/xg-mixed-string.c: Include xg-pos.h.
	(mixed_string_buffer_init): New function.
	(mixed_string_buffer_alloc): Invoke it.
	(mixed_string_buffer_is_empty): New function, based on comment_at_start in
	x-java.c.
	(mixed_string_buffer_append_lone_surrogate): New function, based on
	string_buffer_append_lone_surrogate in x-java.c.
	(mixed_string_buffer_flush_utf16_surr, mixed_string_buffer_append_unicode): Use
	it.
	(mixed_string_buffer_destroy, mixed_string_buffer_result): New functions.
	(mixed_string_buffer_done): Invoke mixed_string_buffer_result.
	* gettext-tools/src/x-java.c: Include xg-mixed-string.h.
	(struct string_buffer): Remove type.
	(init_string_buffer, string_buffer_append_byte,
	string_buffer_append_unicode_grow, string_buffer_append_unicode,
	string_buffer_append_lone_surrogate, string_buffer_flush_utf16_surr,
	string_buffer_flush_curr_buffer): Remove functions.
	(mixed_string_buffer_append): Renamed from string_buffer_append. Use
	mixed_string_buffer.
	(string_buffer_result, free_string_buffer): Remove functions.
	(comment_buffer, comment_start, comment_at_start, comment_add,
	comment_line_end): Use mixed_string_buffer API.
	(accumulate_escaped, phase5_get): Likewise.

	xgettext: Share some more code among extractors.
	* gettext-tools/src/xg-pos.h: New file.
	* gettext-tools/src/xg-pos.c: New file.
	* gettext-tools/src/Makefile.am (noinst_HEADERS): Add xg-pos.h.
	(xgettext_SOURCES): Add xg-pos.c.
	* gettext-tools/src/FILES: Update.
	* gettext-tools/src/x-awk.c: Include xg-pos.h.
	(real_file_name, logical_file_name, line_number): Remove variables.
	* gettext-tools/src/x-c.c: Likewise.
	* gettext-tools/src/x-csharp.c: Likewise.
	* gettext-tools/src/x-elisp.c: Likewise.
	* gettext-tools/src/x-java.c: Likewise.
	* gettext-tools/src/x-javascript.c: Likewise.
	* gettext-tools/src/x-librep.c: Likewise.
	* gettext-tools/src/x-lisp.c: Likewise.
	* gettext-tools/src/x-lua.c: Likewise.
	* gettext-tools/src/x-perl.c: Likewise.
	* gettext-tools/src/x-php.c: Likewise.
	* gettext-tools/src/x-python.c: Likewise.
	* gettext-tools/src/x-rst.c: Likewise.
	* gettext-tools/src/x-scheme.c: Likewise.
	* gettext-tools/src/x-sh.c: Likewise.
	* gettext-tools/src/x-smalltalk.c: Likewise.
	* gettext-tools/src/x-tcl.c: Likewise.
	* gettext-tools/src/x-vala.c: Likewise.
	* gettext-tools/src/x-ycp.c: Likewise.

	xgettext: Split source code into smaller files.
	* gettext-tools/src/rc-str-list.h: New file, extracted from
	gettext-tools/src/xgettext.h.
	* gettext-tools/src/xg-encoding.h: Likewise.
	* gettext-tools/src/xg-mixed-string.h: Likewise.
	* gettext-tools/src/xg-arglist-context.h: Likewise.
	* gettext-tools/src/xg-arglist-callshape.h: Likewise.
	* gettext-tools/src/xg-arglist-parser.h: Likewise.
	* gettext-tools/src/xg-message.h: Likewise.
	* gettext-tools/src/xg-encoding.c: New file, extracted from
	gettext-tools/src/xgettext.c.
	* gettext-tools/src/xg-mixed-string.c: Likewise.
	* gettext-tools/src/xg-arglist-context.c: Likewise.
	* gettext-tools/src/xg-arglist-callshape.c: Likewise.
	* gettext-tools/src/xg-arglist-parser.c: Likewise.
	* gettext-tools/src/xg-message.c: Likewise.
	* gettext-tools/src/xgettext.h: Remove declarations that moved to rc-str-list.h
	and xg-*.h.
	(add_all_comments, comment_tag, msgstr_prefix, msgstr_suffix,
	default_syntax_check, current_formatstring_parser1,
	current_formatstring_parser2, current_formatstring_parser3): New declarations.
	(xgettext_comment, xgettext_comment_reset, savable_comment_to_xgettext_comment,
	recognize_qt_formatstrings): New declarations.
	(substring_match): Remove obsolete declaration.
	* gettext-tools/src/xgettext.c: Include xgettext.h first.
	Include <iconv.h>, rc-str-list.h, xg-encoding.h, xg-arglist-context.h,
	xg-message.h. Don't include xsize.h, po-xerror.h, unistr.h.
	(add_all_comments, comment_tag, msgstr_prefix, msgstr_suffix,
	default_syntax_check): Make global.
	(split_keywordspec, insert_keyword_callshape): Moved to xg-arglist-callshape.c.
	(null_context, passthrough_context, inherited_context,
	null_context_list_iterator, passthrough_context_circular_list,
	passthrough_context_list_iterator, flag_context_list_iterator,
	flag_context_list_iterator_advance, flag_context_list_table_lookup): Move to
	xg-arglist-context.c.
	(flag_context_list_table_insert): Move bulk of body to new function
	flag_context_list_table_add in xg-arglist-context.c.
	(xgettext_comment, xgettext_comment_reset, savable_comment_to_xgettext_comment):
	Make global.
	(current_formatstring_parser1, current_formatstring_parser2,
	current_formatstring_parser3): Make global.
	(non_ascii_error_message, from_current_source_encoding): Move to xg-encoding.c.
	(CONVERT_STRING, set_format_flags_from_context, warn_format_string,
	remember_a_message, remember_a_message_plural): Move to xg-message.c.
	(arglist_parser_alloc, arglist_parser_clone, arglist_parser_remember,
	arglist_parser_remember_msgctxt, arglist_parser_decidedp, arglist_parser_done):
	Move to xg-arglist-parser.c.
	(mixed_string_buffer_alloc, mixed_string_buffer_append_to_curr_buffer,
	mixed_string_buffer_grow_utf8_buffer, mixed_string_buffer_append_to_utf8_buffer,
	mixed_string_buffer_flush_utf16_surr, mixed_string_buffer_flush_curr_buffer,
	mixed_string_buffer_append_char, mixed_string_buffer_append_unicode,
	mixed_string_buffer_done): Move to xg-mixed-string.c.
	(recognize_qt_formatstrings): New function.
	* gettext-tools/src/x-*.h: Include xg-arglist-context.h instead of xgettext.h.
	* gettext-tools/src/x-*.c: Update include directives.
	* gettext-tools/src/its.h: Likewise.
	* gettext-tools/src/Makefile.am (noinst_HEADERS): Add the new .h files.
	(xgettext_SOURCES): Add the new .c files.
	* gettext-tools/src/FILES: Update.

	xgettext: Fix crash when parsing invalid \Uxxxxxxxx escape sequence.
	* gettext-tools/src/x-c.c (phase3_pushback): Increase size to 9 characters.

	xgettext: Add support for C++11 raw string literals.
	* gettext-tools/src/x-c.c (phase5_get): Recognize the R"..." syntax and its variants.
	* gettext-tools/tests/xgettext-c-20: Change expected error message.

	xgettext: Add support for C11 string literals.
	* gettext-tools/src/x-c.c (phase5_get): Recognize the u8"..." syntax.
	* gettext-tools/tests/xgettext-c-25: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.
	* NEWS: Mention the change.

	xgettext: Vala: Improve parsing of escape sequences.
	* gettext-tools/src/x-vala.c (phase7_getc): Don't recognize \?, \a, \1...\7, \U.
	Do recognize \$.
	* gettext-tools/tests/xgettext-vala-1: Test \t in verbatim strings literals.
	* NEWS: Mention the change.

2018-11-05  Bruno Haible  <bruno@clisp.org>

	xgettext: Fix result for concatenation of strings with escape sequences.
	Reported by Morten Welinder <mwelinder@gmail.com>
	in <https://lists.gnu.org/archive/html/bug-gettext/2015-12/msg00017.html>
	and <https://savannah.gnu.org/bugs/?46756>.

	Revert commits from
	2014-05-07 xgettext: Provide a way to interpret string literals lazily
	2014-05-07 c: Interpret string literals lazily
	2014-05-09 vala: Interpret string literals lazily
	2014-12-02 c: Support C++11 string literals
	and subsequent fixes of these.

	* gettext-tools/src/xgettext.h (savable_comment_convert_encoding): Remove
	declaration.
	(enum literalstring_escape_type, struct literalstring_parser): Remove types.
	(struct partial_call): Update.
	(arglist_parser_remember_literal): Remove declaration.
	* gettext-tools/src/xgettext.c (struct extractor_ty): Remove
	'literalstring_parser' field.
	(savable_comment_convert_encoding): Remove function.
	(current_literalstring_parser): Remove variable.
	(extract_from_file, arglist_parser_alloc, arglist_parser_clone): Update.
	(arglist_parser_remember_literal): Remove function.
	(arglist_parser_remember_msgctxt): Simplify accordingly.
	* gettext-tools/src/x-*.h (SCANNERS_*): Remove literalstring_parser initializer.
	* gettext-tools/src/x-c.h (literalstring_c): Remove declaration.
	* gettext-tools/src/x-c.c: Remove all traces of literalstring_escape_type and
	literalstring_parser.
	(phase7_getc, phase7_ungetc): Reinstantiate functions.
	(phase5_get): Simplify. Use phase7_getc.
	* gettext-tools/src/x-vala.c: Remove all traces of literalstring_escape_type and
	literalstring_parser.
	(phase7_getc, phase7_ungetc): Reinstantiate functions.
	(phase3_get): Simplify. Use phase7_getc.
	(extract_balanced): Simplify.

2018-11-05  Bruno Haible  <bruno@clisp.org>

	xgettext: New tests for non-ASCII extracted comments.
	* gettext-tools/tests/xgettext-c-24: New file.
	* gettext-tools/tests/xg-c-24.c: New file.
	* gettext-tools/tests/xgettext-vala-2: New file.
	* gettext-tools/tests/xg-vala-2.vala: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add xgettext-c-24, xgettext-vala-2.
	(EXTRA_DIST): Add xg-c-24.c, xg-vala-2.vala.

	xgettext: Enhance test for NUL byte handling.
	* gettext-tools/tests/xg-c-21.c: Add some more test cases.
	* gettext-tools/tests/xgettext-c-21: Update expected result accordingly. Change
	expected result for backslash-NUL.

2018-11-04  Bruno Haible  <bruno@clisp.org>

	xgettext: New test of concatenation of strings with escape sequences.
	Reported by Morten Welinder <mwelinder@gmail.com>
	in <https://lists.gnu.org/archive/html/bug-gettext/2015-12/msg00017.html>
	and <https://savannah.gnu.org/bugs/?46756>.

	* gettext-tools/tests/xgettext-c-23: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2018-11-04  Bruno Haible  <bruno@clisp.org>

	xgettext: JavaScript: Fix a memory leak.
	* gettext-tools/src/x-javascript.c (free_token): Free tp->string also for
	token_type_keyword.

	Whitespace changes.
	* gettext-tools/src/cldr-plural-exp.h: Add a blank line.
	* gettext-tools/src/locating-rule.h: Correct indentation.

	Fix test failure with valgrind.
	* gettext-tools/tests/msgcmp-4: Filter out valgrind's messages from the output.

2018-10-28  Bruno Haible  <bruno@clisp.org>

	Make test files executable.
	* gettext-tools/tests/xgettext-c-22: Make executable.
	* gettext-tools/tests/xgettext-properties-[234]: Likewise.
	* gettext-tools/tests/xgettext-rst-[12]: Likewise.

	Make it easier to build the code when the documentation tools don't work.
	* gettext-tools/Makefile.am (SUBDIRS): Move 'doc' to the end. Move 'its' to the
	middle.

	tests: Improve reliability.
	* xgettext-3: Verify the exit code of the xgettext invocation.
	* xgettext-4: Likewise.
	* xgettext-appdata-1: Likewise.
	* xgettext-c-19: Likewise.
	* xgettext-c-20: Likewise.
	* xgettext-c-21: Likewise.
	* xgettext-csharp-2: Likewise.
	* xgettext-csharp-3: Likewise.
	* xgettext-csharp-8: Likewise.
	* xgettext-desktop-1: Likewise.
	* xgettext-glade-1: Likewise.
	* xgettext-glade-6: Likewise.
	* xgettext-glade-7: Likewise.
	* xgettext-gsettings-1: Likewise.
	* xgettext-perl-2: Likewise.
	* xgettext-perl-3: Likewise.

2018-10-25  Bruno Haible  <bruno@clisp.org>

	po, examples: Change .po -> .gmo rules to consider the newest changes to the POT file.
	Reported by Claude Paroz <claude@2xlibre.net>
	in <https://savannah.gnu.org/bugs/?50910>.

	* gettext-runtime/m4/po.m4 (AM_PO_SUBDIRS): Set MSGMERGE_FOR_MSGFMT_OPTION.
	* gettext-runtime/po/Makefile.in.in (MSGMERGE): Use GNU msgmerge, even if not
	first in $PATH.
	(MSGMERGE_FOR_MSGFMT_OPTION): New variable.
	(.po.gmo): Depend on the POT file. Use msgmerge on the fly, to take into
	account the most recent POT file changes.
	* gettext-tools/examples/hello-*/po/Makefile.am: Likewise, also for the .po.qm,
	update-properties, update-classes targets.
	* gettext-tools/examples/hello-objc-gnustep/po/GNUmakefile
	(MSGMERGE_FOR_MSGFMT_OPTION): New variable.
	($(STRINGSFILES)): Depend on the POT file. Use msgmerge on the fly, to take
	into account the most recent POT file changes.

2018-10-25  Bruno Haible  <bruno@clisp.org>

	msgmerge: New option --for-msgfmt.
	* gettext-tools/src/msgmerge.c (for_msgfmt): New variable.
	(long_options): Add option --for-msgfmt.
	(main): Handle option --for-msgfmt.
	(usage): Document option --for-msgfmt.
	(match_domain): When --for-msgfmt is given, omit untranslated and fuzzy messages
	from the result.
	(merge): When --for-msgfmt is given, don't add obsolete messages to the result.
	* gettext-tools/tests/msgmerge-26: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.
	* gettext-tools/doc/msgmerge.texi: Mention the option --for-msgfmt.
	* NEWS: Mention the change.

	Add ability to write PO files without translator comment lines.
	* gettext-tools/src/write-po.h (message_print_style_comment): New declaration.
	* gettext-tools/src/write-po.c (print_comment): New variable.
	(message_print_style_comment): New function.
	(message_print_comment): Output nothing if print_comment is false.

2018-10-24  Bruno Haible  <bruno@clisp.org>

	Improve reliability of 'make dist'.
	* gettext-tools/examples/po/Makefile.am (distdir1): Depend on the .pot file.

2018-10-24  Bruno Haible  <bruno@clisp.org>

	po, examples: Put stamp-po in the source directory.
	Rationale: <https://www.gnu.org/prep/standards/html_node/Makefile-Basics.html>.

	* gettext-runtime/po/Makefile.in.in: Use $(srcdir)/stamp-po instead of stamp-po.
	Talk about "version control system", not CVS.
	* gettext-tools/examples/hello-*/po/Makefile.am: Likewise.
	* gettext-tools/examples/po/Makefile.am: Likewise.
	* gettext-tools/examples/check-examples (func_check_dist_vpath): Verify the
	stamp-po file does not exist in the build dir, except when using the older
	Makefile.in.in infrastructure.

2018-10-24  Bruno Haible  <bruno@clisp.org>

	po: Make "make maintainer-clean" erase the .pot file.
	Rationale:
	<https://www.gnu.org/prep/standards/html_node/Standard-Targets.html>
	<https://www.gnu.org/software/automake/manual/html_node/Clean.html>

	* NEWS: Mention the change.
	* gettext-runtime/po/Makefile.in.in (maintainer-clean): Remove the .pot file.
	* gettext-tools/examples/hello-*/po/Makefile.am (MAINTAINERCLEANFILES): Add
	the .pot file.
	* gettext-tools/examples/po/Makefile.am (MAINTAINERCLEANFILES): Likewise.
	* gettext-tools/examples/check-examples (func_check_maintainerclean,
	func_check_maintainerclean_vpath): Verify the .pot file is removed after
	'make maintainer-clean', except when using the older Makefile.in.in
	infrastructure.

2018-10-24  Bruno Haible  <bruno@clisp.org>

	po, examples: Use case-insensitive search for "GNU <PACKAGE_NAME>".
	Reported by Akim Demaille <akim@lrde.epita.fr> in
	<https://lists.gnu.org/archive/html/bug-gettext/2018-10/msg00020.html>.

	* gettext-runtime/po/Makefile.in.in ($(DOMAIN).pot-update): Use a
	case-insensitive search for "GNU <PACKAGE_NAME>".
	* gettext-tools/examples/hello-*/po/Makefile.am ($(DOMAIN).pot-update):
	Likewise.
	* gettext-tools/examples/hello-objc-gnustep/po/GNUmakefile
	($(DOMAIN).pot-update): Likewise.

2018-10-24  Bruno Haible  <bruno@clisp.org>

	po: Remove obsolete Makefile rules for .mo files.
	* gettext-runtime/po/Makefile.in.in (MSGFMT*): Remove variables.
	(.SUFFIXES): Remove .mo.
	(.po.mo): Remove rule.
	(distclean): Don't remove *.mo files.
	* gettext-tools/examples/hello-*/po/Makefile.am (.SUFFIXES): Remove .mo.
	(.po.mo): Remove rule.
	(DISTCLEANFILES): Remove *.mo.
	* gettext-tools/examples/hello-objc-gnustep/po/GNUmakefile (.SUFFIXES):
	Remove .mo.
	* gettext-runtime/m4/po.m4 (AM_PO_SUBDIRS): Don't set MSGFMT_015.

2018-10-24  Bruno Haible  <bruno@clisp.org>

	Remove outdated DJGPP build infrastructure.
	Approved by Juan Manuel Guerrero <juan.guerrero@gmx.de>.

	* djgpp: Remove directory.
	* Makefile.am (EXTRA_DIST): Remove the djgpp files.

2018-10-24  Bruno Haible  <bruno@clisp.org>

	examples: Add support for msgmerge --previous.
	This mirrors the Makefile.in.in change from 2016-07-01.

	* gettext-tools/examples/hello-*/po/Makefile.am ($(POFILES), update-po): Use
	option --previous when the msgmerge program supports it.
	* gettext-tools/examples/hello-objc-gnustep/po/GNUmakefile: Likewise.

2018-10-24  Bruno Haible  <bruno@clisp.org>

	examples: Support reading header comments from file.
	This mirrors the Makefile.in.in change from 2015-09-01 with the amendment
	from today.

	* gettext-tools/examples/hello-*/po/Makefile.am ($(DOMAIN).pot-update):
	Replace header entry with the content of $(DOMAIN).pot-header, if exists.
	* gettext-tools/examples/hello-objc-gnustep/po/GNUmakefile: Likewise.

2018-10-24  Bruno Haible  <bruno@clisp.org>

	examples: Make it possible to pass custom options to msginit.
	This mirrors the Makevars change from 2014-10-08.

	* gettext-tools/examples/hello-*/po/Makefile.am (MSGINIT_OPTIONS): New variable.
	* gettext-tools/examples/hello-objc-gnustep/po/GNUmakefile: Likewise.

2018-10-24  Bruno Haible  <bruno@clisp.org>

	examples: Add an option to claim the package as GNU/non-GNU.
	This mirrors the Makefile.in.in and Makevars change from 2014-05-01.

	Reported by David Shea at <https://savannah.gnu.org/bugs/?40520>.

	* gettext-runtime/po/Makefile.in.in ($(DOMAIN).pot-update): Tweak whitespace.
	* gettext-tools/examples/hello-*/po/Makefile.am (PACKAGE_GNU): New variable.
	($(DOMAIN).pot-update): Don't search for "GNU packagename" if $(PACKAGE_GNU) is
	set.
	* gettext-tools/examples/hello-objc-gnustep/po/GNUmakefile: Likewise.

2018-10-24  Bruno Haible  <bruno@clisp.org>

	examples: Upgrade to newest Makevars.
	* gettext-tools/examples/hello-*/po/Makevars (PACKAGE_GNU, MSGINIT_OPTIONS,
	PO_DEPENDS_ON_POT, DIST_DEPENDS_ON_UPDATE_PO): New variables.
	* gettext-tools/examples/hello-*/configure.* (AM_GNU_GETTEXT_VERSION): Require
	version 0.19.8.
	* gettext-tools/examples/po/xsmallpot.sh (hello-c++-kde): Likewise.
	* gettext-tools/examples/hello-*/m4/Makefile.am (EXTRA_DIST): Update list of .m4
	files.
	* gettext-tools/examples/hello-*/autoclean.sh: Likewise.
	* gettext-tools/examples/check-examples (func_check_maintainerclean,
	func_check_maintainerclean_vpath): Allow left-over .po~ files.

2018-10-24  Bruno Haible  <bruno@clisp.org>

	examples: Avoid grepping through monster files.
	This mirrors the Makefile.in.in change from 2010-06-12.

	Reported by Jim Meyering <jim@meyering.net>.

	* gettext-tools/examples/hello-*/po/Makefile.am (($(DOMAIN).pot-update): When
	GNU find is available, avoid grepping through monster files.
	* gettext-tools/examples/hello-objc-gnustep/po/GNUmakefile: Likewise.

2018-10-24  Bruno Haible  <bruno@clisp.org>

	examples: Don't create unnecessary installation directories.
	This mirrors the Makefile.in.in change from 2009-06-09.

	Reported by Serge Pavlovsky <pal666@gmail.com>.

	* gettext-tools/examples/hello-*/po/Makefile.am (install-data-local-yes,
	installdirs-local-yes): Remove unnecessary MKDIR_P invocations.

2018-10-24  Bruno Haible  <bruno@clisp.org>

	po: Make the insertion of the .pot-header file more robust.
	This improves on the 2015-09-01 patch.

	* gettext-runtime/po/Makefile.in.in ($(DOMAIN).pot-update): Fail if the 'cat'
	command fails.

2018-10-24  Bruno Haible  <bruno@clisp.org>

	po: When doing msgmerge --version, use the correct msgmerge program.
	This reverts the patch from
	<https://lists.gnu.org/archive/html/bug-gettext/2015-06/msg00000.html>.
	Rationale:
	<https://lists.gnu.org/archive/html/bug-gettext/2018-10/msg00000.html>.

	* gettext-runtime/po/Makefile.in.in ($(POFILES)): Use $(MSGMERGE_UPDATE),
	not $(MSGMERGE).

2018-10-24  Bruno Haible  <bruno@clisp.org>

	po: Make $(POFILES) target more robust.
	It was introduced on 2014-05-01.

	* gettext-runtime/po/Makefile.in.in ($(POFILES)): Create POT file also when the
	PO file does not yet exist. Fail if creation of the POT file fails.

2018-10-23  Bruno Haible  <bruno@clisp.org>

	Update list of files to check with gnulib.
	* Makefile.am (distcheck): Check also localename-table.h and localename-table.c.

	intl: Improve support for per-thread locales on Solaris 11.4.
	* gettext-runtime/intl/localename.c: Update from gnulib:
	Handle HAVE_SOLARIS114_LOCALES through Solaris specific code.
	* gettext-runtime/intl/localename-table.in.h: Update from gnulib's
	localename-table.h.
	* gettext-runtime/intl/localename-table.c: Update from gnulib.
	* gettext-runtime/m4/intl-thread-locale.m4: Renamed from
	gettext-runtime/m4/intlsolaris.m4.
	(gt_INTL_THREAD_LOCALE_NAME): Renamed from gt_INTL_SOLARIS. Define
	HAVE_SOLARIS114_LOCALES instead of HAVE_NAMELESS_LOCALES.
	* gettext-runtime/m4/intl.m4: Update from gnulib:
	(AM_INTL_SUBDIR): Require gt_INTL_THREAD_LOCALE_NAME. Test for 'uselocale'. Set
	HAVE_NAMELESS_LOCALES.
	(gt_INTL_SUBDIR_CORE): Don't invoke gt_INTL_SOLARIS. Don't set
	HAVE_NAMELESS_LOCALES here.
	* gettext-runtime/m4/Makefile.am (EXTRA_DIST): List intl-thread-locale.m4, not
	intlsolaris.m4.
	* gettext-tools/m4/Makefile.am (aclocal_DATA): List intl-thread-locale.m4, not
	intlsolaris.m4.
	* gettext-tools/misc/gettextize.in (m4filelist): List intl-thread-locale.m4, not
	intlsolaris.m4.
	* Makefile.am (distcheck-hook): Check intl-thread-locale.m4, not intlsolaris.m4.
	* gettext-tools/doc/gettext.texi (aclocal): List intl-thread-locale.m4, not
	intlsolaris.m4.
	* PACKAGING: List intl-thread-locale.m4, not intlsolaris.m4.

	Update to newest gnulib.

	intl: Fix support for per-thread locales on Solaris 11.4.
	* gettext-runtime/intl/localename-table.in.h: Renamed from
	gettext-runtime/intl/localename-table.h.
	* gettext-runtime/intl/Makefile.in (HEADERS): Add localename-table.in.h. Remove
	localename-table.h.
	(localename-table.h): New target.
	(localename.$lo, localename-table.$lo): Update dependencies.
	(mostlyclean): Remove localename-table.h.

2018-10-23  Daiki Ueno  <ueno@gnu.org>

	xgettext: Fix compiler warning
	* gettext-tools/src/x-javascript.c (phase5_scan_regexp): Remove
	implicit argument.  Reported in:
	<https://savannah.gnu.org/bugs/?48404>.

2018-10-23  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* configure.ac: Require Autoconf >= 2.63.
	* gettext-runtime/configure.ac: Likewise.
	* gettext-runtime/libasprintf/configure.ac: Likewise.
	* gettext-tools/configure.ac: Likewise.

	Update from gnulib: Assume Autoconf >= 2.63.
	* gettext-runtime/m4/po.m4 (AM_PO_SUBDIRS): Don't set localedir.
	* gettext-runtime/m4/gettext.m4 (AM_GNU_GETTEXT): Update comment.
	* gettext-runtime/m4/fcntl-o.m4 (gl_FCNTL_O_FLAGS): Assume
	AC_USE_SYSTEM_EXTENSIONS exists.
	* gettext-runtime/m4/threadlib.m4 (gl_THREADLIB_EARLY_BODY): Likewise,
	* gettext-runtime/m4/longlong.m4: Require Autoconf >= 2.62. Update comments.
	* gettext-runtime/m4/size_max.m4 (AC_COMPUTE_INT): Remove fallback for
	Autoconf < 2.61.

	Update from gnulib: Assume Automake >= 1.11.
	* gettext-runtime/m4/po.m4 (AM_PO_SUBDIRS, AM_POSTPROCESS_PO_MAKEFILE):
	Eliminate uses of 'eval'.

	Update from gnulib: Make better use of Autoconf.
	* gettext-runtime/m4/visibility.m4: Use AC_CACHE_CHECK where possible.

2018-10-23  Bruno Haible  <bruno@clisp.org>

	intl: Add support for per-thread locales on Solaris 11.4.
	Relies on the recent changes to the 'localename' module in gnulib.

	* gettext-runtime/intl/localename.c: Apply changes from gnulib.
	* gettext-runtime/intl/localename-table.h: New file, from gnulib.
	* gettext-runtime/intl/localename-table.c: New file, from gnulib.
	* gettext-runtime/intl/libgnuintl.in.h (newlocale, duplocale, freelocale): New
	overriding declarations.
	* gettext-runtime/intl/Makefile.in (HEADERS): Add localename-table.h.
	(SOURCES): Add localename-table.c.
	(OBJECTS): Add localename-table.$lo.
	(localename-table.lo): New target.
	(libgnuintl.h, libintl.h): Substitute also HAVE_NAMELESS_LOCALES.
	* gettext-runtime/m4/intl.m4: Apply changes from gnulib:
	(gt_INTL_SUBDIR_CORE): Don't test for 'uselocale' and 'getlocalename_l'.
	Instead, invoke gt_INTL_SOLARIS. Set HAVE_NAMELESS_LOCALES.
	* gettext-runtime/m4/intlsolaris.m4: New file, from gnulib.
	* gettext-runtime/m4/Makefile.am (EXTRA_DIST): Add it.
	* gettext-tools/m4/Makefile.am (aclocal_DATA): Add intlsolaris.m4.
	* gettext-tools/misc/gettextize.in (m4filelist): Add intlsolaris.m4.
	* Makefile.am (distcheck-hook): Verify that intlsolaris.m4 is consistent with
	gnulib.
	* gettext-tools/doc/gettext.texi (aclocal): Add intlsolaris.m4 to the file list.
	* PACKAGING: Add intlsolaris.m4 to the list of installed files.
	* NEWS: Mention the change.

2018-10-23  Bruno Haible  <bruno@clisp.org>

	Update to newest gnulib.

	examples: Fix another build failure.
	* gettext-tools/examples/po/xsmallpot.sh: In hello-pascal, make sure to build
	hello.rsj.

2018-10-21  Bruno Haible  <bruno@clisp.org>

	New subdirectory system-tests.
	* gettext-tools/system-tests/Makefile.am: New file.
	* gettext-tools/system-tests/README: New file.
	* gettext-tools/system-tests/run-test: New file.
	* gettext-tools/system-tests/testlocale.c: New file.
	* gettext-tools/system-tests/intl-1-prg.c: New file.
	* gettext-tools/system-tests/intl-3-prg.c: New file.
	* gettext-tools/system-tests/intl-4-prg.c: New file.
	* gettext-tools/system-tests/intl-5-prg.c: New file.
	* gettext-tools/system-tests/intl-setlocale-1-prg.c: New file.
	* gettext-tools/system-tests/intl-setlocale-2-prg.c: New file.
	* gettext-tools/system-tests/intl-thread-1-prg.c: New file.
	* gettext-tools/system-tests/intl-thread-2-prg.c: New file.
	* gettext-tools/system-tests/intl-thread-3-prg.c: New file.
	* gettext-tools/system-tests/format-c-3-prg.c: New file.
	* gettext-tools/system-tests/format-c-4-prg.c: New file.
	* gettext-tools/system-tests/format-c-5-prg.c: New file.
	* gettext-tools/system-tests/plural-1-prg.c: New file.
	* gettext-tools/Makefile.am (SUBDIRS): Add system-tests.
	* gettext-tools/configure.ac (TEST_SYSTEM_LIBINTL): New conditional.
	(AC_CONFIG_FILES): Add system-tests/Makefile.
	* gettext-tools/tests/init.cfg: Include init-env from the tests/ directory.
	* gettext-tools/tests/intl-5-prg.c: When USE_SYSTEM_LIBINTL is defined, use the
	system's <libintl.h>.
	* gettext-tools/tests/intl-setlocale-1-prg.c: Likewise.
	* gettext-tools/tests/intl-setlocale-2-prg.c: Likewise.
	* gettext-tools/tests/intl-thread-1-prg.c: Likewise.
	* gettext-tools/tests/intl-thread-2-prg.c: Likewise.
	* gettext-tools/tests/intl-thread-3-prg.c: Likewise.
	* gettext-tools/tests/intl-1-prg.c: When USE_SYSTEM_LIBINTL is defined, use the
	system's <libintl.h>.
	* gettext-tools/tests/intl-3-prg.c: Likewise.
	* gettext-tools/tests/intl-4-prg.c: Likewise.
	* gettext-tools/tests/format-c-3-prg.c: Likewise.
	* gettext-tools/tests/format-c-4-prg.c: Likewise.
	* gettext-tools/tests/plural-1-prg.c: Likewise.
	* gettext-tools/tests/format-c-5-prg.c: When USE_SYSTEM_LIBINTL is defined, use
	the system's <libintl.h> and setenv instead of xsetenv, and no fake setlocale.
	* gettext-tools/tests/format-c-3: When USE_SYSTEM_LIBINTL is defined, try
	$LOCALE_FR and $LOCALE_FR_UTF8.
	* gettext-tools/tests/format-c-4: Likewise.
	* gettext-tools/tests/plural-1: Likewise.
	* gettext-tools/tests/format-c-5: When USE_SYSTEM_LIBINTL is defined, try fa_IR
	and fa_IR.UTF-8.

	Update comments.
	* gettext-tools/tests/Makefile.am: Update comments.

	Rename test gettext-8 to intl-5.
	* gettext-tools/tests/intl-5: Renamed from gettext-tools/tests/gettext-8.
	* gettext-tools/tests/intl-5-prg.c: Renamed from
	gettext-tools/tests/gettext-8-prg.c.
	* gettext-tools/tests/Makefile.am: Update.

	Rename test gettext-7 to intl-thread-3 and support more platforms.
	* gettext-tools/tests/intl-thread-3: Renamed from gettext-tools/tests/gettext-7.
	Don't limit to fixed set of platforms.
	* gettext-tools/tests/intl-thread-3-prg.c: Renamed from
	gettext-tools/tests/gettext-7-prg.c. Expect locale names as arguments.
	* gettext-tools/tests/intl-thread-3.po: Renamed from
	gettext-tools/tests/gettext-7.po.
	* gettext-tools/tests/Makefile.am: Update.

	Make the intl-thread-2 test effective on Solaris 11.
	* gettext-tools/m4/locale-de.m4: New file, based on locale-fr.m4 from gnulib.
	* gettext-tools/m4/Makefile.am (EXTRA_DIST): Add it.
	* gettext-tools/configure.ac: Invoke gt_LOCALE_DE_UTF8.
	* gettext-tools/tests/init-env.in: Set LOCALE_DE_UTF8.
	* gettext-tools/tests/intl-thread-2: Use a German instead of a Turkish locale.

	Rename test gettext-6 to intl-thread-2 and support more platforms.
	* gettext-tools/tests/intl-thread-2: Renamed from gettext-tools/tests/gettext-6.
	Don't limit to fixed set of platforms.
	* gettext-tools/tests/intl-thread-2-prg.c: Renamed from
	gettext-tools/tests/gettext-6-prg.c. Expect locale names as arguments.
	* gettext-tools/tests/intl-thread-2-1.po: Renamed from
	gettext-tools/tests/gettext-6-2.po. Convert to UTF-8.
	* gettext-tools/tests/intl-thread-2-2.po: Renamed from
	gettext-tools/tests/gettext-6-1.po. Convert to UTF-8.
	* gettext-tools/tests/Makefile.am: Update.

	New test intl-thread-1.
	* gettext-tools/tests/intl-thread-1: New file.
	* gettext-tools/tests/intl-thread-1-prg.c: New file.
	* gettext-tools/tests/intl-thread-1.po: New file.
	* gettext-tools/tests/Makefile.am: Update.

	Rename test gettext-5 to intl-setlocale-2.
	* gettext-tools/tests/intl-setlocale-2: Renamed from
	gettext-tools/tests/gettext-5.
	* gettext-tools/tests/intl-setlocale-2-prg.c: Renamed from
	gettext-tools/tests/gettext-5-prg.c.
	* gettext-tools/tests/intl-setlocale-2.po: Renamed from
	gettext-tools/tests/gettext-5.po.
	* gettext-tools/tests/Makefile.am: Update.

	Rename test gettext-4 to intl-4.
	* gettext-tools/tests/intl-4: Renamed from gettext-tools/tests/gettext-4.
	* gettext-tools/tests/intl-4-prg.c: Renamed from
	gettext-tools/tests/gettext-4-prg.c.
	* gettext-tools/tests/intl-4.po: Renamed from gettext-tools/tests/gettext-4.po.
	* gettext-tools/tests/Makefile.am: Update.

	New test intl-3.
	* gettext-tools/tests/intl-3: New file.
	* gettext-tools/tests/intl-3-prg.c: New file.
	* gettext-tools/tests/Makefile.amL Update.

	New test intl-2.
	* gettext-tools/tests/intl-2: New file.
	* gettext-tools/tests/intl-2-1.po: New file.
	* gettext-tools/tests/intl-2-2.po: New file.
	* gettext-tools/tests/Makefile.am: Update.

	New test intl-1.
	* gettext-tools/tests/intl-1: New file.
	* gettext-tools/tests/intl-1-prg.c: New file.
	* gettext-tools/tests/intl-1.po: New file.
	* gettext-tools/tests/Makefile.am: Update.

	Rename gettext-3 test to intl-setlocale-1.
	* gettext-tools/tests/intl-setlocale-1: Renamed from
	gettext-tools/tests/gettext-3.
	* gettext-tools/tests/intl-setlocale-1-prg.c: Renamed from
	gettext-tools/tests/gettext-3-prg.c.
	* gettext-tools/tests/intl-setlocale-1-1.po: Renamed from
	gettext-tools/tests/gettext-3-1.po.
	* gettext-tools/tests/intl-setlocale-1-2.po: Renamed from
	gettext-tools/tests/gettext-3-2.po.
	* gettext-tools/tests/Makefile.am: Update.

	Update PACKAGING documentation.
	* PACKAGING: Remove mention of charset.alias (dropped on 2018-05-19).
	Mention that libintl does not get installed on Solaris 11.

	Tests: Update comments.
	* gettext-tools/tests/lang-python-1: Update comment about Python versions.
	* gettext-tools/tests/lang-python-2: Likewise.
	* gettext-tools/tests/lang-pascal: Update comment about fpk versions.

	Fix lang-bash test failure in VPATH builds.
	* gettext-tools/tests/lang-bash: Prepend the gettext-runtime/src build dir,
	not the gettext-runtime/src source dir, to PATH.

2018-10-20  Bruno Haible  <bruno@clisp.org>

	Fix 'make dist' (recent regression).
	* gettext-tools/examples/Makefile.am (EXAMPLESFILES): Remove
	hello-pascal/hello.rst.

2018-10-19  Bruno Haible  <bruno@clisp.org>

	examples: Modernize configure.ac.
	* gettext-tools/examples/hello-*/configure.ac: Use the recommended AC_INIT and
	AM_INIT_AUTOMAKE syntax. Require automake >= 1.11.

	examples: Add a script for checking against mistakes.
	* gettext-tools/examples/check-examples: New file.
	* gettext-tools/examples/HACKING: New file.
	* gettext-tools/examples/Makefile.am (EXTRA_DIST): Add them.
	* Admin/release-steps: Mention check-examples.

	examples: hello-pascal: Fix 'make distcheck'.
	* gettext-tools/examples/hello-pascal/Makefile.am (hello$(EXEEXT)): Move
	hello.rsj into $(srcdir) only if the new contents differs from the old contents.

	examples: hello-java*: Fix 'make distcheck'.
	* gettext-tools/examples/hello-java*/po/Makefile.am (update-properties): Create
	the new .properties files in the build dir and move them to $(srcdir) only if
	the new contents differs from the old contents.
	(update-classes): Likewise, also for .class files.

2018-10-18  Bruno Haible  <bruno@clisp.org>

	examples: hello-csharp*: Improve 'make maintainer-clean'.
	* gettext-tools/examples/hello-csharp*/po/Makefile.am (MAINTAINERCLEANFILES):
	Don't list the $(RESOURCESDLLFILES) here.
	(maintainer-clean-local): Instead, remove them and their parent directories
	here.

	examples: hello-php: Fix runtime error.
	* gettext-tools/examples/hello-php/hello.php: Fix the PHP markup. Don't print
	the return value of the printf function.

	examples: hello-tcl*: Fix runtime error.
	* gettext-tools/examples/hello-tcl*/configure.ac: Ensure pkgdatadir is an
	absolute file name without variable references.

	examples: hello-clisp: Fix runtime error with clisp versions >= 2.34.
	* gettext-tools/examples/hello-clisp/hello.lisp.in: Use the function
	PROCESS-ID, not PROGRAM-ID.

	examples: Fix 'make dist' failures in VPATH builds.
	* gettext-tools/examples/hello-*/po/Makefile.am (distdir1): Invoke target
	'stamp-po' after having done target 'update-po'.

	examples: hello-pascal: Fix 'make dist' failure in VPATH builds.
	* gettext-tools/examples/hello-pascal/Makefile.am: Generate hello.rsj
	in $(srcdir), not in the build dir.

	examples: hello-pascal: Fix 'make dist'.
	* gettext-tools/examples/hello-pascal/Makefile.am (EXTRA_DIST): Add the source
	file.

	examples: hello-java*: Fix "make dist".
	* gettext-runtime/m4/po.m4 (AM_POSTPROCESS_PO_MAKEFILE): Change PROPERTIESFILES
	and CLASSFILES to contain files in $(srcdir), not in $(top_srcdir).
	* gettext-tools/examples/hello-java*/Makefile.am (hello.jar): Fetch the catalogs
	from the po/ directory.
	* gettext-tools/examples/hello-java*/po/Makefile.am (MAINTAINERCLEANFILES):
	Add the .properties and the .class files.
	(EXTRA_DIST): Add the .properties files.
	(update-properties, update-classes): Generate the .properties and .class files
	in the po/ directory, not in the top-level directory.
	* gettext-tools/examples/hello-java*/autoclean.sh: Remove the catalogs in
	the po/ directory, not in the top-level directory.

	examples: Fix 'make dist'.
	* gettext-tools/examples/hello-c/m4/Makefile.am (EXTRA_DIST): Add all files
	that are brought in by 'autopoint'.
	* gettext-tools/examples/hello-c-gnome/m4/Makefile.am (EXTRA_DIST): Likewise.
	* gettext-tools/examples/hello-c-gnome3/m4/Makefile.am (EXTRA_DIST): Likewise.
	* gettext-tools/examples/hello-c++/m4/Makefile.am (EXTRA_DIST): Likewise.
	* gettext-tools/examples/hello-c++-kde/m4/Makefile.am (EXTRA_DIST): Likewise.
	* gettext-tools/examples/hello-c++-gnome/m4/Makefile.am (EXTRA_DIST): Likewise.
	* gettext-tools/examples/hello-objc/m4/Makefile.am (EXTRA_DIST): Likewise.
	* gettext-tools/examples/hello-objc-gnome/m4/Makefile.am (EXTRA_DIST): Likewise.

	examples: Fix 'make' failures in VPATH builds.
	* gettext-tools/examples/hello-java*/Makefile.am (hello_RESOURCES,
	MAINTAINERCLEANFILES): Remove variables.
	(hello.jar): Use two jar commands, to combine .class files from the build dir
	with .properties files from the source dir.
	* gettext-tools/examples/hello-java*/po/Makefile.am (update-properties,
	update-classes): Reference the .pot file in the source dir, not in the build
	dir.
	(echo-catalogs): Include the fallback catalog.
	* gettext-tools/examples/hello-pascal/Makefile.am (hello_SOURCES): Add $(srcdir)
	prefix.
	(hello$(EXEEXT)): Use -o option to specify where the object file and the
	executable file shall be created.

2018-10-17  Bruno Haible  <bruno@clisp.org>

	examples: hello-csharp-forms: Fix 'make clean'.
	* gettext-tools/examples/hello-csharp-forms/Makefile.am (CLEANFILES): Add
	hello.net.exe.mdb.

	examples: hello-csharp: Fix 'make clean'.
	* gettext-tools/examples/hello-csharp/Makefile.am (CLEANFILES): Add
	hello.net.exe.mdb.

	examples: hello-objc-gnustep: Fix 'make distclean'.
	* gettext-tools/examples/hello-objc-gnustep/GNUmakefile (internal-distclean):
	Remove the *.lproj directories.
	* gettext-tools/examples/hello-objc-gnustep/po/GNUmakefile (internal-clean):
	Remove remove-potcdate.sed.

	examples: hello-pascal: Fix 'make maintainer-clean'.
	* gettext-tools/examples/hello-pascal/Makefile.am (MAINTAINERCLEANFILES): New
	variable.

	examples: hello-java: Fix 'make' failure.
	* gettext-tools/examples/hello-java/po/Makefile.am (stamp-po): Fix syntax error.

	examples: hello-pascal: Update.
	* gettext-tools/examples/hello-pascal/configure.ac (PPC): Test for ppcx64 if
	ppc386 is not found.
	* gettext-tools/examples/hello-pascal/hello.rst: Remove file.
	* gettext-tools/examples/hello-pascal/Makefile.am: hello.rsj replaces hello.rst.
	(SUBDIRS): Proceed in current directory before recursing into po/.
	* gettext-tools/examples/hello-pascal/po/Makefile.am (POTFILES): hello.rsj
	replaces hello.rst.
	* gettext-tools/examples/hello-pascal/autoclean.sh: Remove hello.rsj.

	examples: Correctly clean up left-over files.
	* gettext-tools/examples/hello-csharp/autoclean.sh: Handle shell wildcard
	correctly.
	* gettext-tools/examples/hello-csharp-forms/autoclean.sh: Likewise.

2018-10-15  Bruno Haible  <bruno@clisp.org>

	examples: Remove left-over files.
	* gettext-tools/examples/hello-*/autoclean.sh: Remove left-over files.

	examples: Clean up autoconf left-over.
	* gettext-tools/examples/hello-*/autoclean.sh: Remove the 'autom4te.cache'
	directory.

	examples: hello-c++-widgets: Update build infrastructure.
	* gettext-tools/examples/hello-c++-widgets/autogen.sh: Pull in some more .m4
	files.
	* gettext-tools/examples/hello-c++-widgets/autoclean.sh: Remove them.

	Update test after gnulib module 'localcharset' changed.
	* gettext-tools/tests/gettext-4-prg.c: Treat Haiku like BeOS.

	examples: Fix "make dist" error.
	* gettext-tools/examples/po/xsmallpot.sh (hello-c++-kde): Invoke 'autopoint'
	before, not after, 'aclocal'.

	examples: Update developer documentation.
	* gettext-tools/examples/hello-csharp*/po/Makefile.am: Add comment.
	* gettext-tools/examples/hello-tcl*/po/Makefile.am: Likewise.

	examples: Improve developer documentation.
	* gettext-tools/examples/README: Add note about po/ directories.

	examples: Improve developer documentation.
	* HACKING: Mention dependency needed for examples.
	* gettext-tools/examples/hello-objc-gnustep/INSTALL: Small clarifications.

	Fix list of dependencies.
	* DEPENDENCIES: Add libacl.

	C# doc: Fix typo in Makefile.
	* gettext-runtime/intl-csharp/Makefile.am (doc): Fix typo.

2018-10-15  Bruno Haible  <bruno@clisp.org>

	gettextize: Don't redirect stderr.
	Reported by ShellCheck via Pavel Raiskup <praiskup@redhat.com>.

	* gettext-tools/misc/gettextize.in: Don't redirect stderr.

2018-10-15  Bruno Haible  <bruno@clisp.org>

	autopoint: Don't redirect stderr.
	Reported by ShellCheck via Pavel Raiskup <praiskup@redhat.com>.

	* gettext-tools/misc/autopoint.in (func_version_prereq): Don't redirect stderr.

2018-10-15  Bruno Haible  <bruno@clisp.org>

	Fix "make dist" error (regression from 2018-10-09).
	* gettext-tools/examples/Makefile.am (EXAMPLESFILES): Remove
	hello-csharp-forms/BUGS.

2018-10-09  Bruno Haible  <bruno@clisp.org>

	C# support: Remove pnet choice.
	* DEPENDENCIES: Don't mention pnet.
	* PACKAGING: Likewise.
	* gettext-tools/src/format-csharp.c: Simplify comment.
	* gettext-tools/src/msgfmt.cs: Remove workarounds for cscc.
	* gettext-tools/src/write-csharp.c (write_csharp_code): Update comment.
	* gettext-tools/doc/gettext.texi (C#): Don't mention resgen.
	* gettext-tools/tests/lang-csharp: Rely on mono, not pnet.
	* gettext-tools/examples/hello-csharp/INSTALL: Likewise.
	* gettext-tools/examples/hello-csharp-forms/INSTALL: Likewise.
	* gettext-tools/examples/hello-csharp-forms/BUGS: Remove file.

	Update to newest gnulib.

2018-10-06  Bruno Haible  <bruno@clisp.org>

	Fix a build failure on mingw with -O0.
	Reported at <https://savannah.gnu.org/bugs/?36443>.
	Fix suggested by Evgeny Grin <k2k@narod.ru>
	in <https://savannah.gnu.org/bugs/?36443#comment4>.

	* gnulib-local/build-aux/moopp (func_emit_source_h): Wrap the function
	declarations in extern "C" {}.

2018-10-05  Bruno Haible  <bruno@clisp.org>

	msgfmt: Remove outdated warning.
	* gettext-tools/src/msgfmt.c (msgfmt_parse_debrief): Remove outdated warning.
	(struct msgfmt_catalog_reader_ty): Remove field 'has_nonfuzzy_header_entry'.
	(msgfmt_constructor, msgfmt_frob_new_message): Update.

2018-10-05  Bruno Haible  <bruno@clisp.org>

	Fix conflict between different uses of GETTEXTLIBDIR.
	Rationale: The programs installed in $(prefix)/lib/gettext/ are at different
	locations before installation: some are in the source tree, some are in the
	build tree.

	* gettext-tools/src/msginit.c (project_id, project_id_version): Test
	GETTEXTLIBDIR_SRCDIR, not GETTEXTLIBDIR.
	(plural_forms): Test GETTEXTLIBDIR_BUILDDIR, not GETTEXTLIBDIR.
	* gettext-tools/tests/msginit-3: Set GETTEXTLIBDIR_SRCDIR, not GETTEXTLIBDIR.
	* gettext-tools/tests/msginit-4: Set both GETTEXTLIBDIR_SRCDIR and
	GETTEXTLIBDIR_BUILDDIR.

2018-10-05  Bruno Haible  <bruno@clisp.org>

	Fix conflict between different uses of GETTEXTDATADIR.
	* gettext-tools/src/read-tcl.c (msgdomain_read_tcl): Test GETTEXTTCLDIR, not
	GETTEXTDATADIR.
	* gettext-tools/tests/msgunfmt-tcl-1: Set GETTEXTTCLDIR, not GETTEXTDATADIR.

	Fix msginit-4 test failure when run step-by-step.
	* gettext-tools/tests/msginit-4: Don't assume that the test is run in a
	directory with just one POT file.

	cldr-plurals: Improve error handling.
	* gettext-tools/src/cldr-plurals.c (extract_rules): Let libxml2 show errors.
	Don't assume that the error was an out-of-memory.

	Remove unnecessary trailing comma in struct initializers.
	* gettext-tools/src/msgattrib.c (long_options): Remove trailing comma in
	initializer.
	* gettext-tools/src/msgcat.c (long_options): Likewise.
	* gettext-tools/src/msgcomm.c (long_options): Likewise.
	* gettext-tools/src/msgconv.c (long_options): Likewise.
	* gettext-tools/src/msgen.c (long_options): Likewise.
	* gettext-tools/src/msgfilter.c (long_options): Likewise.
	* gettext-tools/src/msgmerge.c (long_options): Likewise.
	* gettext-tools/src/msgunfmt.c (long_options): Likewise.
	* gettext-tools/src/msguniq.c (long_options): Likewise.
	* gettext-tools/src/xgettext.c (long_options): Likewise.

2018-10-05  Bruno Haible  <bruno@clisp.org>

	Explain how to concatenate POT files.
	Reported by Hadi Farah in
	<https://lists.gnu.org/archive/html/bug-gettext/2018-09/msg00026.html>.

	* gettext-tools/doc/msgcat.texi: Explain how to concatenate POT files.

2018-10-05  Bruno Haible  <bruno@clisp.org>

	Include gnulib module 'mkdir', needed for older mingw versions.
	Reported by Maarten Bosmans at <https://savannah.gnu.org/bugs/?33379>.

	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC): Add 'mkdir'.

2018-10-05  Bruno Haible  <bruno@clisp.org>

	Fix link error when building with --enable-shared on mingw.
	* autogen.sh (GNULIB_MODULES_LIBGETTEXTPO_OTHER): Add 'realloc-posix'.

	Fix msginit-4 test failure on Cygwin with --enable-shared.
	* gettext-tools/src/msginit.c (plural_forms): Include the program's directory
	in argv[0].

	Update after gnulib changed.
	* gettext-runtime/intl/vasnprintf.c: Update from gnulib.
	* gettext-runtime/libasprintf/vasnprintf.c: Update from gnulib.

	Update to newest gnulib.

2018-09-19  Bruno Haible  <bruno@clisp.org>

	Avoid test failures on 32-bit Cygwin in a 64-bit Cygwin environment.
	In this situation, argv[0] is absolute, even though the program was invoked
	as a file name without slashes (and thus found in $PATH).

	* gettext-tools/tests/msgcmp-2: Normalize the program name better.
	* gettext-tools/tests/msgcmp-3: Likewise.
	* gettext-tools/tests/msgfmt-7: Likewise.
	* gettext-tools/tests/msgfmt-8: Likewise.
	* gettext-tools/tests/msgfmt-9: Likewise.
	* gettext-tools/tests/msgfmt-10: Likewise.
	* gettext-tools/tests/msgmerge-2: Likewise.
	* gettext-tools/tests/msgmerge-9: Likewise.

2018-09-18  Bruno Haible  <bruno@clisp.org>

	Fix link error when building with --disable-shared on 64-bit Cygwin.
	* gnulib-local/lib/execute.c.diff: Remove file.
	* gnulib-local/lib/spawn-pipe.c.diff: Remove file.
	* gnulib-local/tests/test-environ.c.diff: Remove file.
	* gnulib-local/Makefile.am (EXTRA_DIST): Remove them.

	Fix link error when building with --disable-shared on Cygwin and mingw.
	* gettext-tools/configure.ac (LIBXML_STATIC): Define to 1 when using the
	included libxml and building with --disable-shared.
	* gnulib-local/lib/libxml/libxml.h (LIBXML_STATIC): Define to 1, not empty.

2018-09-17  Bruno Haible  <bruno@clisp.org>

	autogen.sh: Fix use of undefined function.
	* autogen.sh: Rewrite error message code.

2018-09-17  Bruno Haible  <bruno@clisp.org>

	Fix link error on Cygwin.
	Patch partially by Michael Haubenwallner at
	https://gitlab.gnome.org/GNOME/libxml2/commit/c65c9e8ee07e2dab0647392c2bd1795a5bc99829

	* gnulib-local/lib/libxml/xmlexports.in.h: Don't assume that _WIN32 is defined
	on Cygwin.
	(XMLPUBVAR): Define as 'extern', not as empty.

2018-09-17  Bruno Haible  <bruno@clisp.org>

	Fix "Unescaped left brace in regex is deprecated here" warnings from Perl 5.26.
	Reported and patch by Jehan <jehan@girinstud.io> <jehan@zemarmot.net> at
	<https://savannah.gnu.org/bugs/?54088>.

	* gettext-tools/doc/texi2html: Escape braces in regular expressions.
	* gettext-runtime/libasprintf/texi2html: Likewise.

2018-09-17  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* gnulib-local/modules/fnmatch.diff: Update.
	* gettext-runtime/intl/config.charset: Remove file.
	* gettext-runtime/intl/localcharset.h: Update from gnulib.
	* gettext-runtime/intl/localcharset.c: Likewise.
	* gettext-runtime/intl/Makefile.in (DISTFILES.common): Remove config.charset.
	(charset.alias): Remove target.
	(install-exec): Don't install charset.alias.
	(install-data): Don't chmod config.charset.
	(installdirs): Don't create $(libdir).
	(uninstall): Don't uninstall charset.alias.
	(mostlyclean): Don't remove charset.alias.
	* gettext-runtime/intl/lock.h: Update from gnulib.
	* gettext-runtime/intl/verify.h: Likewise.
	* gettext-runtime/intl/printf-parse.c: Likewise.
	* gettext-runtime/libasprintf/printf-parse.c: Likewise.
	* gettext-runtime/m4/extern-inline.m4: Likewise.
	* gettext-runtime/m4/threadlib.m4: Likewise.
	* Makefile.am (distcheck-hook): Don't compare config.charset, ref-add.sin,
	ref-del.sin.

	Update to newest gnulib.

	Fix lang-sh test failure in VPATH builds.
	* gettext-tools/tests/lang-sh: Prepend the gettext-runtime/src build dir,
	not the gettext-runtime/src source dir, to PATH.

2018-09-16  Bruno Haible  <bruno@clisp.org>

	libintl: Improve locale handling on macOS 10.12 or newer.
	* gettext-runtime/intl/langprefs.c (_nl_language_preferences_default): Make the
	logic also work in locales such as "zh-Hans-DE".
	* gettext-runtime/intl/setlocale.c: Include header files for CoreFoundation.
	(libintl_setlocale): Try harder to set a locale for categories LC_CTYPE and
	LC_MESSAGES.

2018-09-16  Bruno Haible  <bruno@clisp.org>

	Don't assume that 'sed' supports alternation in regular expressions.
	See https://www.gnu.org/software/autoconf/manual/autoconf-2.69/html_node/Limitations-of-Usual-Tools.html

	* gettext-tools/tests/msginit-1: Don't use \| in a 'sed' regular expression.
	* gettext-tools/tests/msginit-3: Likewise.
	* gettext-tools/tests/msginit-4: Likewise.

2018-09-16  Bruno Haible  <bruno@clisp.org>

	Update list of locale names with scripts on macOS.
	* gettext-runtime/intl/localename.c (gl_locale_name_canonicalize): Update
	tables to match Mac OS X 10.13 and recent glibc.

	Oops, fix typo.
	* gettext-runtime/m4/intlmacosx.m4 (gt_INTL_MACOSX): Fix variable name.

	Fix link error in "make check" when building with --disable-shared on macOS.
	* gnulib-local/modules/term-ostream-tests (test_term_ostream_LDADD): Add
	@INTL_MACOSX_LIBS@.

	Use newer macOS APIs when possible.
	* gettext-runtime/m4/intlmacosx.m4 (gt_INTL_MACOSX): Check for
	CFLocaleCopyPreferredLanguages.
	* gettext-runtime/intl/langprefs.c (_nl_language_preferences_default): Use
	CFLocaleCopyPreferredLanguages when it exists.

	Revisit macOS specific code.
	* gettext-runtime/intl/localename.c (gl_locale_name_default): Reduce code
	duplication. Fix comments about Mac OS X versions.

2018-09-16  Bruno Haible  <bruno@clisp.org>

	libintl: Fix language preferences on macOS 10.12 or newer.
	Reported by Kristian Rietveld <kris@loopnest.org> at
	<https://savannah.gnu.org/bugs/?49560>.

	* gettext-runtime/intl/langprefs.c (_nl_language_preferences_default): Handle
	preferences elements of the form "ll-CC" in a reasonable way.
	* NEWS: Mention the change.

2018-09-16  Bruno Haible  <bruno@clisp.org>

	setlocale: Improve support for locales not supported by libc.
	Reported by Dapeng Gao <peter@dpgao.cc> at
	<https://savannah.gnu.org/bugs/?54479>.

	* gettext-runtime/intl/setlocale.c: Include <stdio.h>.
	(libintl_setlocale): Use a more error-tolerant strategy when the locale to be
	set is not supported by libc: Emit warnings instead of failing.

2018-09-16  Bruno Haible  <bruno@clisp.org>

	Fix link error when linking with libintl.a on macOS.
	* gettext-runtime/intl/loadmsgcat.c (_nl_msg_cat_cntr): Zero-initialize on
	macOS.

	doc: Assume texinfo 4.0 or newer.
	* gettext-tools/doc/gettext.texi: Omit Next, Prev, Up fields from @node lines.
	* gettext-runtime/libasprintf/autosprintf.texi: Likewise.

	Reduce "make dist" time by 7 minutes.
	* configure.ac (AM_INIT_AUTOMAKE): Remove dist-xz and dist-lzip options.
	* Admin/release-steps: Mention how to create the tarballs with higher
	compression after "make dist".

2018-09-15  Bruno Haible  <bruno@clisp.org>

	Add support for translation lookup with context in shell scripts.
	Reported by Markus Gothe <nietzsche@lysator.liu.se>
	in <https://savannah.gnu.org/bugs/?49899>.

	* gettext-runtime/src/gettext.c (long_options): Add option '--context'.
	(main): Handle option -c/--context.
	(usage): Document option -c/--context. Split usage message.
	* gettext-runtime/src/ngettext.c (long_options): Add option '--context'.
	(main): Handle option -c/--context.
	(usage): Document option -c/--context. Split usage message.
	* gettext-runtime/src/gettext.sh.in (eval_pgettext, eval_npgettext): New
	functions.
	* gettext-tools/src/xgettext.h (struct arglist_parser): Add 'next_is_msgctxt'
	field.
	(arglist_parser_remember_msgctxt): New declaration.
	* gettext-tools/src/xgettext.c (arglist_parser_alloc, arglist_parser_clone):
	Update accordingly.
	(arglist_parser_remember_msgctxt): New function.
	* gettext-tools/src/x-sh.c (init_keywords): Recognize also eval_pgettext and
	eval_npgettext.
	(init_flag_table_sh): Set flags for eval_pgettext, eval_npgettext.
	(substring_of_word): New function.
	(read_command): Recognize and handle -c/--context argument of 'gettext' and
	'ngettext'.
	* gettext-tools/tests/lang-sh: Add test of message lookup with context.
	* gettext-runtime/doc/rt-gettext.texi: Mention the --context option.
	* gettext-runtime/doc/rt-ngettext.texi: Likewise.
	* gettext-tools/doc/gettext.texi (sh, Preparing Shell Scripts, gettext.sh):
	Mention the new shell functions.
	(eval_pgettext Invocation, eval_npgettext Invocation): New subsubsections.
	* gettext-tools/doc/xgettext.texi: Mention the support for eval_pgettext,
	eval_npgettext.
	* NEWS: Mention the changes.

2018-08-12  Bruno Haible  <bruno@clisp.org>

	gettext-runtime/intl/setlocale.c: Add fixes from gnulib.
	2018-08-11  Bruno Haible  <bruno@clisp.org>

	        setlocale: Trivial simplification.
	        * lib/setlocale.c (setlocale_unixlike): Remove redundant #if.

	2017-04-21  Bruno Haible  <bruno@clisp.org>

	        Fix test-mbrtowc5.sh failure on native Windows.
	        * setlocale.c (setlocale_unixlike): Accept "POSIX" as an alias for
	        "C".

	2016-03-22  Geert Janssens  <janssens-geert@telenet.be>

	        setlocale: add "sv" to Windows language table
	        * setlocale.c (language_table) [W32]: Add "sv".
	        Reported in <https://savannah.gnu.org/bugs/?44588>.

	2012-01-04  Bruno Haible  <bruno@clisp.org>

	        Talk about "native Windows API", not "Win32".
	        * setlocale.c: Update comments to mention native Windows.

2018-07-25  Bruno Haible  <bruno@clisp.org>

	Upgrade to newer help2man.
	Reported by Bernhard M. Wiedemann in <https://savannah.gnu.org/bugs/?54367>.

	* gettext-runtime/man/help2man: Upgrade to version 1.47.6, with one change:
	  $source ||= "$program $version";
	  replaced by
	  $source ||= "$package $version";
	* gettext-tools/man/help2man: Likewise.

2018-07-25  Bruno Haible  <bruno@clisp.org>

	Make it possible to copy&paste strings from the HTML-formatted man pages.
	* gettext-runtime/man/Makefile.am (MAN2HTML_POSTPROCESS): New variable.
	(gt_man2html): Use it.
	* gettext-tools/man/Makefile.am (MAN2HTML_POSTPROCESS): New variable.
	(gt_man2html): Use it.

2018-07-03  Bruno Haible  <bruno@clisp.org>

	Enable the format_arg attribute also on clang on Mac OS X.
	Reported by Tom Tromey <tom@tromey.com>
	in <https://lists.gnu.org/archive/html/bug-gettext/2018-07/msg00000.html>.

	* gettext-runtime/intl/libgnuintl.in.h (_INTL_MAY_RETURN_STRING_ARG): On macOS,
	use attribute __format_arg__ if the compiler is based on clang >= 3.0.

2018-07-03  Bruno Haible  <bruno@clisp.org>

	Make the format_arg attribute effective also in the case _INTL_REDIRECT_INLINE.
	Reported by Tom Tromey <tom@tromey.com>
	in <https://lists.gnu.org/archive/html/bug-gettext/2018-07/msg00000.html>.

	* gettext-runtime/intl/libgnuintl.in.h (gettext, dgettext, dcgettext,
	ngettext, dngettext, dcngettext): Add attribute __format_arg__ also to the
	'static inline' functions.

2018-06-17  Bruno Haible  <bruno@clisp.org>

	Fix a NEWS entry.
	NEWS: Fix entry from 2016-07-01.

2018-05-14  Bruno Haible  <bruno@clisp.org>

	Update .gitignore.

2018-05-14  Bruno Haible  <bruno@clisp.org>

	xgettext: Improve support for specialized vector syntax in Scheme.
	Reported by Florent Angly <Florent.Angly@cslbehring.com>.

	* gettext-tools/src/x-scheme.c (read_object): Don't call free_token on an
	uninitialized token. Support recent syntax for homogeneous vector types (SRFI-4)
	and byte vectors as well.
	* NEWS: Mention the change.

2018-05-12  Bruno Haible  <bruno@clisp.org>

	libintl: Ensure the *printf function overrides are POSIX compatible.
	Reported by Eli Zaretskii <eliz@gnu.org>.

	* gettext-runtime/intl/printf.c (USE_REPLACEMENT_CODE_ALWAYS): New macro.
	(libintl_vfprintf, libintl_vsprintf, libintl_vsnprintf, libintl_vfwprintf,
	libintl_vswprintf): Use it.
	* NEWS: Mention the change.

2018-05-05  Bruno Haible  <bruno@clisp.org>

	all: Replace more http and ftp URLs by https URLs.
	* autogen.sh: Use https: URLs.
	* gettext-runtime/doc/nls.texi (Translating Teams, Available Packages): Likewise.
	* gettext-tools/doc/gettext.texi: Likewise.
	* gettext-tools/doc/FAQ.html: Likewise.
	* gettext-tools/doc/tutorial.html: Likewise.
	* gettext-tools/misc/gettextize.in: Likewise.
	* gettext-tools/projects/GNOME/team-address: Likewise.
	* gettext-tools/projects/GNOME/teams.url: Likewise.
	* gettext-tools/projects/KDE/team-address: Likewise.
	* gettext-tools/projects/KDE/teams.url: Likewise.
	* gettext-tools/projects/TP/teams.url: Likewise.
	* gettext-tools/src/x-python.c: Likewise.
	* gettext-tools/tests/xgettext-its-1: Likewise.

	all: Use https: URLs in --version output.
	* gettext-runtime/src/envsubst.c: Use https: URL in --version output.
	* gettext-runtime/src/gettext.c: Likewise.
	* gettext-runtime/src/gettext.sh.in: Likewise.
	* gettext-runtime/src/ngettext.c: Likewise.
	* gettext-tools/misc/autopoint.in: Likewise.
	* gettext-tools/misc/convert-archive.in: Likewise.
	* gettext-tools/misc/gettextize.in: Likewise.
	* gettext-tools/src/cldr-plurals.c: Likewise.
	* gettext-tools/src/hostname.c: Likewise.
	* gettext-tools/src/msgattrib.c: Likewise.
	* gettext-tools/src/msgcat.c: Likewise.
	* gettext-tools/src/msgcmp.c: Likewise.
	* gettext-tools/src/msgcomm.c: Likewise.
	* gettext-tools/src/msgconv.c: Likewise.
	* gettext-tools/src/msgen.c: Likewise.
	* gettext-tools/src/msgexec.c: Likewise.
	* gettext-tools/src/msgfilter.c: Likewise.
	* gettext-tools/src/msgfmt.c: Likewise.
	* gettext-tools/src/msggrep.c: Likewise.
	* gettext-tools/src/msginit.c: Likewise.
	* gettext-tools/src/msgmerge.c: Likewise.
	* gettext-tools/src/msgunfmt.c: Likewise.
	* gettext-tools/src/msguniq.c: Likewise.
	* gettext-tools/src/recode-sr-latin.c: Likewise.
	* gettext-tools/src/urlget.c: Likewise.
	* gettext-tools/src/xgettext.c: Likewise.
	* gettext-tools/tests/tstgettext.c: Likewise.
	* gettext-tools/tests/tstngettext.c: Likewise.
	* gnulib-local/build-aux/moopp: Likewise.

	all: Replace http URLs by https URLs in copyright notices.

	Simplify code. Drop support for Borland C++ on Windows.
	* gettext-runtime/intl/dcigettext.c: Simplify
	'defined _WIN32 || defined __WIN32__' to just 'defined _WIN32'.
	* gettext-runtime/intl/l10nflist.c: Likewise.
	* gettext-runtime/intl/langprefs.c: Likewise.
	* gettext-runtime/intl/libgnuintl.in.h: Likewise.
	* gettext-runtime/intl/loadinfo.h: Likewise.
	* gettext-runtime/intl/setlocale.c: Likewise.
	* gettext-runtime/intl/printf-parse.c: Likewise.
	* gettext-runtime/libasprintf/printf-parse.c: Likewise.
	* gettext-tools/src/format-c-parse.h: Likewise.
	* gettext-tools/src/hostname.c: Likewise.
	* gnulib-local/lib/basename.c: Likewise.

	Update after gnulib changed.
	* Makefile.am (distcheck-hook): Update comparison of flexmember.h.
	* gettext-runtime/intl/localcharset.c: Update from gnulib.
	* gettext-runtime/intl/localename.c: Likewise.
	* gettext-runtime/intl/lock.h: Likewise.
	* gettext-runtime/intl/relocatable.c: Likewise.
	* gettext-runtime/intl/vasnprintf.c: Likewise.
	* gettext-runtime/intl/verify.h: Likewise.
	* gettext-runtime/intl/xsize.h: Likewise.
	* gettext-runtime/libasprintf/vasnprintf.c: Likewise.
	* gettext-runtime/m4/*.m4: Likewise.
	* gettext-tools/examples/po/remove-potcdate.sin: Likewise.
	* gnulib-local/lib/execute.c.diff: Update.

	Update to newest gnulib.

2018-03-24  Bruno Haible  <bruno@clisp.org>

	Add support for recent Java versions.
	Reported by Emmanuel Bourg <ebourg@apache.org>
	at <https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=892733>
	via Santiago Vila.

	* gettext-runtime/configure.ac: Require a Java compiler that supports
	source-version 1.5 and target-version 1.6 (such as Java 6 or newer, or
	GCJ 4.3 or newer).
	* gettext-tools/src/write-java.c (msgdomain_write_java): Likewise
	* gettext-tools/examples/hello-java-qtjambi/configure.ac: Likewise.
	* gettext-tools/configure.ac: Require a Java compiler that supports
	source-version 1.5 (such as Java 5 or newer, or GCJ 4.3 or newer).
	* gettext-tools/examples/hello-java/configure.ac: Likewise.
	* gettext-tools/examples/hello-java-awt/configure.ac: Likewise.
	* gettext-tools/examples/hello-java-swing/configure.ac: Likewise.
	* NEWS: Mention the change.

2018-03-24  Bruno Haible  <bruno@clisp.org>

	Update README-alpha.
	* README-alpha: Don't suggest private email for bug reports about test releases.

	Comment.
	* .dir-locals.el: Add comment.

	Update after gnulib changed.
	* gnulib-local/lib/unistd.in.h.diff: Update.
	* gnulib-local/lib/regexec.c.diff: Remove file.
	* gnulib-local/Makefile.am (EXTRA_DIST): Remove it.

	Update to newest gnulib

	Update NEWS file.
	* NEWS: Add a missing entry (for a change from 2016-12-15).

2018-03-15  Bruno Haible  <bruno@clisp.org>

	doc: Fix statement about required Bison version.
	Reported by Amit Chaudhuri <amit.k.chaudhuri@gmail.com>.

	* HACKING: Required minimum Bison version is now 3.0, for cldr-plural.y.

2018-01-27  Bruno Haible  <bruno@clisp.org>

	Rename some files.
	* INSTALL.windows: Renamed from README.windows.
	* Makefile.am (EXTRA_DIST): Update.
	* gettext-runtime/INSTALL.windows: Renamed from gettext-runtime/README.windows.
	* gettext-runtime/Makefile.am (EXTRA_DIST): Update.
	* gettext-runtime/intl/INSTALL.windows: Renamed from gettext-runtime/intl/README.windows.
	* gettext-runtime/intl/Makefile.in (DISTFILES.gettext): Update.
	* gettext-runtime/libasprintf/INSTALL.windows: Renamed from gettext-runtime/libasprintf/README.windows.
	* gettext-runtime/libasprintf/Makefile.am (EXTRA_DIST): Update.
	* gettext-tools/INSTALL.windows: Renamed from gettext-tools/README.windows.
	* gettext-tools/Makefile.am (EXTRA_DIST): Update.

	xgettext: Support '_' in number tokens in C++.
	* gettext-tools/src/x-c.c (phase5_get): Recognize '_' in C++.
	* NEWS: Update.

2018-01-07  Bruno Haible  <bruno@clisp.org>

	xgettext: Support 'p'/'P' exponent markers in number tokens also in C.
	* gettext-tools/src/x-c.c (phase5_get): Recognize sign after 'p' or 'P' also
	in C.
	* NEWS: Update.

2018-01-07  Bruno Haible  <bruno@clisp.org>

	Avoid a test failure of lang-gawk.
	It's a bug in gawk 4.2.0, reported at
	https://lists.gnu.org/archive/html/bug-gawk/2018-01/msg00026.html .

	* gettext-tools/tests/lang-gawk: Skip the test if gawk's version is 4.2.0.

2018-01-06  Bruno Haible  <bruno@clisp.org>

	Add support for new C++ preprocessing number tokens.
	Reported by Moritz Bunkus <moritz@bunkus.org>
	at <https://savannah.gnu.org/bugs/?50117>.

	* gettext-tools/src/x-c.c (phase5_get): Recognize C++14 and C++17 extensions of
	preprocessing number tokens.
	* gettext-tools/tests/xgettext-c-22: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.
	* NEWS: Mention the change.

2018-01-06  Bruno Haible  <bruno@clisp.org>

	Comment fix.
	* gettext-tools/tests/xgettext-c-20: Fix typo in comment.

	doc: Document the data formats supported by the tools in a central place.
	* gettext-tools/doc/gettext.texi (Data Formats): New chapter.
	(Internationalizable Data): Moved here from chapter "Programming Languages".

	Avoid a test failure of lang-csharp on Mac OS X.
	* gettext-tools/tests/lang-csharp: Don't test in $LOCALE_FR on Mac OS X.

	xgettext: Add support for .properties files in UTF-8 encoding.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC): Add read-file, unistr/u8-check.
	* gettext-tools/src/read-properties: Read the file into memory, then find out
	about its encoding, then start parsing it.
	* gettext-tools/tests/xgettext-properties-2: New file.
	* gettext-tools/tests/xgettext-properties-3: New file.
	* gettext-tools/tests/xgettext-properties-4: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add them.
	* NEWS: Mention the change.

2018-01-05  Bruno Haible  <bruno@clisp.org>

	Add support for .rsj files.
	* gettext-tools/src/x-rst.h (EXTENSIONS_RST, SCANNERS_RST): Add RSJ scanner.
	(extract_rsj): New declaration.
	* gettext-tools/src/x-rst.c: Implement extraction from .rsj files.
	* gettext-tools/src/xgettext.c (usage): Mention RSJ along with RST.
	* gettext-tools/tests/xgettext-rst-1: New file.
	* gettext-tools/tests/xgettext-rst-2: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add them.
	* gettext-tools/tests/lang-pascal: Extract from .rsj file, if the compiler
	generated it.
	* gettext-tools/doc/gettext.texi (RST): Mention that .rsj files are supported
	as well.
	* gettext-tools/doc/xgettext.texi (Choice of input file language): Mention RSJ
	along with RST.
	* NEWS: Mention the change.

2018-01-05  Bruno Haible  <bruno@clisp.org>

	Fix failure of lang-javascript on Ubuntu 16.04.
	pkg-config almost never works. It is best to never use it.

	* gettext-tools/tests/lang-javascript: Don't use pkg-config to test whether
	the installed gjs is appropriate.

2018-01-05  Bruno Haible  <bruno@clisp.org>

	Fix a comment.
	* gettext-tools/src/x-stringtable.h: Fix typo in comment.

2018-01-04  Bruno Haible  <bruno@clisp.org>

	doc: More information for maintainers.
	* HACKING: New section 'Additional requirements for maintainers'.

2018-01-04  Bruno Haible  <bruno@clisp.org>

	Use locales with the customary names.
	On glibc systems, nowadays, the German and French locales are named
	'de_DE.UTF-8' and 'fr_FR.UTF-8', respectively. This change avoids the need
	to install similar locales with different names.

	* gettext-tools/tests/gettext-3: Use locales with '.UTF-8' suffix.
	* gettext-tools/tests/gettext-3-prg.c (lang): Likewise.

2018-01-04  Bruno Haible  <bruno@clisp.org>

	doc: Add information about lua-gettext package.
	* gettext-tools/doc/gettext.texi (Lua): Describe from where to get the
	lua-gettext package.

	doc: Add information about Ubuntu packages.
	* gettext-tools/doc/gettext.texi (List of Programming Languages): Add a
	subsection 'Ubuntu packages' for each.

2018-01-03  Bruno Haible  <bruno@clisp.org>

	Fix msgunfmt-3 failure (regression from 2017-09-24).
	* gettext-tools/tests/Makefile.am (EXTRA_DIST): Add sysdep-without-nul.mo.

	Update dependencies list.
	* HACKING: Add Lzip (needed for "make dist" since 2014-12-24).

2018-01-03  Bruno Haible  <bruno@clisp.org>

	Fix "make dist" of modified git checkouts.
	This fixes error messages such as
	tar: gettext-0.19.8.1.74-72e49-dirty/gettext-tools/gnulib-tests/test-term-ostream-xterm-linux-mandriva.out: file name is too long (max 99); not dumped
	tar: gettext-0.19.8.1.74-72e49-dirty/gettext-runtime/intl-csharp/doc/GNU_Gettext_GettextResourceManager.html: file name is too long (max 99); not dumped

	* configure.ac: Pass option 'tar-ustar' to AM_INIT_AUTOMAKE.
	(am__tar): Use 'tar' option --format=ustar.

2018-01-02  Bruno Haible  <bruno@clisp.org>

	Clarify required bison version.
	Reported by Roger Mc Murtrie <rogermc@grapevine.com.au>
	at <https://savannah.gnu.org/bugs/?47484>.

	* HACKING: Mention minimum version of bison.

2018-01-02  Bruno Haible  <bruno@clisp.org>

	Avoid build failures caused by parallel make.
	Reported by Andrew Stormont <andyjstormont@gmail.com>
	at <https://savannah.gnu.org/bugs/?48412>.

	* gettext-tools/doc/Makefile.am (GNUMAKEFLAGS): New variable.
	* gettext-tools/src/Makefile.am (cldr-plural.h): Add dependency.

2018-01-02  Bruno Haible  <bruno@clisp.org>

	Fix 'ar' invocation when cross-compiling and in 64-bit mode on AIX.
	Reported by Benedikt Morbach <bmorbach@redhat.com>
	at <https://savannah.gnu.org/bugs/?43037>.

	* gettext-runtime/m4/intl.m4 (AM_INTL_SUBDIR): Require gl_PROG_AR_RANLIB if
	available. Otherwise, use AC_PROG_RANLIB and set AR and ARFLAGS.
	* gettext-runtime/intl/Makefile.in (AR): Use the value determined through
	autoconf.
	(ARFLAGS): New variable.
	(libintl.a, libgnuintl.a): Use it.
	* gettext-runtime/configure.ac: Invoke gl_PROG_AR_RANLIB.
	* gettext-runtime/libasprintf/configure.ac: Likewise.
	* gettext-tools/configure.ac: Likewise.

2018-01-02  Bruno Haible  <bruno@clisp.org>

	Don't use -lc explicitly when linking with libtool.
	libtool has logic that determines whether it should add -lc, and this logic
	works fine on all modern platforms.

	Reported by Michael Forney <mforney@mforney.org>
	at <https://savannah.gnu.org/bugs/?40192>.

	* gettext-runtime/m4/intl.m4 (AM_INTL_SUBDIR): Don't set LTLIBC.
	* gettext-runtime/intl/Makefile.in (libintl.la, libgnuintl.la): Don't use
	LTLIBC.

2017-10-15  Bruno Haible  <bruno@clisp.org>

